@echo off

if %1test==helptest goto errormsg

if %1test==test goto setenv

if NOT %1test==test cd %1

pwd

set CONNECTION_TYPE="DIRECT"

If NOT %2test==test set SERVER_NAME=%2

If NOT %3test==test set PORT=%3

if NOT %4test==test set BROWSER=%4

if NOT %5test==test set BROWSERVERSION=%5

if NOT %6test==test set REGRESSIONID=%6

if NOT %7test==test set TEST_TYPE=%7

if NOT %8test==test set CONNECTION_TYPE=%8

if NOT %9test==test set PROXY_HOST=%9

if NOT %10test==test set PROXY_PORT=%10

if NOT %11test==test set USERNAME=%11

if NOT %12test==test set PASSWORD=%12

goto browcheck

:setenv
call setEnv.bat

:browcheck
if "%BROWSER%"=="IE" goto IE
	
if "%BROWSER%"=="ie" goto IE
	
if "%BROWSER%"=="Mozilla" goto MOZILLA
	
if "%BROWSER%"=="mozilla" goto MOZILLA

if "%BROWSER%"=="MOZILLA" goto MOZILLA

if "%BROWSER%"=="Firefox" goto FIREFOX
	
if "%BROWSER%"=="FireFox" goto FIREFOX

if "%BROWSER%"=="firefox" goto FIREFOX

if "%BROWSER%"=="FIREFOX" goto FIREFOX


echo "Configured browser %BROWSER% not supported . Supported Browsers are IE, Mozilla and Firefox"

goto end

:IE
 WebTestRunner.exe SERVER_HOST %SERVER_NAME% SERVER_PORT %PORT% CONNECTION_TYPE %CONNECTION_TYPE% PROXY_HOST %PROXY_HOST% PROXY_PORT %PROXY_PORT% USERNAME %USERNAME% PASSWORD %PASSWORD% REGRESSION_ID %REGRESSIONID% TEST_TYPE %TEST_TYPE%
goto end


:MOZILLA
set QE_FILE="qe_moz_%BROWSERVERSION%.bat"
set executebrowser=mozilla
goto MOZEXE

:FIREFOX
set QE_FILE="qe_ff_%BROWSERVERSION%.bat"
set executebrowser=firefox
goto MOZEXE

:MOZEXE
if NOT EXIST c:\qenginecmd\%QE_FILE% goto QEFILENOTEXIST
call c:\qenginecmd\%QE_FILE%
if "%PROFILENAME%test" == "test" echo "Please configure the profile name (default or user-defined) set in the browser."
cd /d %mozilla_path%
set XPCOM_CHECK_THREADSAFE=0
set COMMAND_LINE_EXECUTION=true
set SERVER_NAME=%SERVER_NAME%
set PORT=%PORT%
set CONNECTION_TYPE=%CONNECTION_TYPE%
set PROXY_HOST=%PROXY_HOST%
set PROXY_PORT=%PROXY_PORT%
set USERNAME=%USERNAME%
set PASSWORD=%PASSWORD%
set REGRESSIONID=%REGRESSIONID%
set TEST_TYPE=%TEST_TYPE%
set BROWSER=%browser%
set BROWSERVERSION=%BROWSERVERSION%

call %executebrowser% -P %PROFILENAME% about:blank
goto end

:errormsg
echo For execution Usage: CommandLineWebTest.bat . SERVER_NAME SERVER_PORT BROWSER BROWSER_VERSION REGRESSION_ID TEST_TYPE [CONNECTION_TYPE PROXY_HOST PROXY_PORT PROXY_USERNAME PROXY_PASSWORD]
echo CONNECTION_TYPE and PROXY Properties needed only if the server and client are proxy/firewall protected
	
goto end

:QEFILENOTEXIST
echo "C:\qenginecmd\%QE_FILE% is not found"
echo "Please connect the server with %BROWSER% %BROWSERVERSION% browser using  QEngine toolbar once and then execute Command Line "

:end
cd %1
