


export SUITENAME=$1
export TESTCASENAME=$2
export REPORTSDIR=$4
export DB_NAME=$3
export SESSIONID=$5
export HISTORYDIR=$6
export USER_NAME=$7

if [ "test"$SUITENAME == "test" ]
then
	echo "Usage: GenerateWPReports.bat <SUITENAME> <LOADTESTNAME>"
	exit
fi

if [ "test"$TESTCASENAME == "test" ]
then
	echo "Usage: GenerateWPReports.bat <SUITENAME> <LOADTESTNAME>"
	exit
fi

if [ "test"$DB_NAME == "test" ]
then
	export DB_NAME="LATEST"
fi

if [ "test"$SESSIONID == "test" ]
then
	export DB_NAME="runtimesession"
fi

if [ "test"$REPORTSDIR == "test" ]
then
	export REPORTSDIR="LATEST"
fi

if [ "test"$HISTORYDIR == "test" ]
then
	export HISTORYDIR="LATEST"
fi

if [ "test"$USER_NAME== "test" ]
then
	export USER_NAME="QENGINE"
fi

. bin/setCommonEnv.sh

# reinitialize code removed after 6.1.0

PATH=$PATH:.

export PATH

JAVA="$JAVA_HOME/bin/java"

export JAVA

COMMON_OPTS="-Dcatalina.home=$SERVER_HOME -Dserver.home=$SERVER_HOME -Dserver.stats=10000  -Djava.util.logging.manager=com.adventnet.logging.LogManager -Djava.util.logging.config.file=$SERVER_HOME/conf/logging.xml -Djava.util.logging.config.class=com.adventnet.logging.LoggingScanner -Dlog.dir=$SERVER_HOME -Ddb.home=$DB_HOME -Djava.library.path=$SERVER_HOME/lib/native -Dcheck.tomcatport=true"

echo $COMMON_OPTS

export COMMON_OPTS

QE_OPTS="-Dpy.path=$SERVER_HOME/jars/ -Dmysql.home=$DB_HOME"

export QE_OPTS

JAVA_OPTS="$COMMON_OPTS $QE_OPTS"

export JAVA_OPTS
QE_CLASSPATH=$SERVER_HOME/jars:$DB_CLASSPATH:$FWK_CLASSPATH:$WF_CLASSPATH:$WP_CLASSPATH:$WS_CLASSPATH

export QE_CLASSPATH

CLASS_PATH=$QE_CLASSPATH:$SERVER_HOME/bin/run.jar:$SERVER_HOME/jars/jdt-compiler.jar:$SERVER_HOME/jars/poi-3.0.1-FINAL-20070705.jar:$SERVER_HOME/lib/AdvCoreLogging.jar:$SERVER_HOME/lib/AdventNetNPrevalent.jar:$SERVER_HOME/lib/tomcat/servlet-api.jar:$SSH_CLASSPATH

export CLASS_PATH

$JAVA $JAVA_OPTS -Dfile.encoding=UTF-8 -Xms250m -Xmx750m -Dtest.dir=$SERVER_HOME -Dpython.path=$PY_PATH -Duser.language=en -Dwsp.threadcount=$WSP_THREADCOUNT -cp $CLASS_PATH com.adventnet.qengine.load.report.WebLoadReportGenerator SUITENAME $SUITENAME TESTCASENAME $TESTCASENAME DB_NAME $DB_NAME SESSION $SESSIONID HISTORYDIR $HISTORYDIR REPORTSDIR $REPORTSDIR USERNAME $USER_NAME

export PATH=$PATH

