@echo off

rem This script file is used to start the QEngine Web Performance Distributed Agents

rem echo Usage: StartDistributedAgent.bat [port]

cd ..

if NOT EXIST bin\setCommonEnv.bat goto setcommonenv

call .\bin\setCommonEnv.bat

set RMIPORT="-Drmi.registery.port=%RMI_PORT%"
set RMIHOST="-Djava.rmi.server.hostname=%RMI_HOSTNAME%"

if "%RMI_PORT%"=="" (set RMIPORT=)
if "%RMI_HOSTNAME%"=="" (set RMIHOST=)

set PATH=%PATH%;%SERVER_HOME%\lib\native\

set QE_CLASSPATH=%SERVER_HOME%\jars;%DB_CLASSPATH%;%FWK_CLASSPATH%;%WP_CLASSPATH%;%WS_CLASSPATH%;%SERVER_HOME%\jars\tools.jar;

set CLASSPATH=%QE_CLASSPATH%;%WEBSERVER_CLASSPATH%;%SERVER_HOME%\lib;%SERVER_HOME%\lib\AdvCoreLogging.jar;%SERVER_HOME%\bin\run.jar;%SERVER_HOME%\lib\commons-logging-api.jar;%SERVER_HOME%\lib\AdventNetNPrevalent.jar;

%JAVA% -Xmx200m -Dtest.dir=. -Dmysql.home=%DB_HOME% -Djava.library.path=%SERVER_HOME%\lib\native\ -Djava.security.manager -Djava.security.policy="conf\policy" %RMIPORT% %RMIHOST% com.adventnet.qengine.agent.server.RemoteServer %1

goto end

:setcommonenv

echo "setCommonEnv.bat is not found"

goto end

:end

cd bin
