@echo off

rem $Id: StartWebTestServer.bat,v 1.29.4.4 2010/06/04 08:25:33 yamini Exp $
cd ..


if %1test == nobrowsertest (set LAUNCH_BROWSER_NEEDED=no) ELSE (set LAUNCH_BROWSER_NEEDED=yes)




cd bin
cscript //nologo StartService.vbs

set exit_code=%errorlevel%

if [%exit_code%]==[10] goto END_NO_PAUSE
cd ..



call .\bin\setCommonEnv.bat

set OLD_PATH=%PATH%

set PATH=%PATH%;"%SERVER_HOME%\lib\native"

SET JAVA=%JAVA_HOME%\bin\java

SET JAVAW=%JAVA_HOME%\bin\javaw

set COMMON_OPTS= -Dcatalina.home="%SERVER_HOME%" -Dserver.home="%SERVER_HOME%" -Dpython.path=%PY_PATH% -Dserver.stats=10000  -Djava.util.logging.manager=com.adventnet.logging.LogManager -Djava.util.logging.config.file="%SERVER_HOME%\conf\logging.xml" -Djava.util.logging.config.class=com.adventnet.logging.LoggingScanner -Dlog.dir="%SERVER_HOME%" -Ddb.home="%DB_HOME%" -Djava.library.path="%SERVER_HOME%\lib\native" -Dcheck.tomcatport="true"

set QE_OPTS= -Dpy.path="%PY_PATH%"  -Dmysql.home="%DB_HOME%"

set JAVA_OPTS=%COMMON_OPTS% %QE_OPTS%

set QE_CLASSPATH=%SERVER_HOME%\jars;%FWK_CLASSPATH%;%WF_CLASSPATH%;%WP_CLASSPATH%;%WS_CLASSPATH%;%DB_CLASSPATH%

set CLASS_PATH=%QE_CLASSPATH%;%SERVER_HOME%\bin\run.jar;%SERVER_HOME%\jars\poi-3.0.1-FINAL-20070705.jar;%SERVER_HOME%\jars\jdt-compiler.jar;%SERVER_HOME%\lib\AdvCoreLogging.jar;%SERVER_HOME%\lib\AdventNetNPrevalent.jar;%SERVER_HOME%\lib\tomcat\servlet-api.jar;C:\PROGRA~1\Java\jdk1.5.0_10\lib\tools.jar;%SSH_CLASSPATH%

echo ===============================================================================
echo .
echo .
echo   SERVER_HOME: %SERVER_HOME%
echo .
echo   JAVA: %JAVA%
echo .
echo   JAVA_OPTS: %JAVA_OPTS%
echo .
echo .
echo ===============================================================================
echo .

%JAVA% %JAVA_OPTS% -cp "%CLASS_PATH%" com.adventnet.mfw.util.JdkAndPortCheck

%JAVA% %JAVA_OPTS% -Dmainserver.port="%SERVER_PORT%" -Duser.language=en -Dwebserver.port="%WEBSERVER_PORT%" -Dtest.dir="%SERVER_HOME%" -cp "%CLASS_PATH%" com.adventnet.testtools.server.util.QEngineEnvironmentChecker

if %errorlevel% NEQ 0 goto END

start /B %JAVAW% %JAVA_OPTS% -Dmainserver.port="%SERVER_PORT%" -Duser.language=en -Dwebserver.port="%WEBSERVER_PORT%" -Dtest.dir="%SERVER_HOME%" -Dnobrowser="%LAUNCH_BROWSER_NEEDED%" -cp "%CLASS_PATH%" com.adventnet.qengine.server.startup.util.StartProgressUtil

:RESTART 									
start /B %JAVAW% %JAVA_OPTS% -Dsplash.filename=./images/aboutus.gif -Dfile.encoding=UTF-8 -Xms250m -Xmx500m -Dtest.dir="%SERVER_HOME%" -Dnobrowser="%LAUNCH_BROWSER_NEEDED%" -Dwsp.threadcount="%WSP_THREADCOUNT%" -Duser.language=en -cp "%CLASS_PATH%" com.adventnet.mfw.Starter

IF ERRORLEVEL 0 IF NOT ERRORLEVEL 1 GOTO END_NO_PAUSE
IF ERRORLEVEL 10 GOTO RESTART

:END
goto end
if "%NOPAUSE%" == "" pause

:END_NO_PAUSE

set PATH=%OLD_PATH%
