cd ..

. bin/setCommonEnv.sh

# reinitialize code removed after 6.1.0

PATH=$PATH:.

export PATH

JAVA="$JAVA_HOME/bin/java"

export JAVA

COMMON_OPTS="-Dcatalina.home=$SERVER_HOME -Dserver.home=$SERVER_HOME -Dserver.stats=10000  -Djava.util.logging.manager=com.adventnet.logging.LogManager -Djava.util.logging.config.file=$SERVER_HOME/conf/logging.xml -Djava.util.logging.config.class=com.adventnet.logging.LoggingScanner -Dlog.dir=$SERVER_HOME -Ddb.home=$DB_HOME -Djava.library.path=$SERVER_HOME/lib/native -Dcheck.tomcatport=true"

echo $COMMON_OPTS

export COMMON_OPTS

QE_OPTS="-Dpy.path=$PY_PATH -Dmysql.home=$DB_HOME"

export QE_OPTS

JAVA_OPTS="$COMMON_OPTS $QE_OPTS"

export JAVA_OPTS
QE_CLASSPATH=$SERVER_HOME/jars:$DB_CLASSPATH:$FWK_CLASSPATH:$WF_CLASSPATH:$WP_CLASSPATH:$WS_CLASSPATH

export QE_CLASSPATH

CLASS_PATH=$QE_CLASSPATH:$SERVER_HOME/bin/run.jar:$SERVER_HOME/jars/jdt-compiler.jar:$SERVER_HOME/jars/poi-3.0.1-FINAL-20070705.jar:$SERVER_HOME/lib/AdvCoreLogging.jar:$SERVER_HOME/lib/AdventNetNPrevalent.jar:$SERVER_HOME/lib/tomcat/servlet-api.jar:$SSH_CLASSPATH

export CLASS_PATH

echo ===============================================================================
echo .
echo .
echo   SERVER_HOME: $SERVER_HOME
echo .
echo   JAVA: $JAVA
echo .
echo   JAVA_OPTS: $JAVA_OPTS
echo .
echo .
echo   CLASS_PATH: $CLASS_PATH
echo .
echo .
echo ===============================================================================
echo .

$JAVA $JAVA_OPTS -cp $CLASS_PATH com.adventnet.mfw.util.JdkAndPortCheck

$JAVA $JAVA_OPTS -Dmainserver.port=$SERVER_PORT -Dwebserver.port=$WEBSERVER_PORT -Dtest.dir=$SERVER_HOME -cp $CLASS_PATH com.adventnet.testtools.server.util.QEngineEnvironmentChecker

if [ $? != 0 ]
then
	exit
fi

echo ######################################################

$JAVA $JAVA_OPTS -Dsplash.filename=./images/aboutus.gif -Dfile.encoding=UTF-8 -Xms250m -Xmx500m -Dtest.dir=$SERVER_HOME -Dpython.path=$PY_PATH -Duser.language=en -Dwsp.threadcount=$WSP_THREADCOUNT -cp $CLASS_PATH com.adventnet.mfw.Starter

export PATH=$PATH
