/* $Id: commoneditor.js,v 1.4.4.4 2009/10/30 05:43:36 srinivasar Exp $*/
var tempScriptContOrig = '', isEnc = false;

function inAr(oStr) {
	var opAr = new Array('+','-','*','%','=','+=','-=','&gt;','&lt;','&gt;=','&lt;=','++','--','==','!=','&lt;&lt;','&gt;&gt;','&amp;nbsp;','&amp;','|','^','~','!','&amp;&amp;','||','?',':');
	for( var x = 0; x < opAr.length; x++ )
	{
		if( oStr.substr(0,opAr[x].length) == opAr[x] )
		{
		 return opAr[x];
		}
	 }
	return false;
}

function getNodeForText(text)
{
	text = "<div>"+text+"<\/div>";
	var parser = new DOMParser();
	var doc = parser.parseFromString(text, "text/xml");

	brNode = document.createElement("br");
	node = doc.documentElement;
	node.appendChild(brNode);

	return node;
}


function printscript(scriptContent)
{
	try
	{
		sWindow=window.open("",'Print','scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes');
		var str="<html><head><script type='text/javascript'>	function printPage()  {  window.print();  }</script></head><body onload='printPage()'>" +scriptContent+"</body></html>";
		sWindow.document.write(str);
		sWindow.document.close();
		sWindow.focus();
	}
	catch(e)
	{
		alert(e);
	}
	return;

}
function removeAutoComments(scriptContent) 
{
	var scriptLines;
	if(scriptContent.indexOf("<p>")>0)
	{
		scriptLines = scriptContent.split("<p>");
	}
	if(scriptContent.indexOf("<br>")>0)
	{
		scriptLines = scriptContent.split("<br>");	
	}
	var con="";
	for(var l = 0;l<scriptLines.length;l++)
	{
		//	alert(scriptLines[l]);
		tempScriptCont = scriptLines[l];
		if(scriptLines[l].substring(0,2)=="#@")
		{
		}
		else
		{
			if(scriptLines[l].indexOf("</p>")<0)
			{
				con = con + scriptLines[l] +"<br>";
			}
			else
			{
				con= con + "<p>"+scriptLines[l];
			}
		}
	}
	return con;
}

function ordinaryCodeScript(scriptContent,mode) {
	//testRegEx();
	var tempScriptCont = scriptContent, newVal = ''; tempScriptContOrig = scriptContent;
	var headers = '<'+'!DOCTYPE HTML PUBLIC "-\/\/W3C\/\/DTD HTML 4.01\/\/EN" "http:\/\/www.w3.org\/TR\/html4\/strict.dtd">'+
	'<html><head><title>QEngine Web Test Studio : Script Editor<\/title>\n'+
	'<!'+'-- copy from here if you want to paste this into a HTML document --'+'>\n'+
	'<style type="text/css">\n<!'+'--\nbody { background-color: #ffffff; color: #000000; }\n'+
	'pre { font-family: "Courier New",Courier,monospace; font-size: 12px; color: #000000; }\n'+
	'span.comment { color: #008080; font-weight: normal; }\n'+
	'span.oper { color: #0000f0; font-weight: normal; }\n'+
	'span.var { color: #d56000; font-weight: normal; }\n'+
	'span.func { color: #099800; font-weight: normal; }\n'+
	'span.color_magenta { color: #ff00ff; font-weight: normal; }\n'+
	'span.color_brown { color: #cd6839; font-weight: normal; }\n'+
	'span.color_dgreen { color: #006700; font-weight: normal; }\n'+
	'span.color_violet { color: #9e2ce2; font-weight: normal; }\n'+
	'span.color_red { color: #e10000; font-weight: normal; }\n'+
	'span.color_lgreen { color: #009900; font-weight: normal; }\n'+
	'span.color_lblue { color: #0A5ECD; font-weight: normal; }\n'+
	'span.color_pgreen { color: #666600; font-weight: normal; }\n'+
	'span.color_bgreen { color: #006699; font-weight: normal;}\n'+
	'span.string { color: #0000FF; font-weight: normal; }\n'+
	'span.num { color: #000000; font-weight: normal; }\n'+
	'span.reg { color: #8d7f07; font-weight: normal; }\n'+
	'--'+'>\n<\/style><\/head><body>\n<pre>';
	var footers = '<\/pre>\n<!'+'-- stop copying here--'+'>\n<\/body><\/html>';

	if(scriptContent != "")
	{
			newVal="<pre>";
			scriptContent = headers+""+tempScriptContOrig+""+footers;

	}
	return scriptContent;
}

function replaceAll(str,pattern,replaceStr)
{
	while(str.indexOf(pattern)>=0)
	{
		str = str.replace(pattern,replaceStr);
	}
	return str;
}

function colorCodeScript(scriptContent,mode) {
	//testRegEx();
	var tempScriptCont = scriptContent, newVal = ''; tempScriptContOrig = scriptContent;
	var headers = '<'+'!DOCTYPE HTML PUBLIC "-\/\/W3C\/\/DTD HTML 4.01\/\/EN" "http:\/\/www.w3.org\/TR\/html4\/strict.dtd">'+
	'<html><head><title>QEngine Web Test Studio : Script Editor<\/title>\n'+
	'<!'+'-- copy from here if you want to paste this into a HTML document --'+'>\n'+
	'<style type="text/css">\n<!'+'--\nbody { background-color: #ffffff; color: #000000; }\n'+
	'pre { font-family: "Verdena","Courier New",Courier,monospace; font-size: 12px; color: #000000; }\n'+
	'span.comment { color: #008080; font-weight: normal; }\n'+
	'span.oper { color: #0000f0; font-weight: normal; }\n'+
	'span.var { color: #d56000; font-weight: normal; }\n'+
	'span.func { color: #099800; font-weight: normal; }\n'+
	'span.color_magenta { color: #ff00ff; font-weight: normal; }\n'+
	'span.color_brown { color: #cd6839; font-weight: normal; }\n'+
	'span.color_dgreen { color: #006700; font-weight: normal; }\n'+
	'span.color_violet { color: #9e2ce2; font-weight: normal; }\n'+
	'span.color_red { color: #e10000; font-weight: normal; }\n'+
	'span.color_lgreen { color: #009900; font-weight: normal; }\n'+
	'span.color_lblue { color: #0A5ECD; font-weight: normal; }\n'+
	'span.color_pgreen { color: #666600; font-weight: normal; }\n'+
	'span.color_bgreen { color: #006699; font-weight: normal;}\n'+
	'span.string { color: #0000FF; font-weight: normal; }\n'+
	'span.num { color: #000000; font-weight: normal; }\n'+
	'span.reg { color: #8d7f07; font-weight: normal; }\n'+
	'--'+'>\n<\/style><\/head><body>\n<pre>';
	var footers = '<\/pre>\n<!'+'-- stop copying here--'+'>\n<\/body><\/html>';
	var oAmp = 'a', oRand = new Array('b','c'); //start conversion to HTML entities
	var vowel = new Array('e','i','o','u','A','E','I','O','U');
	
	if(scriptContent == "")
	{
		if(mode != "insert")
		{
			newVal="<pre>";
			scriptContent = headers+newVal+footers;
		}
		alert(scriptContent);
		return scriptContent;
	}


	if(tempScriptCont.indexOf(oAmp) != -1)
	{
		while( tempScriptCont.indexOf(oAmp) + 1 )
		{
			oAmp += oRand[Math.round(Math.random())];
		}
	}
	else
	{
		for(var x = 0; x < vowel.length; x++)
		{
			if(tempScriptCont.indexOf(vowel[x]) != -1)
			{
				oAmp = vowel[x];
				while( tempScriptCont.indexOf(oAmp) + 1 )
				{
					oAmp += oRand[Math.round(Math.random())];
				}
				break;
			}
		}
	}

	var fromAr = new Array('&',oAmp,'<','>','"'), toAr = new Array(oAmp,'&amp;','&lt;','&gt;','&quot;');
	for( var x = 0; x < fromAr.length; x++ )
	{
		 while(tempScriptCont.indexOf(fromAr[x])+1)
		{
			tempScriptCont = tempScriptCont.replace(fromAr[x],toAr[x]);
		}
	 }

	var brUsing =false;
	scriptLines = tempScriptCont.split("&lt;p&gt;");
	if(tempScriptCont.indexOf("&lt;p&gt;")<0)
	{
		if(tempScriptCont.indexOf("&lt;br&gt")>0)
		{
			brUsing= true;
			scriptLines = tempScriptCont.split("&lt;br&gt;");
		}
	}
	scriptContent = 'Please wait. . . Your script is getting loaded . . .'; //start full conversion
for(var l = 0;l<scriptLines.length;l++)
{
	//	alert(scriptLines[l]);
	tempScriptCont = scriptLines[l];
	var test = tempScriptCont.replace(/^\s+|\s+$/, '');
	if(brUsing)
	{
		tempScriptCont = tempScriptCont +"&lt;br&gt;";
	}
	if(test.substr(0,1)=='@@@@@@@@@@@@@@@@@@@@@@22')
	{

		tempScriptCont = replaceAll(tempScriptCont,'&lt;p&gt;','<p>');	
		tempScriptCont = replaceAll(tempScriptCont,'&lt;br&gt;','<br>');	
		tempScriptCont = replaceAll(tempScriptCont,'&lt;br/&gt;','<br/>');	
		tempScriptCont = replaceAll(tempScriptCont,'&amp;Empty','<p>\n</p>');	
		tempScriptCont = replaceAll(tempScriptCont,'&amp;TAB','\t');	
		tempScriptCont = replaceAll(tempScriptCont,'&amp;nbsp;','&nbsp');	
		tempScriptCont = replaceAll(tempScriptCont,'&lt;/p&gt;','</p>');	
		tempScriptCont = replaceAll(tempScriptCont,'&amp;nbsp;','&nbsp');	
		tempScriptCont= tempScriptCont.replace(/^\s+|\s+$/, '');
		//alert("-->"+tempScriptCont+"<---");
		if(brUsing)
		{
			newVal += ''+tempScriptCont+'';
		}
		else
		{
			if(tempScriptCont.indexOf('<\/p>')>-1)
			{
				newVal += '<p>'+tempScriptCont+'';
			}
			else
			{

				newVal += ''+tempScriptCont+'';
			}
		}
		alert(newVal);
	}
	else
	{
		if(!brUsing)
		{
			if(tempScriptCont.indexOf('&lt;\/p&gt;')>-1)
			{
				tempScriptCont = '&lt;p&gt;'+tempScriptCont;
			}
			else
			{
				tempScriptCont = tempScriptCont;

			}
		}
		else
		{
				tempScriptCont = tempScriptCont;

		}

		for( var x = 0; x < tempScriptCont.length; x++ )
		{
			if( tempScriptCont.substr(x,1).replace(/[\w\+\-\*\/%=&\!\|\^~\'\"\?:]/,'') )
			{
				newVal += tempScriptCont.substr(x,1);
			}
			else
			{
				//This must be highlighted in some way
				if( !tempScriptCont.substr(x,1).replace(/[a-zA-Z_]/,'') )
				{
					//variable or function or keyword or true/false/null
					var tempKey = tempScriptCont.substr(x).replace(/\W[\w\W]*/,'');
					x += tempKey.length - 1; //the word is isolated and its length added
					if( tempScriptCont.substr(x).replace(/\w*\s*/,'').substr(0,1) == '(' )
					{
						//function/method or 'if' or 'for' or 'while' etc.
						if( tempKey == 'for' || tempKey == 'if' || tempKey == 'while' || tempKey == 'switch' || tempKey == 'with' || tempKey == 'typeof' || tempKey == 'void' || tempKey == 'return' || tempKey == 'function' )
						{
							newVal += '<span class="oper">'+tempKey+'<\/span>';
						}
						else
						{
							var col=getColorForFunction(tempKey);
							//newVal += '<span class="func">'+tempKey+'<\/span>';
							newVal += '<span class="'+col+'">'+tempKey+'<\/span>';
						}
					}
					else if( tempScriptCont.substr(x).replace(/\w*\s*/,'').substr(0,1) == '#@' )
					{
					//	alert("asdasd");
					}
					else
					{ //variable or keyword or true/false/null
						if( tempKey == 'var' || tempKey == 'function' || tempKey == 'new' || tempKey == 'else' || tempKey == 'return' || tempKey == 'do' || tempKey == 'break' || tempKey == 'continue' || tempKey == 'case' || tempKey == 'default' || tempKey == 'in' || tempKey == 'delete' || tempKey == 'typeof' )
						{
							newVal += '<span class="oper">'+tempKey+'<\/span>';
						}
						else
						{
							if( tempKey == 'true' || tempKey == 'false' || tempKey == 'null' )
							{
								newVal += '<span class="num">'+tempKey+'<\/span>';
							}
							else
							{
								newVal += '<span class="var">'+tempKey+'<\/span>';
							}
						}
					}

				}
				else
				{
					if( !tempScriptCont.substr(x,1).replace(/[\d]/,'') )
					{ //numbers (+ & - signs are operators)
						newVal += '<span class="num">'+tempScriptCont.substr(x).replace(/[^0-9.xE][\w\W]*/,'')+'<\/span>';
						x += tempScriptCont.substr(x).replace(/[^0-9.xE][\w\W]*/,'').length - 1;
					}
					else
					{ //operators and comments and regexp and quotes
						if( tempScriptCont.substr(x,2) != '\/*' && tempScriptCont.substr(x,2) != '\/\/' )
															  { //ops,regexp,',"
															  if( tempScriptCont.substr(x,1) == "'" )
															  {
															  var backSl = 0; //'string'
															  for( var y = 1; ( backSl%2 || tempScriptCont.substr(y+x,1) != "'" ) && x+y < tempScriptCont.length - 1; y++ )
															  {
															  if( tempScriptCont.substr(y+x,1) == '\\' && ( tempScriptCont.substr(y+x+1,1) == '\\' || tempScriptCont.substr(y+x+1,1) == "'" ) )
															  {
															  backSl++;
															  }
															  else
															  {
															  backSl = 0;
															  }
															  }

															  newVal += "'<span class=\"string\">"+tempScriptCont.substr(x+1,y-1)+"<\/span>'"; x += y;
															  }
															  else
															  {
															  if( tempScriptCont.substr(x,6) == "&quot;" )
															  {
															  var backSl = 0; //"string"
															  for( var y = 1; ( backSl%2 || tempScriptCont.substr(y+x,6) != "&quot;" ) && x+y < tempScriptCont.length - 1; y++ )
															  {
															  if( tempScriptCont.substr(y+x,1) == '\\' && ( tempScriptCont.substr(y+x+1,1) == '\\' || tempScriptCont.substr(y+x+1,6) == "&quot;" ) )
															  {
															  backSl++;
															  }
															  else
															  {
															  backSl = 0;
															  }
															  }
															  newVal += '&quot;<span class="string">'+tempScriptCont.substr(x+6,y-6)+'<\/span>&quot;'; x += y+5;
															  }
															  else
															  {
															  if( inAr(tempScriptCont.substr(x)) )
															  { //ops, regexp
															  if(tempScriptCont.substr(x,10) == "&lt;br&gt;")
															  {
															  newVal += "<br>";
															  x += 9;
															  }
															  else if(tempScriptCont.substr(x,11) == "&lt;br/&gt;")
															  {
															  newVal += "<br/>";
															  x +=10;
															  }
															  else if(tempScriptCont.substr(x,9) == "&lt;p&gt;")
															  {
															  newVal += "<p>";
															  x += 8;
															  }
															  else if(tempScriptCont.substr(x,10) == "&lt;/p&gt;")
															  {
															  newVal += "</p>";
															  x += 9;
															  }
															  else if(tempScriptCont.substr(x,10) == "&amp;nbsp;")
															  {
															  newVal += "&nbsp;";
															  x += 9;
															  }
															  else if(tempScriptCont.substr(x,10) == "&amp;Empty")
															  {
															  newVal += "<p>\n</p>";
															  x+=9;
															  }
															  else if(tempScriptCont.substr(x,8) == "&amp;TAB")
															  {
																  newVal += "\t";
																  x+=7;
															  }
															  else
															  {
																  newVal += '<span class="oper">'+inAr(tempScriptCont.substr(x))+'<\/span>';
																  x += inAr(tempScriptCont.substr(x)).length - 1;
															  }
					}
															  else
															  { //regexp and /. divide preceeded by word or number or ) then any number of tabs or spaces
																  for( var y = -1; x + y != 0 && ( tempScriptCont.substr(x+y,1) == '\t' || tempScriptCont.substr(x+y,1) == ' ' || tempScriptCont.substr(x+y,1) == '\n' || tempScriptCont.substr(x+y,1) == '\r' || tempScriptCont.substr(x+y,1) == '\f' ); y-- ) {}
																  if( !tempScriptCont.substr(x+y,1).replace(/[\)\w\]]/,'') )
																  {
																	  newVal += '<span class="oper">\/<\/span>'; //divide
																  }
																  else
																  {
																	  var backSl = 0; //regexp
																	  for( var y = 1; ( backSl%2 || tempScriptCont.substr(y+x,1) != '\/' ) && x+y < tempScriptCont.length - 1; y++ )
																	  {
																		  if( tempScriptCont.substr(y+x,1) == '\\' && ( tempScriptCont.substr(y+x+1,1) == '\\' || tempScriptCont.substr(y+x+1,1) == '\/' ) )
																		  {
																			  backSl++;
																		  }
																		  else
																		  {
																			  backSl = 0;
																		  }
																	  } //now I have the regexp. I must also see if there is a g or gi or i after it
																	  newVal += '\/<span class="reg">'+tempScriptCont.substr(x+1,y-1)+'<\/span>\/'; x += y; y = x;
																	  if( tempScriptCont.substr(x+1,1) == 'g' || tempScriptCont.substr(x+1,1) == 'i' ) { x++; }
																	  if( tempScriptCont.substr(x+1,1) == 'g' || tempScriptCont.substr(x+1,1) == 'i' ) { x++; }
																	  if( x > y )
																	  {
																		  newVal += '<span class="reg">'+tempScriptCont.substr(y+1,x-y)+'<\/span>';
																	  }
																  }
															  }
					}
					}
					}
						else
						{
							if( tempScriptCont.substr(x,2) == '\/*' )
																  { //block comments
																  newVal += '<span class="comment">'+tempScriptCont.substr(x).replace(/\*\/[\w\W]*/,'')+'*\/<\/span>';
								x += tempScriptCont.substr(x).replace(/\*\/[\w\W]*/,'').length + 1;
						}
							else
							{ //one-line comments
								newVal += '<span class="comment">'+tempScriptCont.substr(x).replace(/[\n\r][\w\W]*/,'')+'<\/span>';
								x += tempScriptCont.substr(x).replace(/[\n\r][\w\W]*/,'').length - 1; 						     }
						}
					}
				}
			}
		}//for loop
	}//if else
}//for loop
	if(mode == "typedText")
	{
		scriptContent = newVal;
	}
	else if(mode != "insert")
	{
		scriptContent = headers+newVal+footers;
	}
	else
	{
		if(isIE)
		{
			//This is done to preserve space inbetween words. If no pre tag is given then single space in between the word is removed.
			scriptContent = "<pre>"+newVal+"</pre>";
		}
		else
		{
			scriptContent = newVal;
		}
	}
	isEnc = true;
	return scriptContent;
}


function getColorForFunction(temp)
{
	//window related
	var col;
	//window functions
	if(temp=="setWindow" || temp=="setTopWindow" || temp=="setAlertWindow" || temp=="closeWindow" || temp=="closeAlertWindow" || temp=="setDialog" || temp=="setDialogWindow" || temp=="closeDialog" || temp=="setWindowNM" || temp=="setTopWindowNM" || temp=="setAlertWindowNM" || temp=="closeWindowNM" || temp=="closeAlertWindowNM" || temp=="setDialogNM" || temp=="setDialogWindowNM" || temp=="closeDialogNM" || temp=="closeUnExpectedPopUp" || temp=="useLocalMapFile" || temp=="useSuiteLevelMapFile" || temp=="closeLastWindow" || temp=="setLastWindow" || temp=="useMapFile")
	{

		col="color_magenta";

	}//retrieval functions
	else if(temp=="linkGetInfo" || temp=="imageGetInfo" || temp=="buttonGetInfo" || temp=="editGetInfo" || temp=="selectGetInfo" || temp=="pageGetInfo" || temp=="winGetInfo" || temp=="getPopUpText" || temp=="getUnExpectedPopUpTitle" || temp=="getCellValueAt" || temp=="getCellValueAtNM" || temp=="getRowCount"  || temp=="getHTMLTableRowCount"  || temp=="getColumnCount" || temp=="getHTMLTableColumnCount" || temp=="getAllHTMLTableCells" || temp=="getLastError" || temp=="getHTMLTableColumnValues" || temp=="listGetInfo" || temp=="webGetText" || temp=="result" || temp=="getWindowTitle" || temp=="getWindowStatus" || temp=="getLastWindowTitle" || temp=="getWindowURL" || temp=="getLastWindowURL" || temp=="getLastWindowDocumentType" || temp=="getLastWindowId")
	{

		col="color_brown";

	}//check functions
	else if(temp=="linkCheckInfo" || temp=="styleCheckInfo" || temp=="buttonCheckInfo" || temp=="imageCheckInfo" || temp=="editCheckInfo" || temp=="selectCheckInfo" || temp=="staticCheckInfo" || temp=="webCheckText" || temp=="pageCheckInfo" || temp=="winCheckInfo"  || temp=="listCheckInfo"  || temp=="checkCellValueAt"  || temp=="executeTest" || temp=="checkCellValueAtNM" || temp=="checkElementProperty" || temp=="checkElementPropertyById")
	{

		col="color_brown";

	}//Miscellaneous functions
	else if(temp=="clickButton" || temp=="clickList" || temp=="clickElement" || temp=="clickMainToolBarButton" || temp=="clickImage" || temp=="clickLink" || temp=="clickMap" || temp=="fireMouseOver" || temp=="showContextMenu" || temp=="changeURL"  || temp=="setText"  || temp=="dragAndDrop" || temp=="dragAndDropAnalog" || temp=="selectItem"  || temp=="selectItemWithIndex" || temp=="launchApplication" || temp=="doubleClick" || temp=="keyPressed" || temp=="mouseOver" || temp=="executeJavaScript" || temp=="clearCookies" || temp=="clearCache")
	{

		col="color_dgreen";

	}//general functions
	else if(temp=="closeAllWindows" || temp=="doesWindowExists" || temp=="setDynamicWindow" || temp=="closeDynamicWindow" || temp=="displayMessage" || temp=="reportStatus" || temp=="reportTestCase" || temp=="getElementWithFocus" || temp=="doesElementExists" || temp=="getElementIdentifier" || temp=="getElementProperty" || temp=="getElementPropertyById" || temp=="getCellElementProperty"  || temp=="getLocaleDetails"  || temp=="getLocalizedString" || temp=="fireEventOnElement" || temp=="fireEventOnElementById" || temp=="fireEventOnCellElement" || temp=="fireEventOnTableCell" || temp=="fireEventOnTableCellElement" || temp=="fireEventOnChildElement" || temp=="wait" || temp=="waitForPageDownload" || temp=="setDownloadTimeLimit" || temp=="setFastMode" || temp=="setMouseCapture" || temp=="submitForm" || temp=="saveScreenShot" || temp=="initCSV" || temp=="initDB" || temp=="getCSVValueAt" || temp=="getDBValueAt" || temp=="getDBValues" || temp=="getDBTableRowCount" || temp=="getDBTableColumnCount" || temp=="getEncryptedValue" || temp=="setGlobal" || temp=="getGlobal" || temp=="getHTMLElementCount" || temp=="getOSVersion" || temp=="getOSName" || temp=="getBrowserVersion" || temp=="getBrowserType" || temp=="writeToCSVFile" || temp=="changeLocale")
	{

		col="color_violet";

	}//file functions
	else if(temp=="getLinesInFile" || temp=="isStringInFile" || temp=="getFileCount" || temp=="getStringCountInFile" || temp=="isFileInZip" || temp=="isStringInZip" || temp=="compareFile" || temp=="getFileSize")
	{

		col="color_violet";

	}//xml functions
	else if(temp=="getValuesAsMap" || temp=="getNodeValues" || temp=="getNodeCount" || temp=="getNodeValue" || temp=="getNodeAttributes" || temp=="isNodePresent" || temp=="isXMLSimilar" || temp=="isXMLIdentical" || temp=="getTextNodeValues")
	{

		col="color_violet";


	}//date functions
	else if(temp=="getDateTime" || temp=="getDateStr" || temp=="getTimeStr" || temp=="getTimeLong" || temp=="adjustDate" || temp=="adjustGivenDate" || temp=="getDateTimePart" || temp=="getDateDiff" || temp=="getDay" || temp=="getNextDay"  || temp=="getPreviousDay"  || temp=="getHour"  || temp=="getNextHour" || temp=="getPreviousHour")
	{

		col="color_violet";

	}//costly functions
	else if(temp=="stop" || temp=="stopAll" || temp=="callScript" || temp=="callScriptUpto" || temp=="callScriptFrom" || temp=="invokeApplication" || temp=="invokeApplicationInThread" || temp=="setErrorHandlingScript" || temp == "disableErrorHandling" || temp=="terminateBrowser")
	{

		col="color_red";

	}//utility functions
	else if(temp=="indexOf" || temp=="length" || temp=="split" || temp=="toLowerCase" || temp=="toUpperCase" || temp=="startsWith" || temp=="endsWith" || temp=="replaceFirst" || temp=="replaceAll" || temp=="subString")
	{

		col="color_lgreen";

	}//Ajax functions
	else if(temp=="waitForElement" || temp=="waitForDynamicElement" || temp=="waitForDynamicElementById" || temp=="waitForElementRemoval" || temp=="waitForDynamicElementRemoval" || temp=="waitForDynamicElementRemovalById" ||temp=="waitForText" || temp=="waitForTitle" || temp=="enableWaitForElement" || temp=="setWaitTimeForElement" || temp=="waitForWindowStatus" || temp=="waitForElementPropertyChange" || temp=="waitForDynamicElementPropertyChange" || temp=="waitForDynamicElementPropertyChangeById")
	{
		col="color_lblue";
	}
	else if(temp=="getAllHTMLTableCells" || temp=="getAllHTMLTableCellsNM" || temp=="getHTMLTableColumnValues" || temp=="getHTMLTableColumnValuesNM" || temp=="getHTMLTableRowValues" || temp=="getHTMLTableRowValuesNM" || temp=="getHTMLTableRowCount" || temp=="getHTMLTableRowCountNM" || temp=="getHTMLTableColumnCount" || temp=="getHTMLTableColumnCountNM" || temp=="getCellHTML" || temp=="getCellHTMLNM" || temp=="getHTMLTableHTML" || temp=="getHTMLTableHTML" || temp=="doesColumnContain" || temp=="doesColumnContainNM" || temp=="compareDB_HTMLTableColumn" || temp=="compareDB_HTMLTableColumnNM" || temp=="compareDB_HTMLTableRow" || temp=="compareDB_HTMLTableRowNM" || temp=="compareDB_HTMLTable" || temp=="compareDB_HTMLTableNM" || temp=="compareCSV_HTMLTableColumn" || temp=="compareCSV_HTMLTableColumnNM" || temp=="compareCSV_HTMLTableRow" || temp=="compareCSV_HTMLTableRowNM" || temp=="compareCSV_HTMLTable" || temp=="compareCSV_HTMLTableNM")
	{
		col= "color_bgreen";
	}
	else
	{

		col="func";

	}
	return col;
}
