/* $Id: editH.js,v 1.4.4.20 2009/10/29 12:51:03 aishwarya Exp $*/
var buttons=[
    ["Background_Color",false],
    ["Text_Color",false],
    ["Larger_Text",false],
    ["Smaller_Text",false],
    ["Bold",true],
    ["Italic",true],
    ["Underline",true],
    ["Strikethrough",false],
    ["Subscript",false],
    ["Superscript",false],
    ["Link",true],
    ["Unlink",true],
    ["Create_Table",false],
    ["Outdent",true],
    ["Indent",true],
    ["Unordered_List",true],
    ["Ordered_List",true],
    ["Left",true],
    ["Center",true],
    ["Right",true],
    ["Justify",false],
    ["New_Page",false],
    ["Copy",false],
    ["Cut",false],
    ["Paste",false],
    ["Image",false],
    ["HR",false],
    ["Raw_HTML",false],
    ["Undo",false],
    ["Redo",false]
];
htmlTags = ["A","ABBR","ACRONYM","ADDRESS","APPLET","AREA","B","BASE","BASEFONT","BDO","BIG","BLOCKQUOTE","BODY","BR","BUTTON","CAPTION","CENTER","CITE","CODE","COL","COLGROUP","DD","DEL","DFN","DIR","DIV","DL","DT","EM","FIELDSET","FONT","FORM","FRAME","FRAMESET","H1","H2","H3","H4","H5","H6","HEAD","HR","HTML","I","IFRAME","IMG","INPUT","INS","ISINDEX","KBD","LABEL","LEGEND","LI","LINK","MAP","MENU","META","NOFRAMES","NOSCRIPT","OBJECT","OL","OPTGROUP","OPTION","P","PARAM","PRE","Q","S","SAMP","SCRIPT","SELECT","SMALL","SPAN","STRIKE","STRONG","STYLE","SUB","SUP","TABLE","TBODY","TD","TEXTAREA","TFOOT","TH","THEAD","TITLE","TR","TT","U","UL","VAR"];
var formatBlock = new Array("formatBlock",
			    "Format", "Format",
			    "P", "Paragraph <P>",
			    "H1", "Heading 1 <H1>",
			    "H2", "Heading 2 <H2>",
			    "H3", "Heading 3 <H3>",
			    "H4", "Heading 4 <H4>",
			    "H5", "Heading 5 <H5>",
			    "H6", "Heading 6 <H6>",
			    "BLOCKQUOTE", "Blockquote",
			    "Address", "Address <ADDR>",
			    "PRE", "Pre <PRE>",
			    "Unformatted", "Unformatted");

var fontFamily = new Array("fontname",
			   "Font", "Font",
			   "serif", "Serif",
			   "Arial", "Arial",
		 	   "Courier", "Courier",
			   "Times", "Times");

var fontSize = new Array("fontsize",
			 "Size", "Size",
			 "1", "1",
			 "2", "2",
			 "3", "3",
			 "4", "4",
			 "5", "5",
			 "6", "6",
			 "7", "7");

var color = new Array("forecolor",
		      "color", "Color",
		      "rgb(0, 0, 0)", "black",
		      "rgb(255, 255, 255)", "white",
		      "rgb(255, 0, 0)", "red",
		      "rgb(0, 255, 0)", "green",
		      "rgb(0, 0, 255)", "blue",
		      "rgb(255, 255, 0)", "yellow",
		      "rgb(0, 255, 255)", "cyan",
		      "rgb(255, 0, 255)", "magenta");

var backgroundColor = new Array("hilitecolor", // issue: default is "transparent"
				"background-color", "Background",
				"rgb(0, 0, 0)", "black",
				"rgb(255, 255, 255)", "white",
				"rgb(255, 0, 0)", "red",
				"rgb(0, 255, 0)", "green",
				"rgb(0, 0, 255)", "blue",
				"rgb(255, 255, 0)", "yellow",
				"rgb(0, 255, 255)", "cyan",
				"rgb(255, 0, 255)", "magenta");

var prevRange;
var prevContainer;
var prevPos;
var focusedRange;

//var selectors = new Array(formatBlock, fontFamily, fontSize, color, backgroundColor);
var selectors = new Array(fontFamily, fontSize, color);
addEvent = function(el, evname, func) {
	if (el.attachEvent) {
		el.attachEvent("on" + evname, func);
	} else {
		el.addEventListener(evname, func, true);
	}
};

addEvents = function(el, evs, func) {
	for (var i in evs) {
		addEvent(el, evs[i], func);
	}
};

removeEvent = function(el, evname, func) {
	if (el.detachEvent) {
		el.detachEvent("on" + evname, func);
	} else {
		el.removeEventListener(evname, func, true);
	}
};

removeEvents = function(el, evs, func) {
	for (var i in evs) {
		removeEvent(el, evs[i], func);
	}
};
stopEvent = function(e) {
	if(e.stopPropagation)
	{
		e.preventDefault();
		e.stopPropagation();
	}
	else
	{
		e.cancelBubble = true;
		e.returnValue = false;
	}
};


EditH = function(home,def,learnmode,toption) {
	this.is_ie = (navigator.userAgent.toLowerCase().indexOf("msie") > -1)?true:false;
	this.is_moz = ((navigator.product == 'Gecko') && (navigator.userAgent.indexOf("Safari") == -1))?true:false;
	this.is_opera = (navigator.userAgent.toLowerCase().indexOf("opera") > -1)?true:false;
	this.firstConfirm=true;
	this.home = home;
	this.margin='5px';
	this.fontSize='16px';
	this.font='verdana,arial,helvetica,sans-serif';
        this.backgroundColor = "#FFFFFF";
	this.defMode=(this.is_opera)?'text':def;
	this.mode='';
	this.onlyText=(this.is_opera)?true:false;
	this.text=null;
	this.html=null;
	this.hc = document.createElement('DIV');
        if(toption!=null && toption == false)
            this.toggleOption=false;
        else
            this.toggleOption=true;
            window.editor = this;
	if(learnmode=="true")
	{
		this.learnmode=true;
	}
	this.construct();
}
EditH.prototype.construct = function() {
		document.write('<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="0" class="editH">');
		if(this.learnmode)
		{
			document.write('<tr style="display:none;"><td width="100%" class="editHToolBar">');
		}
		else
		{
			document.write('<tr style="display:none;"><td width="100%" class="editHToolBar">');
		}
		if(this.onlyText) {
			document.write('&nbsp;');
		}
		else {
		document.write('<table cellspacing="4" unselectable="on" class="editHTool" id="editHTool" '+((this.defMode=='text')?'style="display:none;"':'')+'><tr align="center">');
		for(var ind=0; ind < buttons.length; ind++)
		{ if(buttons[ind][1])
			{
				var action = buttons[ind][0];
				document.write('<td width="30" nowrap><a href="javascript:void(0);" onfocus="EditH.focus();" onClick="window.editor.updateState(\''+action+'\');"><img src="/framework/images/editH/'+action+'.gif" width="16" height="16" border="0"></a></td>');
			}
		}
		for(var ind=0; ind < selectors.length; ind++)
		{
			var selector = selectors[ind];
			var id = selector[0];
			document.write('<td class="tdSelect">');
			document.write('<select id="'+id+'" unselectable="on" onchange="window.editor.selectBox(this);">');
			for(var i=1; i<selector.length; i=i+2)
			{
				document.write('<option value="'+selector[i]+'">'+selector[i+1]+'</option>');
			}
			document.write('</select>');
			document.write('</td>');
		}
		document.write('</tr></table></td>');
                document.write('<td nowrap valign="middle" class="editHToolBar" style="display:'+(this.toggleOption?'':'none')+';">');
                document.write('<table border="0" cellspacing="0" cellpadding="0" class="editHTool">');
                document.write('<tr><td><input type="checkbox" name="editHToggle" id="editHToggle" '+((this.defMode=='html')?'checked':'')+' onClick="window.editor.updateState(\'toggleedit\');"></td>');
                document.write('<td nowrap style="width:100px"><label onclick="window.editor.updateState(\'toggleedit\');">HTML Editor</label>&nbsp;&nbsp;</td></tr>');
                document.write('</table></td>');
		}
		
		
		if(this.learnmode)
		{
			var hei = 0;
			if(window.editor.is_ie)
			{
				hei = parent.document.body.offsetHeight - 460 ;
			}
			else
			{
				hei = parent.document.body.offsetHeight -460 ;
			}
document.write('</td></tr><tr><td valign="top"  height ="'+hei+'" colspan="2" id="mainContainer">');
		document.write('<table width="100%" id="tabhei" border="0" height ="'+hei+'" cellpadding="0" cellspacing="0">');
		document.write('<tr><td height ="'+hei+'">');
		if(!this.onlyText)
		document.write('<iframe id="htmlContainer" name="htmlContainer" height="'+hei+'"  width="100%" class="tableborder" style="border:0px;display:none;" frameborder="0" src="" ></iframe>');
		document.write('<textarea id="textContainer" width="100%" height="'+hei+'" style="width:100%;border:0px;display:none;"></textarea>');

		}
		else
		{
			var hei =  0;
			hei = parent.document.body.offsetHeight-200;
			document.write('</td></tr><tr><td valign="top"  colspan="2" id="mainContainer">');
			document.write('<table width="100%" id="tabhei" height="'+hei+'" border="0" cellpadding="0" cellspacing="0">');
			document.write('<tr><td >');
			if(!this.onlyText)
				document.write('<iframe id="htmlContainer" name="htmlContainer" height="100%"  width="100%" class="tableborder" frameborder="0" src="" ></iframe>');
			document.write('<textarea id="textContainer" width="100%" height="100%" style="width:100%;border:0px;display:none;"></textarea>');
		}
		
				document.write('</td></tr>');
		document.write('</table>');
		document.write('</td></tr></table>');

}
EditH.init = function() {
	if(window.editor)
	{
		window.editor.init();
	}
}
EditH.setContent = function(t) {
	window.editor.setContent(t);
}
EditH.getContent = function() {
	return window.editor.getContent();
}
EditH.focus = function() {
	if(window.editor)
	{
		window.editor.focus();
		getFocusToLastLine();
		get_lineno();
	}
}
EditH.getMode = function() {
	return window.editor.mode;
}


EditH.prototype.init = function() {
	if(!this.onlyText) {
		this.tool = document.getElementById('editHTool');
		this.toggle = document.getElementById('editHToggle');
		this.html = document.getElementById('htmlContainer');
	}
	this.text = document.getElementById('textContainer');
        this.mainContainer = document.getElementById('mainContainer');
	if(this.html!=null) {
		this.window = this.html.contentWindow;
		this.document = this.window.document;
		//window.editor.window.document.onkeydown=function(){alert("s");};//keyDownHandler;
		//addEvent(window.editor.html,"blur",function(){window.editor.window.focus();});
		addEvents(window.editor.window.document,["keydown"],
			function(event){
				return keyDownHandler(window.editor.is_ie?window.editor.window.event:event);
			});
		addEvents(window.editor.window.document,["keyup"],
			function(event){
				return keyUpHandler(window.editor.is_ie?window.editor.window.event:event);
			});
		addEvents(window.editor.window.document,["keypress"],
			function(event){
				return keyPressHandler(window.editor.is_ie?window.editor.window.event:event);
			});
		addEvents(window.editor.window.document,["click","mouseup","mousedown"],
					function(event){
						return clickHandler(window.editor.is_ie?window.editor.window.event:event);
			});

		this.document.body.style.margin = this.margin;
		this.document.body.style.fontSize = this.fontSize;
		this.document.body.style.fontFamily = this.font;
                this.document.body.style.backgroundColor = this.backgroundColor

		this.html.style.width = '100%';
		this.html.style.height = '100%';

	}
	this.text.style.margin = this.margin;
	this.text.style.fontSize = this.fontSize;
	this.text.style.fontFamily = this.font;
        this.text.style.backgroundColor = this.backgroundColor;
        this.text.style.width = '99%';
	this.text.style.height = '99%';
        //this.text.style.height = this.mainContainer.offsetHeight;
        //this.text.rows= this.mainContainer.offsetHeight/16;
	if(this.onlyText) {
		this.text.style.display = '';
		this.mode='text';
		return true;
	}

	if(this.defMode=='text') {
		this.text.style.display = '';
		this.toggle.checked=false;
		this.mode='text';
		return true;
	}
	if(this.defMode=='html') {
		this.html.style.display = '';
		this.toggle.checked=true;
		this.onDesignMode();
		this.mode='html';
		return true;
	}
}
EditH.prototype.setContent = function(t) {
	if(this.mode=='text') {
		this.text.value=t;
	}
	else {
                if(t=='')
                    t='<br>';
                this.insertNodeAtSelection(t);
		//this.onDesignMode();
	}
}
EditH.prototype.loadContent = function(t) {
	if(this.mode=='text') {
		this.text.value=t;
	}
	else {
                if(t=='')
                    t='<br>';
 	        frames.htmlContainer.document.write(t);
		//this.onDesignMode();
	}
}
EditH.prototype.getContent = function() {
	if(this.mode=='text') {
		return this.text.value;
	}
	else {
		try
		{
			return this.document.body.innerHTML;
		}
		catch(e)
		{
			if(this.text.value != null)
			{
				return this.text.value;
			}
			else
			{
				return "EMPTY";
			}
		}
	}
}
EditH.prototype.focus = function() {
	if(this.mode=='html') {
		this.window.focus();
	}
	else {
		this.text.focus();
	}
}
EditH.prototype.onDesignMode = function() {
	if(this.mode='html') {
		if(window.editor.is_ie)
			this.document.body.contentEditable = true;
		else
			this.document.designMode = 'On';
	}
}
EditH.prototype.selectBox = function(el) {
	var cursel = el.selectedIndex;

  	if (cursel != 0)
	{
		var selectName = el.id;
 		var selectValue = el.options[cursel].value;

		this.updateSelect(selectName, selectValue);

		el.options[0].selected = true; // reset to first option

		document.getElementById(selectName).blur(); // ensures focus goes back to editable area
	}
}
EditH.prototype.updateSelect = function(selectName,selectValue) {
	this.document.execCommand(selectName,false,selectValue);
	this.window.focus();
}
EditH.prototype.updateState = function(action) {
		switch(action)
		{
			case "Unlink":
					this.document.execCommand('Unlink',false,null);
			break;

			case 'Link':
				var szURL = prompt("Enter a URL:", "http://");
				if ((szURL != null) && (szURL != "")) {
					this.document.execCommand("CreateLink",false,szURL);
				}
			break;

			case "Save":
					parent.window.editor.savescript(false);
			break;

			case 'Bold':
					this.document.execCommand('bold',false,null);
			break;
			case 'Italic':
					this.document.execCommand('italic',false,null);
			break;
			case 'Underline':
					this.document.execCommand('underline',false,null);
			break;
			case 'Strikethrough':
					this.document.execCommand('Strikethrough',false,null);
			break;
			case 'Subscript':
					this.document.execCommand('Subscript',false,null);
			break;
			case 'Superscript':
					this.document.execCommand('Superscript',false,null);
			break;
			case 'Ordered_List':
					this.document.execCommand('insertorderedlist',false,null);
			break;
			case 'Unordered_List':
					this.document.execCommand('insertunorderedlist',false,null);
			break;
			case 'Indent':
					this.document.execCommand('indent',false,null);
			break;
			case 'Outdent':
					this.document.execCommand('outdent',false,null);
			break;
			case 'Left':
					this.document.execCommand('justifyleft',false,null);
			break;
			case 'Right':
					this.document.execCommand('justifyright',false,null);
			break;
			case 'Center':
					this.document.execCommand('justifycenter',false,null);
			break;
			case 'Image': // need to replace with native file selection dialog
			    imagePath = prompt('Enter Image URL:', 'http://');
			    if ((imagePath != null) && (imagePath != "")) {
					this.document.execCommand('InsertImage', false, imagePath);
				}
			break;
			case 'HR':
					this.document.execCommand('InsertHorizontalRule',false,null);
			break;
			case 'Create_Table':
				var table;
			    rowstext = prompt("enter rows",'');
			    colstext = prompt("enter cols",'');
			    rows = parseInt(rowstext);
				cols = parseInt(colstext);
				if ((rows > 0) && (cols > 0)) {
					if(MOZILLA) {
						table = this.document.createElement("table");
						table.setAttribute("border", "1");
						table.setAttribute("cellpadding", "2");
						table.setAttribute("cellspacing", "2");
						tbody = this.document.createElement("tbody");
						for (var i=0; i < rows; i++) {
							tr =this.document.createElement("tr");
							for (var j=0; j < cols; j++) {
								td =this.document.createElement("td");
								br =this.document.createElement("br");
								td.appendChild(br);
								tr.appendChild(td);
							}
							tbody.appendChild(tr);
						}
						table.appendChild(tbody);
					}
					else if(IE)
					{
						table = '<table border="1" cellpadding="2" cellspacing="2"><tbody>';
						for (var i=0; i < rows; i++) {
							table = table + '<tr>';
							for (var j=0; j < cols; j++) {
								table = table + '<td><br></td>';
							}
							table = table + '</tr>';
						}
						table = table + '</table>';
					}
					this.insertNodeAtSelection(table);
				}
			break;
			case 'Copy':
					this.document.execCommand('copy',false,null);
			break;
			case 'Cut':
					this.document.execCommand('cut',false,null);
			break;
			case 'Paste':
					this.document.execCommand('paste',false,null);
			break;
			case 'Undo':
					this.document.execCommand('undo',false,null);
			break;
			case 'Redo':
					this.document.execCommand('redo',false,null);
			break;
			case 'Raw_HTML':
				if(this.mode=='html'){
					this.html.style.display="none";
					this.text.value=this.document.body.innerHTML;
					this.text.style.display='';
					this.mode = 'text';
				}
				else{
					this.document.body.innerHTML = this.text.value;
	                                this.text.style.display="none";
        	                        this.html.style.display="";
					this.mode = 'html'
				}
			break;
			case 'toggleedit':
				if(this.mode=='text') {
					this.mode='html';
					this.switchMode();
				}
				else{
					if(this.firstConfirm) {
						if(confirm('Converting this to plain text will lose some formatting.\n Are you sure you want to continue?')) {
							this.mode='text';
							this.firstConfirm = false;
							this.switchMode();
						}
						else {
							this.toggle.checked=true;
							this.window.focus();
						}
					}
					else {
						this.mode='text';
						this.switchMode();
					}
				}
			break;
		}
}

EditH.prototype.switchMode = function() {
	if(this.mode == 'html') {
		this.document.body.innerHTML = EditH.t2h(this.text.value);
		this.text.value='';
		this.tool.style.display='';
		this.text.style.display='none';
		this.html.style.display='';
		this.toggle.checked=true;
		this.onDesignMode();
		this.window.focus();
	}
	else {
		this.text.value=EditH.h2t(this.document.body.innerHTML);
		this.document.body.innerHTML = '';
		this.tool.style.display='none';
		this.text.style.display='';
		this.html.style.display='none';
		this.toggle.checked=false;
		this.text.focus();
	}
}
EditH.h2t = function(iVal) {
    iVal = iVal.replace(/\n+/gi,'');
    iVal = iVal.replace(/\r+/gi,'');
    iVal = iVal.replace(/<!--.*?-->/gi,'');
    iVal = iVal.replace(/<head>.*?<\/head>/gi,'');
	iVal = iVal.replace(/<br.*?>/gi,'\n');
    iVal = iVal.replace(/<hr.*?>/gi,'\n');
    iVal = iVal.replace(/<\/p>/gi,'\n');
    iVal = iVal.replace(/<\/h[1-6]>/gi,'\n');
    iVal = iVal.replace(/<\/tr>/gi,'\n');
    iVal = iVal.replace(/<\/li>/gi,'\n');
    iVal = iVal.replace(/<\/td>/gi,' ');
    iVal = iVal.replace(/<\/th>/gi,' ');
    iVal = iVal.replace(/<\/.*?>/gi,'');
    iVal = iVal.replace(/<.*?>/gi,function($1)
	{
		if(EditH.ishtag($1)) {
			return '';
		}
		else {
			return $1;
		}
	});
    iVal = iVal.replace(/\&.*?;/gi, function($1)
    {
        return EditH.h2c($1);
    });
    //iVal = iVal.replace(/^\n+/gi,'');
    iVal = iVal.replace(/\n+$/gi,'');
    return iVal;
}
EditH.t2h = function(iv) {
	return iv.replace(/\ /gi,'&nbsp;').replace(/</gi,'&lt;').replace(/>/gi,'&gt;').replace(/\n/gi,'<br>');
}
EditH.t2hwonbsp = function(iv) {
	if(window.editor.is_ie)
	{
		return iv.replace(/</gi,'&lt;').replace(/>/gi,'&gt;').replace(/\n/gi,'<br\/>');
	}
	else
	{
		return iv.replace(/</gi,'&lt;').replace(/>/gi,'&gt;').replace(/\n/gi,'<br\/>');
	}
}
EditH.h2c = function(iv) {
	//The check here is made due to &nbsp; char giving syntax error in IE. - Raghavan
	// issue while playing rspace , lspace and middle space are fixed - Raghavan
	if(window.editor.is_ie && iv == "&nbsp;")
	{
		return iv.replace('&nbsp;','\u00a0');
	}
	else
	{
		window.editor.hc.innerHTML=iv;
    	return window.editor.hc.firstChild.nodeValue;
	}
}
EditH.c2h = function(iv) {
    window.editor.hc.innerHTML='';
    var tn = document.createTextNode(iv);
    window.editor.hc.appendChild(tn);
    return window.editor.hc.innerHTML;
}
EditH.ishtag = function(ih) {
	//var r = ih.substring(1,ih.length-1);
	return true;
}


EditH.prototype.insertScriptAtRecMode = function (inNode) {
		if(window.editor)
		{
			if(window.editor.is_moz)
			{

				//alert("is_moz here");
				// get current selection

				var sel = window.editor.window.getSelection();
				if(!isPaste)
				{
					getFocusToLastLine();
				}
				// get the first range of the selection
				// (there's almost always only one range)
				var range;
				if(sel.getRangeAt(0))
				{
					range = sel.getRangeAt(0);
				}
				else
				{
					range = sel.createRange();
				}

				// deselect everything
				sel.removeAllRanges();
		
				// remove content of current selection from document
				range.deleteContents();
					
				// get location of current selection
				var container = range.startContainer;
				var pos = range.startOffset;
				var endOffSet = range.endOffset;

				if(pos==0 && endOffSet==0)
				{
					if(prevRange)
					{
						range = prevRange;
						endOffSet = range.endOffset;
					}
					container = prevContainer;
					pos = prevPos;
				}
				else
				{
					// make a new range for the new selection
					range=window.editor.document.createRange();
				}
				prevRange=range;
				prevContainer=container;
				prevPos = pos;

				if (container.nodeType==3 && inNode.nodeType==3) {

					// if we insert text in a textnode, do optimized insertion
					container.insertData(pos, inNode.nodeValue);

					// put cursor after inserted text
					range.setEnd(container, pos+inNode.length);
					range.setStart(container, pos+inNode.length);

				} else {


					var afterNode;
					if (container.nodeType==3) {

						// when inserting into a textnode
						// we create 2 new textnodes
						// and put the inNode in between

						var textNode = container;
						container = textNode.parentNode;
						var text = textNode.nodeValue;

						// text before the split
						var textBefore = text.substr(0,pos);
						// text after the split
						var textAfter = text.substr(pos);

						var beforeNode = document.createTextNode(textBefore);
						var afterNode = document.createTextNode(textAfter);

						// insert the 3 new nodes before the old one
						container.insertBefore(afterNode, textNode);
						container.insertBefore(inNode, afterNode);
						container.insertBefore(beforeNode, inNode);

						// remove the old node
						container.removeChild(textNode);

					} else {

						// else simply insert the node
						afterNode = container.childNodes[pos];
						container.insertBefore(inNode, afterNode);
						prevPos = pos+inNode.childNodes.length;
					}
					if(afterNode)
					{
						//current position is taken to make cursor to the next line of the currently pasted text
						parent = afterNode.parentNode;
						range.setEnd(parent, (pos+1));
						range.setStart(parent, (pos+1));
					}
					else
					{
						range.setEnd(inNode, inNode.childNodes.length);
						range.setStart(inNode, inNode.childNodes.length);
					}
				}
				sel.addRange(range);
				focusedRange = range;
			}
			else if(window.editor.is_ie)
			{
				//getFocusedRange();
				getFocusToLastLine();
				var sel = window.editor.document.selection;
				if(sel!=null)
				{
					var range = sel.createRange();
					range.pasteHTML(inNode.toString());			
					// Following part will take the cursor to end of the pasted html. This is done to paste the checkpoint text  in the editor in the correct order.
					//range.moveStart("character",(EditH.h2t(inNode)).length);
					//range.moveEnd("character",(EditH.h2t(inNode)).length);
					range.collapse();
					range.select();
					focusedRange = range.duplicate();
				}
			}
		}
	}

EditH.prototype.insertNodeAtSelection = function (inNode) {
		//alert("inside insertNodeAtSelection");
		if(this.is_moz)
		{
			// get current selection
			var sel = this.window.getSelection();

			// get the first range of the selection
			// (there's almost always only one range)
			var range = sel.getRangeAt(0);
			
			// deselect everything
			sel.removeAllRanges();

			// remove content of current selection from document
			range.deleteContents();

			// get location of current selection
			var container = range.startContainer;
			var pos = range.startOffset;

			// make a new range for the new selection
			range=this.document.createRange();

			if (container.nodeType==3 && inNode.nodeType==3) {

				// if we insert text in a textnode, do optimized insertion
				container.insertData(pos, inNode.nodeValue);

				// put cursor after inserted text
				range.setEnd(container, pos+inNode.length);
				range.setStart(container, pos+inNode.length);

			} else {


				var afterNode;
				if (container.nodeType==3) {

					// when inserting into a textnode
					// we create 2 new textnodes
					// and put the inNode in between

					var textNode = container;
					container = textNode.parentNode;
					var text = textNode.nodeValue;

					// text before the split
					var textBefore = text.substr(0,pos);
					// text after the split
					var textAfter = text.substr(pos);

					var beforeNode = document.createTextNode(textBefore);
					var afterNode = document.createTextNode(textAfter);

					// insert the 3 new nodes before the old one
					container.insertBefore(afterNode, textNode);
					container.insertBefore(inNode, afterNode);
					container.insertBefore(beforeNode, inNode);

					// remove the old node
					container.removeChild(textNode);

				} else {

					// else simply insert the node
					afterNode = container.childNodes[pos];
					container.insertBefore(inNode, afterNode);
				}

				range.setEnd(afterNode, 0);
				range.setStart(afterNode, 0);
			}
			sel.addRange(range);
		}
		else if(this.is_ie)
		{
			var sel = this.document.selection;
			if(sel!=null)
			{
			var range = sel.createRange();
			range.pasteHTML(inNode.toString());
			}
		}
	}

var mdownx;
var mdowny;
var mupx;
var mupy;

//This variable is introduced to use in getline number
// when click in the script with empty lines then the focus goes to the next line in IE browser
var clickEvent;
function clickHandler(evt)
{
	try
	{
		hideRightMenu(evt);
	}
	catch(e)
	{

	}
	if(window.editor.is_ie)
	{
		if(evt.type == "mousedown")
		{
			mdownx = evt.clientX;
			mdowny = evt.clientY;
			return;
		}
		else if(evt.type == "mouseup")
		{
			mupx = evt.clientX;
			mupy = evt.clientY;
			return;
		}
		else if(evt.type == "click")
		{
			clickEvent=true;
			// without this check the text selected in the editor will disappear
			if((mdownx - mupx) == 0 && (mdowny - mupy) == 0)
			{
				var pos = document.selection.createRange();
				//this is used for data configuration paste to work
				focusedRange = pos.duplicate();
				get_lineno();
			}
		}
	}
	else
	{
		if(evt.type == "click")
		{
			get_lineno();
		}
	}
}

//This will get the range when the arrow keys are pressed in the editor.
function keyUpHandler(evt)
{
	if(window.editor.is_ie && evt.type =="keyup") {
		window.status = evt.keyCode;
	
		if(evt.keyCode >=33 && evt.keyCode<=40 && (!evt.shiftKey))
		{
			var pos = document.selection.createRange();
			//this is used for data configuration paste to work
			focusedRange = pos.duplicate();
			//line no updation done
			get_lineno();
		}
		else if(evt.keyCode == 13)
		{
			//this is used for data configuration paste to work
			get_lineno();
			var pos = document.selection.createRange();
			focusedRange = pos.duplicate();
		}
		else if(evt.keyCode == 83 && evt.ctrlKey)
		{
			parent.window.editor.savescript(false);
		}

	}
	else if(!window.editor.is_ie && evt.type =="keyup" && (!evt.shiftKey)){
		window.status = evt.keyCode;
		if(evt.keyCode >=33 && evt.keyCode<=40)
		{
			//line no updation done
			get_lineno();
		}
		else if(evt.keyCode == 83 && evt.altKey)
		{
			parent.window.editor.savescript(false);
		}

	}
}

var funcName = "";
var nodes;
var functions;
var x;
var y;
var lineContent = "";
var prevLNo;
var selectFunc="";
var keyDownMode = false;
var funcExist = false;
var bsmode = false;
var looping = false;
var funcClickMode = false;
function getAllFunction()
{
	if(window.editor.is_ie)
	{
		var ie = (typeof window.ActiveXObject != 'undefined');
		if(!ie)
		{
			alert("Cannot Read xml in IE");
		}
		var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
		xmlDoc.async="false";
		xmlDoc.load("/qehome/conf/fguitemplate.xml");
		nodes = xmlDoc.documentElement.childNodes;
	}
	else if(window.editor.is_moz)
	{
		var moz = (typeof document.implementation != 'undefined') && (typeof document.implementation.createDocument != 'undefined'); 
		if(!moz)
		{
			alert("Cannot Read xml in Firefox");
		}
		var xmlDoc = document.implementation.createDocument("", "", null);
		xmlDoc.async=false;
		xmlDoc.load("/qehome/conf/fguitemplate.xml");
		functions=xmlDoc.getElementsByTagName("Functions");
		nodes=functions[0].getElementsByTagName("Function");
	}
}

function setUpClickHandler(mode,func,funcName)
{
	funcClickMode = true;
	completeTheFunction(func,funcName);
}


function showFunctions()
{
    var divtoshow =window.parent.parent.parent.document.getElementById("sug-func1");
    divtoshow.innerHTML = "";
	if(functions.length == 0)
	{
		divtoshow.style.display = "none";
		return;
	}
    if(window.editor.is_ie)
    {
	    var sel = document.selection;
	    var range = sel.createRange();
	    var parent = range.parentElement();

	    var rect = range.getBoundingClientRect();
		
	    x = 280 + rect.left
	    var h = (typeof window.innerHeight != 'undefined' ? window.innerHeight : document.body.offsetHeight);
	    var toolbarHgt = screen.availHeight - h;
	    y = 52 + rect.top + 190;
    }
    else
    {
	    var sel = window.editor.window.getSelection();
	    var range;
	    if(sel.getRangeAt(0))
	    {
		    range = sel.getRangeAt(0);
	    }
	    else
	    {
		    range = sel.createRange();
	    }

	    x = 280 + range.startOffset;
	    var h = (typeof window.innerHeight != 'undefined' ? window.innerHeight : document.body.offsetHeight);
	    var toolbarHgt = screen.availHeight - h;
	    y = 52 + range.endOffset + 260;
    }
    var funclist = "";
    var yPos = y;
	
	var funclist = "";
	var yPos = y;
	var iterLen = functions.length;
	divtoshow.innerHTML="";
	if(iterLen > 10)
	{
		divtoshow.style.height = "150px";
		divtoshow.style.width = "200px";
		divtoshow.style.overflow = "scroll";
	}
	else
	{
		divtoshow.style.height = "auto";
		divtoshow.style.width = "auto";
		divtoshow.style.overflow = "auto";

	}
	for(var i=0;i<iterLen;i++)
	{
		var id = "func_"+i;
		yPos = yPos + 10;
		funclist += "<div id='"+id+"' style='left="+x+";top="+yPos+";' align='left' onmouseover=\"setStyle('"+id+"');\" onmouseout=\"removeStyle('"+id+"');\" onclick=\"javascript:setUpClickHandler(true,'"+functions[i]+"','"+funcName+"');\">"+functions[i]+"</div>";
	}
	
	divtoshow.innerHTML=funclist;
	divtoshow.style.left= x;
	divtoshow.style.top= y;
	eval("divtoshow.style.display = 'block';");
	
}

function selectFunctions(addVal)
{
	if(selectFunc=="")
	{
		var selectid = "func_0";
		setStyle(selectid);
	}
	else
	{
		removeStyle(selectFunc);
		
		var index = selectFunc.substring(5,selectFunc.length);
		var indexfunc=parseInt(index)+addVal;
		if(indexfunc == -1)
		{
			indexfunc = functions.length - 1;
		}
		selectid="func_"+indexfunc;
		if(window.parent.parent.parent.document.getElementById(selectid) == null)
		{
			selectid = "func_0";
		}
		if(indexfunc > 9 || addVal == -1)
		{
			window.parent.parent.parent.document.getElementById(selectid).scrollIntoView(true);
		}
		setStyle(selectid);
	}
}

function searchFunction(name)
{
	if(window.parent.parent.parent.document.getElementById("syntaxdiv").style.display == 'block')
	{
		return;
	}

	functions=new Array();
	name=name.toLowerCase();
	var len=name.length;
	for(var i=0;i<nodes.length;i++)
	{
		var func = nodes[i].getAttribute("name");
		var fname=func.substring(0,len);
		fname = fname.toLowerCase();
		if(fname==name)
		{
			var str = functions.toString();
			if(str.indexOf(func) == -1)
			{
				functions.push(func);
			}
		}
	}
	functions.sort();
	
	if(functions.length == 0)
	{
//		functions.push("No Matching Function Found");
		funcExist = false;
	}
	else
	{
		funcExist = true;
	}
	if(funcName == "if" || funcName == "if ")
	{
		functions.push("if Loop");
	}
	else if(funcName == "for" || funcName == "for ")
	{
		functions.push("for Loop");
	}
	showFunctions();
}
function setStyle(id)
{
	selectFunc = id;
	if(document.getElementById(id))
	{
		document.getElementById(id).className="managerButBghover";
	}
	else if(window.parent.parent.parent.document.getElementById(id))
	{
		window.parent.parent.parent.document.getElementById(id).className = "managerButBghover";
	}	
}
function removeStyle(id)
{
	if(document.getElementById(id))
	{
		document.getElementById(id).className="";
	}
	else if(window.parent.parent.parent.document.getElementById(id))
	{
		window.parent.parent.parent.document.getElementById(id).className = "";
		
	}
}

var selectedFuncTxt = "";
var selectFunction = "";

function getSyntax(selfunc)
{
	var divshow;
	divshow =window.parent.parent.parent.document.getElementById("syntaxdiv");

	if(selfunc == "if Loop")
	{
		var syntax = "if (x==y):";
		divshow.innerHTML=syntax;
		divshow.style.left=x;
		divshow.style.top=y;
		eval("divshow.style.display='block';");
		return;
	}
	else if(selfunc == "for Loop")
	{
		var syntax = "for i in range(x,y):";
		divshow.innerHTML=syntax;
		divshow.style.left=x;
		divshow.style.top=y;
		eval("divshow.style.display='block';");
		return;
	}

	for(var i=0;i<nodes.length;i++)
	{
		var func = nodes[i].getAttribute("name");
		if(func==selfunc)
		{
			var syntax = nodes[i].getAttribute("syntax");
			divshow.innerHTML=syntax;
			divshow.style.left=x;
			divshow.style.top=y;
			eval("divshow.style.display='block';");
		}
	}
	
}
function completeTheFunction(fullFunction,func)
{
	var flen = func.length;
	var rectext = fullFunction;
	selectFunction = fullFunction;
	selectedFuncTxt = func;
	if(fullFunction == "if Loop")
	{
		rectext = "if (x==y):";
		//looping = true;
	}
	else if(fullFunction == "for Loop")
	{
		rectext = "for i in range(x,y):";
		//looping = true;
	}
	else
	{
		rectext = rectext+"(";
	}

	if(window.mainscreenframe)
	{
		window.mainscreenframe.insertInToScriptTtext(rectext,selectedFuncTxt,selectFunction);	
	}
	else if(window.parent.parent.parent.mainscreenframe)
	{
		window.parent.parent.parent.mainscreenframe.insertInToScriptTtext(rectext,selectedFuncTxt,selectFunction);
	}
	funcName="";
	hideFunctionsDiv();
}

EditH.prototype.insertScriptAtTypeMode = function (inNode,selectedFuncTxt,selFuncName)
{
	if(window.editor)
		{
			if(window.editor.is_moz)
			{
				var sel = window.editor.window.getSelection();
				var range;
				if(sel.getRangeAt(0))
				{
					range = sel.getRangeAt(0);
				}
				else
				{
					range = sel.createRange();
				}
				sel.removeAllRanges();
				//range.deleteContents();
				var container = range.startContainer;
				var pos = range.startOffset;
				var endOffSet = range.endOffset;
				if(pos==0 && endOffSet==0)
				{
					if(prevRange)
					{
						range = prevRange;
						endOffSet = range.endOffset;
					}
					container = prevContainer;
					pos = prevPos;
				}
				else
				{
					range=window.editor.document.createRange();
				}
				prevRange=range;
				prevContainer=container;
				prevPos = pos;
				if (container.nodeType==3 && inNode.nodeType==3) {
					container.insertData(pos, inNode.nodeValue);
					range.setEnd(container, pos+inNode.length);
					range.setStart(container, pos+inNode.length);
				} else {
					var afterNode;
					if (container.nodeType==3) {
						var textNode = container;
						container = textNode.parentNode;
						var text = textNode.nodeValue;
						var textBefore = text.substr(0,pos);
						var textAfter = text.substr(pos);
						var beforeNode = document.createTextNode(textBefore);
						var afterNode = document.createTextNode(textAfter);
						container.insertBefore(afterNode, textNode);
						container.insertBefore(inNode, afterNode);
						container.insertBefore(beforeNode, inNode);
						container.removeChild(textNode);
						range.setEnd(afterNode, 0);
						range.setStart(afterNode, 0);
						container.removeChild(beforeNode);
					} else {
						afterNode = container.childNodes[pos - 1];
						container.replaceChild(inNode, afterNode);
						prevPos = pos+inNode.childNodes.length;
					}
				}
				/*var range = window.editor.document.createRange();
				range.setStart(inNode, 0);
				sel.addRange(range);*/

				funcName = "";
				getSyntax(selFuncName);
			}
			else if(window.editor.is_ie)
			{
				var lineText = getLineContentFromSelection();
				tabindex = lineText.indexOf("\t");
				var tabcount = 0;
				var strCount = 0;
				var strToPaste = inNode.toString();
				if(tabindex > -1)
				{
					for(i=0;i<lineText.length;i++)
					{
						if(lineText.charAt(i) == "\t")
						{
							strToPaste = "\t"+strToPaste;
							tabcount++;
						}
					}
				}

				if(lineText.indexOf(selectedFuncTxt) != -1 && lineText.indexOf(selectedFuncTxt) > 0)
				{
					strCount = lineText.indexOf(selectedFuncTxt);
				}

				if(window.mainscreenframe)
				{
					funcClickMode = window.funcClickMode;
				}
				else if(window.parent.parent.parent.mainscreenframe)
				{
					funcClickMode = window.parent.parent.parent.funcClickMode;
				}
				
				
				if(keyDownMode || bsmode)
				{
					focusedRange.moveStart("character",0-selectedFuncTxt.length);
					focusedRange.moveEnd("character",-1);
					focusedRange.select();
				}
				else if(funcClickMode)
				{
					funcClickMode = false;
					if(window.mainscreenframe)
					{
						window.funcClickMode = funcClickMode;
					}
					else if(window.parent.parent.parent.mainscreenframe)
					{
						window.parent.parent.parent.funcClickMode = funcClickMode;
					}

					var startPos = 0;
					
					if(strCount > 0)
					{
						startPos = startPos + strCount;
					}

					focusedRange.moveStart("character",startPos);
					focusedRange.moveEnd("character",0);
					focusedRange.select();
					//focusedRange.moveStart("character",(EditH.h2t(inNode)).length);
					//focusedRange.moveEnd("character",(EditH.h2t(inNode)).length);
					//focusedRange.collapse();
					//focusedRange.select();
				}
				else
				{
					var startPos = 0;
					var endPos = 0;
					if(tabcount > 0)
					{
						startPos = tabcount;
						startPos = tabcount;
					}

					if(strCount > 0)
					{
						startPos = startPos + strCount;
					}
					focusedRange.moveStart("character",startPos);
					focusedRange.moveEnd("character",endPos);
					focusedRange.select();
				}
				
				//focusedRange.pasteHTML("<br>");
				focusedRange.moveStart("character",0);
				focusedRange.moveEnd("character",0);
				focusedRange.expand("word");
				focusedRange.select();
				if(looping)
				{
					strToPaste = strToPaste+"<br><br>";
					for(i=0;i<tabcount;i++)
					{
						strToPaste = strToPaste+"\t ";
					}
					strToPaste = strToPaste+"\t";
					looping = false;
				}
				focusedRange.pasteHTML(strToPaste);
				if(bsmode)
				{
					bsmode=false;
					//focusedRange.pasteHTML("<br>");
					focusedRange.moveStart("character",1);
					focusedRange.moveEnd("character",0);
				}
				focusedRange.moveStart("character",-1);
				focusedRange.moveEnd("character",0);
				focusedRange.collapse(true);
				focusedRange.expand("character");
				/*focusedRange.moveStart("character",-1);
				focusedRange.select();
				//focusedRange.pasteHTML("<br>");
				focusedRange.pasteHTML(inNode.toString());
				focusedRange.moveStart("character",-1);
				focusedRange.moveEnd("character",0);
				//focusedRange.select();
				focusedRange.collapse(true);
				focusedRange.expand("character");*/
				funcName = "";
				getSyntax(selFuncName);
								
			}
		}
}

function hideSyntaxDiv()
{
	if(window.parent.parent.parent.document.getElementById("syntaxdiv"))
	{
		var divtohide = window.parent.parent.parent.document.getElementById("syntaxdiv");
		if(divtohide.style.display == "block")
		{
			divtohide.innerHTML = "";
			divtohide.style.display = "none";
		}
	}
}

function hideFunctionsDiv()
{
	if(window.parent.parent.parent.document.getElementById("sug-func1"))
	{
		var divtohide = window.parent.parent.parent.document.getElementById("sug-func1");
		if(divtohide.style.display == "block")
		{
			divtohide.innerHTML = "";
			divtohide.style.display = "none";
		}
	}
}
/*function getLineNoForIE()
{
	try
	{
		var sel = document.selection;
		var range = sel.createRange();

		var parent = range.parentElement();
		pnode = getParentPNode(parent);
	
		el = window.editor.document.createElement("DIV");
		pnode.appendChild(el);
		el.innerText="";
		line = getLineNoForGecko();
		el.removeNode(true);
		return line;
	}
	catch(e)
	{
	}
	return 0;

}*/

function getLineContentFromSelection()
{
	var lineText;
	if(window.editor)
	{
		if(window.editor.is_ie)
		{
			var sel = window.editor.document.selection;
			var range = sel.createRange();
			var parent = range.parentElement();
			
			if(parent.tagName=="SPAN")
			{
				pnode = getParentPNode(parent);
			}
			lineText = pnode.innerText;
		}
		else
		{
			var sel = window.editor.window.getSelection();
			var insbw="false";
			var range;
			var textNode;
			var beforeNode;
			var afterNode;
			if(sel.getRangeAt(0))
			{
				range = sel.getRangeAt(0);
			}
			else
			{
				range = sel.createRange();
			}

			var container = range.startContainer;
			lineText = container.textContent;
		}
	}
	return lineText;
}
function keyPressHandler(evt)
{
	if(evt.type =="keypress")
	{
		window.status = evt.keyCode;
		var divtoshow=window.parent.parent.parent.document.getElementById("sug-func1");
		if(divtoshow.style.display == "block" && (evt.keyCode == 38 || evt.keyCode == 40))
		{
			return false;
		}
		
	}
}

function keyDownHandler(evt)
{
	if(evt.type =="keydown")
	{
		window.status = evt.keyCode;
		if(evt.keyCode == 9) {
			top.status ="Keydown as 9 = TAB";
			//window.editor.document.execCommand("indent",false,null);
			
			
			if(window.editor.is_moz)
			{
				var rectext = "\t";
				try
				{
					insertInToScript(rectext,"","");
					//EditH.prototype.insertScriptAtRecMode(rectext);
				}
				catch(e)
				{
					//				alert(e);
				}
				stopEvent(evt);
			}
		}
		else if(((evt.keyCode>=65 && evt.keyCode<=90)||(evt.keyCode>=97 && evt.keyCode<=123)) && !evt.ctrlKey && !evt.altKey)
		{
			var c = String.fromCharCode(evt.keyCode);
			if(!evt.shiftKey)
			{
				c = c.toLowerCase();	
			}
			funcName=funcName+c;
			searchFunction(funcName);
		}
		else if(evt.keyCode==13)
		{
			hideSyntaxDiv();
			var divtoshow=window.parent.parent.parent.document.getElementById("sug-func1");

			if(divtoshow.style.display=='block' && selectFunc!="")	
			{
				var ffName=window.parent.parent.parent.document.getElementById(selectFunc).innerHTML;
				keyDownMode = true;
				completeTheFunction(ffName,funcName);
				keyDownMode = false;
				return false;
			}
			funcName="";
			hideFunctionsDiv();
		}
		else if(evt.keyCode==27 || evt.keyCode==187)
		{
			funcName="";
			hideFunctionsDiv();
			hideSyntaxDiv();	
		}
		/*else if(evt.keyCode == 8)
		{
			var len1 = funcName.length-1;
			funcName=funcName.substr(0,len1);
			if(funcName!="")
			{
				searchFunction(funcName);
			}
			else
			{
				hideFunctionsDiv();
			}
		}*/
		else if(evt.keyCode == 8)
		{
			var lineText = getLineContentFromSelection();
			
			if(lineText.indexOf(funcName) != -1)
			{
				lineText = lineText.substring(lineText.indexOf(funcName),lineText.length);
			}

			funcName = lineText;
			var charToDel = funcName.substr(funcName.length-1,funcName.length);
			var len1 = funcName.length-1;
			funcName=funcName.substr(0,len1);
			if(funcName!="")
			{
				if(charToDel=="(")
				{
					bsmode = true;
					hideSyntaxDiv();
				}
				searchFunction(funcName);				
			}
			else
			{
				hideFunctionsDiv();
				hideSyntaxDiv();
			}
			var divtoshow=window.parent.parent.parent.document.getElementById("sug-func1");
			if(divtoshow.style.display == "block" && window.editor.is_moz)
			{
				return false;
			}
			
		}
		else if(evt.keyCode >= 37 && evt.keyCode <= 40)
		{
			get_lineno();
			var lno = document.getElementById("linenofld").value;

			var divtoshow=window.parent.parent.parent.document.getElementById("sug-func1");
			if(divtoshow.style.display == "block" && (evt.keyCode == 38 || evt.keyCode == 40))
			{
				var arg = 1;
				if(evt.keyCode == 38)
					arg = -1;
				selectFunctions(arg);
				return false;
			}
			else if(evt.keyCode == 38 || evt.keyCode == 40)
			{
				funcName="";
				hideSyntaxDiv();
			}
		}
		else if(evt.keyCode == 48 && evt.shiftKey)
		{
			hideSyntaxDiv();
		}	
		else if(evt.keyCode == 57 && evt.shiftKey)
		{
			var divtoshow=window.parent.parent.parent.document.getElementById("sug-func1");
			if(divtoshow.style.display == "block")
			{
				//focusedRange.moveStart("character",0-selectedFuncTxt.length-1);
				completeTheFunction(funcName,funcName);
				return false;
			}
			
		}
		


	}

	return true;
}
EditH.setWidthHeightFun = function ()
{
	document.getElementById("htmlContainer").height="100%";
/*
		if(learnModeScript=="fromlearnmode")
		{
			_HEIEdit = parent.document.body.offsetHeight;
			//alert(_HEIEdit);
			_DIVELEMEdit = document.getElementById("tabhei");
			if(_DIVELEMEdit)
			{
				//_DIVELEMEdit.height=_HEIEdit*0.2;
				_DIVELEMEdit.height=_HEIEdit-420;				
				//alert(_DIVELEMEdit.height);		
			}
		}
		else 
		{
			_HEIEdit = parent.document.body.offsetHeight;
			//alert(_HEI);
			_HEIEdit= _HEIEdit - 135;
			
			_DIVELEMEdit = document.getElementById("tabhei");
			 document.getElementById("htmlContainer").height=_HEIEdit;
			if(_DIVELEMEdit)
			{
				_DIVELEMEdit.height=_HEIEdit;
			}
		}
		*/
	
}
function insertSplTxtToFindLineNo(instext)
{
	if(instext !="")
	{
		if(isGecko)
		{
			instextArr = instext.split("\n");
			//alert("length"+rectextArr.length);
			var node = document.createElement("div");
			for(i=0;i<instextArr.length;i++)
			{
				curText = instextArr[i];
				if(curText=="")
				{
					continue;
				}
				curText = curText.replace("<VK_RETURN>","\n");
				//alert("curText"+curText);
				//alert("curText"+curText.match("\n"));
				curText = colorCodeScript(curText,"insert");
				cn = getNodeForText(curText);
				node.appendChild(cn);
			}
			//alert("node"+node);
			lineno=window.parent.editor.EditH.prototype.insertSplText(node);
			return lineno;
		}
		else
		{
			var lineno=window.parent.editor.EditH.prototype.insertSplText(instext);
			return lineno;
		}
	}
}

function getFocusedRange()
{
	if(window.editor)
	{
		if(window.editor.is_ie)
		{
			focusedRange.moveStart("character",0);
			focusedRange.moveStart("character",0);
			focusedRange.collapse();
			focusedRange.select();
		}
	}

}

function indent()
{
	var rectext = "\t";
	try
	{
		insertScriptAtRecMode(rectext);
	}
	catch(e)
	{
//				alert(e);
	}
}

function outdent()
{
	window.editor.document.execCommand("Outdent",false,null);
}

function getFocusToLastLine()
{
	if(window.editor)
	{
		if(window.editor.is_ie)
		{
			var nodes=window.editor.document.getElementsByTagName('P');
			var cont=EditH.getContent();

			if (window.editor.document.body.createTextRange())
			{
				var range = window.editor.document.body.createTextRange();
				range.collapse(true);
				range.moveEnd('character', cont.length-1);
				range.moveStart('character',cont.length-1);
				range.select();
			}
		}
		else
		{
			var sel = window.editor.window.getSelection();
			var range = window.editor.document.createRange();

			sel.removeAllRanges();

			var parent = range.startContainer;
			var childs = parent.documentElement.childNodes;
			var bodyNode = childs[1] ;

			var bChilds = bodyNode.childNodes;
			var prenode;
			for(var i=0;i<bChilds.length;i++)
			{
				cn = bChilds[i];
				if(cn.nodeName=="PRE")
				{
					prenode = cn;
					break;
				}
			}
			pos = prenode.childNodes.length;
			range.setEnd(prenode, pos);
			range.setStart(prenode, pos);
			sel.addRange(range);
		}
	}
}

function get_lineno()
{
	var nooflines = 1 ;
	
	if(window.editor.is_ie)
	{
		var sel = document.selection;
		var pos = sel.createRange();
		//pos.moveEnd("character",0);
		//pos.moveStart("character",0);
		//pos.select();
		
		//this is used for data configuration paste to work
		focusedRange = pos.duplicate();
		nooflines=getLineNoForIE();
		//nooflines=insertSplTxtToFindLineNo("");
	}
		
	else
	{
		nooflines=insertSplTxtToFindLineNo("");	
	}
	//alert("rewrwe"+nooflines);
	document.getElementById("lineno").innerHTML="Line No: " + nooflines;  
	document.getElementById("linenofld").value=nooflines;

}

function getParentPNode(node)
{
	if(!window.parent.recordMode)
	{
		while(node.tagName != 'P')
		{
			node = node.parentNode;
		}
	}
	return node;
}

function getLineNoForIE()
{
	try
	{
		var sel = document.selection;
		var range = sel.createRange();

		var parent = range.parentElement();
		pnode = getParentPNode(parent);
	
		el = window.editor.document.createElement("DIV");
		pnode.appendChild(el);
		el.innerText="";
		line = getLineNoForGecko();
		el.removeNode(true);
		return line;
	}
	catch(e)
	{
	}
	return 0;

}

function getLineNoForGecko()
{
	var cont=EditH.getContent();
	cont1=EditH.h2t(cont);
	cont1=cont1.substring(0,cont1.indexOf(""));
	//alert("*******"+cont1);
	var nl = "\n" ;
	var index ;
	var nooflines = 1 ;
	index = cont1.indexOf ( nl ) ;
	var prevInd = 0;
	while ( index != -1 ) 
	{
	      nooflines++ ;
		  lineContent = cont1.substring(index,cont1.length);
	      index = cont1.indexOf ( nl, index + 1 ); //start search after last match found
	}
	return nooflines;
}

function findBRNode(node)
{
	tempNode=node;
	brNode=node;
	var currentNode;
	try
	{
		while(tempNode.nodeName!="BR")
		{
			brNode = tempNode.nextSibling;
			currentNode = tempNode;
			tempNode=brNode;
		}
	}
	catch(e)
	{
		return currentNode.parentNode;
	}

	return brNode;
}	

	EditH.prototype.insertSplText = function (inNode) {
		if(window.editor)
		{
			if(window.editor.is_moz)
			{

				var lineNo=1;
				//alert("is_moz here");
				// get current selection
				var sel = window.editor.window.getSelection();
				var insbw="false";
				// get the first range of the selection
				// (there's almost always only one range)
				var range;
				var textNode;
				var beforeNode;
				var afterNode;
				if(sel.getRangeAt(0))
				{
					range = sel.getRangeAt(0);
				}
				else
				{
					range = sel.createRange();
				}

				// deselect everything
				sel.removeAllRanges();

				// remove content of current selection from document
				//	range.deleteContents();

				// get location of current selection
				var container = range.startContainer;
				var pos = range.startOffset;
				var endOffSet = range.endOffset;

				// make a new range for the new selection
				range=window.editor.document.createRange();

				if (container.nodeType==3 && inNode.nodeType==3) {

					// if we insert text in a textnode, do optimized insertion
					container.insertData(pos, inNode.nodeValue);

					// put cursor after inserted text
					range.setEnd(container, pos+inNode.length);
					range.setStart(container, pos+inNode.length);

				} else {
					var afterNode;
					if (container.nodeType==3) {

						if(container.parentNode.nodeName=="PRE")
						{
							nex = container.previousSibling;
						}
						else if(container.parentNode.nodeName=="BODY")
						{
							nex = container.parentNode.firstChild;
						}
						else
						{
							nex=container.parentNode.nextSibling;
						}

						if(nex.nodeName == "BR")
						{
							nex = nex.nextSibling;
						}

						brnode=findBRNode(nex);
						if(brnode.nodeName != "PRE")
						{
							parentnode = brnode.parentNode;
							parentnode.insertBefore(inNode, brnode);
							lineNo=getLineNoForGecko();
							parentnode.removeChild(inNode);
						}
						else
						{
							brnode.appendChild(inNode);
							lineNo=getLineNoForGecko();
							brnode.removeChild(inNode);
						}
						insbw="true";

					} else {

						// else simply insert the node
						afterNode = container.childNodes[pos];
						container.insertBefore(inNode, afterNode);
						prevPos = pos+inNode.childNodes.length;
						lineNo=getLineNoForGecko();
						container.removeChild(inNode);
					}

					range.setStart(container, pos);
					range.setEnd(container, endOffSet);

				}
				sel.addRange(range);
				focusedRange = range;
				return lineNo;
			}
			else
			{
				var sel = window.editor.document.selection;
				range;
				var elem;
				if(sel!=null)
				{
					//alert("inside if sel not null");
					range = sel.createRange();
					elem=range.parentElement();
					if(elem.nodeName=="P" && elem.childNodes.length==1)
					{
						if(clickEvent)
						{
							range.move("character",-1);
						}
						clickEvent = false;
					}
					range.pasteHTML(inNode);					
				}
				var lineNo = getLineNoForGecko();
				txtRange=window.editor.document.body.createTextRange();
				txtRange.findText("");
				txtRange.select();
				sel.clear();
				return lineNo;
			}
		}
}

function goToLine()
{   	
	hideFunctionsDiv();
	hideSyntaxDiv();
	var gotoline = prompt("Please enter Line Number","10")
		if(gotoline == null || gotoline == "null")
		{
			return;
		}
	var index=0;
	var childNodes = window.editor.document.documentElement.childNodes;
	//var gotoline="17";
	if(!isIE)
	{
		for (var i = 0; i < childNodes.length; i++) 
		{
			var child = childNodes[i];
			if(child.nodeName=="BODY")
			{
				var subchild=child.childNodes;
				for(var j = 0; j < subchild.length; j++)
				{
					sub=subchild[j];
					if(sub.nodeName=="PRE")
					{
						var prechilds=sub.childNodes;
						var lineno=0;
						for(var k = 0; k < prechilds.length; k++)
						{
							if(isGecko)
							{
								if(prechilds[k].nodeName=="BR")
								{
									lineno=lineno+1;


									if(gotoline==(lineno+1))
									{
										EditH.focus();
										if (typeof window.editor.document.createRange != 'undefined') 
										{
											sel =window.editor.window.getSelection();
											var range;
											if(sel.getRangeAt(0))
											{
												range = sel.getRangeAt(0);
											}
											else
											{
												range = sel.createRange();
												//range = focusedRange;
											}

											sel.removeAllRanges();
											range.setStart(prechilds[k+1],0);
											range.setEnd(prechilds[k+1],0);
											sel.addRange(range);
											break;							
										}     
									}//goto equals

								}//child is br

							}//isGecko      	

						}//for k
					}//if PRE tag

				}//for j
			}//if BODY

		}//for i
	}
	else if(isIE)
	{
		var linenum=0;
		var ptags=window.editor.document.getElementsByTagName("P");
		var totalLines=ptags.length;
		if((gotoline.length > 0 && !gotoline.match(/^[0-9]+$/g))||(gotoline==""))
		{
			gotoline=totalLines;
		}
		if(gotoline>totalLines)
		{
			gotoline=totalLines;
		}
		for(x=0;x<ptags.length;x++)
		{
			linenum=linenum+1;
			var txtVar=ptags[x].innerText;
			index=index+txtVar.length;
			if(txtVar=="")
			{
				index=index+1;
			}

			if(gotoline==linenum)
			{
				if(txtVar!="")
				{
					index=index-txtVar.length;
				}
				else
				{
					index=index-1;
				}
				break;
			}
			index=index+1;
		}
		var range = window.editor.document.body.createTextRange();
		range.collapse(true);
		//ind=getNoOfChars(gotoline);
		range.moveEnd('character', index);
		range.moveStart('character',index);
		range.select();
		range.scrollIntoView();
		//get_lineno();
		document.getElementById("lineno").innerHTML="Line No: " + gotoline;
	}
	get_lineno();
}
var isPaste = false;
function Paste()
{

	isPaste = true;
	if(isIE)
	{
		PastedText = window.editor.document.selection.createRange();
		PastedText.execCommand("Paste");
	}
	else
	{
		var pasteval=document.getElementById("pasteval").value;
		if(pasteval == '')
		{
			isPaste = false;
			return;
		}
		rectextArr = pasteval.split("\n");
		var node = document.createElement("div");
		for(i=0;i<rectextArr.length;i++)
		{
			curText = rectextArr[i];
			if(curText=="")
			{
				continue;
			}
			curText = curText.replace("<VK_RETURN>","\n");
			curText = colorCodeScript(curText,"insert");
			cn = getNodeForText(curText);
			node.appendChild(cn);
		}
		EditH.prototype.insertScriptAtRecMode(node);
	}
	isPaste = false;
}
 
function Cut()
{
	if(isIE)
	{
		CutTxt = window.editor.document.selection.createRange();
		CutTxt.execCommand("Cut");
	}
	else if(isGecko)
	{
		if (window.getSelection)
		{
			sel = window.editor.window.getSelection();
			document.getElementById("pasteval").value=sel;
		}
		else if (document.getSelection)
		{
			sel = window.editor.document.getSelection();
			document.getElementById("pasteval").value=sel;
		}
		else if (document.selection)
		{
			sel = window.editor.document.selection.createRange().text;
			document.getElementById("pasteval").value=sel;
		}
		var range;
		if(sel.getRangeAt(0))
		{
			range = sel.getRangeAt(0);
		}
		else
		{
			range = sel.createRange();
		}
		sel.removeAllRanges();
		range.deleteContents();
	}
}
  
function Copy()
{
	if(isIE)
	{
		CopiedTxt =window.editor.document.selection.createRange();
		CopiedTxt.execCommand("Copy");
	}
	else
	{
		if (window.getSelection)
		{
			copysel = window.editor.window.getSelection();
			document.getElementById("pasteval").value=copysel;
		}
		else if (document.getSelection)
		{
			copysel = window.editor.document.getSelection();
			document.getElementById("pasteval").value=copysel;
		}
		else if (document.selection)
		{
			copysel = window.editor.document.selection.createRange().text;
			document.getElementById("pasteval").value=copysel;
		}
	}
}
 
