<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xalan="org.apache.xalan.xslt.extensions.Redirect"
	extension-element-prefixes="xalan"> 
	<xsl:output method="html" version="4.0" encoding="UTF-8" indent="yes"/>
	<xsl:variable name="scriptDetails" select="/validation_report/report/script"/>
	<xsl:variable name="statusreport" select="/validation_report/status/name" />
	<xsl:variable name="severityreport" select="/validation_report/configuredseverities/severity" />
	<xsl:template match="/">
		<xalan:write select="concat($repdir,'/','top.html')">
			<html>
				<head>
				<title>QEngine Web Test Studio : Script Report</title> 
				</head>
				<body bgcolor="#FFFFFF" text="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
					<table width="100%" border="0" cellspacing="0" cellpadding="0">
						<tr>
							<td background="/qehome/images/bg_top.gif" height="69" valign="bottom">
								<div align="center">
									<table width="45%" border="0" cellspacing="0" cellpadding="0" align="left">
									<tr>
										<td><i><font color="#FFFFFF"></font></i></td>
										<td><i><font color="#FFFFFF"><b>QEngine - Web Client Test Report</b></font></i></td>
									</tr>
									<tr>
										<td><br></br></td>
										<td></td>
									</tr>
									</table>
								</div>
								</td> 
						</tr>
					</table>
				</body>
			</html>
		</xalan:write>
		<xalan:write select="concat($repdir,'/','left.html')">
			<html>
				<head>
					<xsl:text disable-output-escaping="yes">
					<![CDATA[
<style type="text/css">
body { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
.bodytext { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
a { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal; text-decoration:underline }
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; padding-left: 4px; font-weight:bold}
.thstyle2 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:12px; font-style:normal;}
.thstyle2 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-weight:bold; font-style:normal;}
.thstyle11 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.style4 {color: #FF0000}
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; font-weight:bold}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000CC0}
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
					<script language="JavaScript">
					function idGet(id) 
					{
						if (typeof(document.getElementsByName) != "undefined") 
						{
							var imgColl = document.getElementsByName("scriptimage");
							for (i = 0; i < imgColl.length; i++)
							{
								var x = imgColl[i];
								if(!x)
									continue;
								x.src = "/framework/images/ball.gif";
							}
						}
						if (typeof(document.getElementById) != "undefined") 
						{
							return document.getElementById(id);
						} else {
							return document.all[id];
						}
						
					}

					</script>
					]]>
					</xsl:text>
					<title>QEngine Web Test Studio : Script Report</title>
				</head>
				<body bgcolor="#ffffff" text="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
					<br></br>
					<table width="100%" border="0" cellspacing="0" cellpadding="3">
						<tr>
							<td colspan="3" class="tdlinkflevel" align="center"><a target="main" href="scriptsummary.html">Scripts</a></td>
						</tr>

						<xsl:for-each select="$scriptDetails">
							<xsl:variable name="keyvalwithservice" select="@namewithservice"/>
							<xsl:variable name="keyval" select="@name"/>
							<tr valign="middle">
								<td></td>
								<td width="8">
									<img width="8" height="7" src="/framework/images/ball.gif" id="{concat($keyval,'')}" name="scriptimage"/>
								</td>
								<td class="tdlinkflevel">
									<a target="main" href="{concat('./',$keyvalwithservice,'/',$keyval,'.html')}"> <xsl:value-of select="$keyval"/></a>
								</td>
							</tr>			
						</xsl:for-each>
					</table>
				</body>
			</html>
		</xalan:write>
		<xsl:for-each select="$scriptDetails">
			<xsl:variable name="scriptnode" select="."/>
			<xsl:variable name="scriptcasenode" select="$scriptnode/scriptcases/case"/>
			<xsl:variable name="keyvalwithservice" select="@namewithservice"/>
			<xsl:variable name="keyval" select="@name"/>
			<xsl:variable name="logsurl" select="@logsurl"/> 
			<xsl:value-of select="$keyval"/>
			<xalan:write select="concat($repdir,'/',$keyvalwithservice,'/',$keyval,'.html')">
				<html>
					<head>
						<xsl:text disable-output-escaping="yes">
						<![CDATA[
<style type="text/css">
body { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
.bodytext { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
a { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal; text-decoration:underline }
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; padding-left: 4px; font-weight:bold}
.thstyle2 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:12px; font-style:normal;}
.thstyle2 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-weight:bold; font-style:normal;}
.thstyle11 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.style4 {color: #FF0000}
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; font-weight:bold}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000CC0}
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
<script>
function openBrWindow(theURL,winName) { //v2.0
	while(winName.indexOf(" ")>0)
		{
			winName = winName.replace(" ","_");
		}

	window.open(theURL,winName,'scrollbars=yes,width=800,height=600,screenX=100,screenY=150,location=no,directories=no,status=no,menubar=yes,toolbar=no,resizable=yes');
}
</script>
						]]>
						</xsl:text>
					<title>QEngine Web Test Studio : Script Report</title>
					</head>

					<body bgcolor="#FFFFFF" text="#000000">
						<h2><a name="scriptLink"></a></h2>
						<table width="90%" border="0" cellspacing="0" cellpadding="0" align="center">
							<tr>
								<td align="left" bgcolor="#ffffff"><a class="tdlinkflevel" href='../../scriptsummary.html'>Scripts Summary</a></td>
								<td align="right" bgcolor="#ffffff"><a href="#testcaseLink" class="tdlinkflevel">Goto Testcase Report</a></td>
							</tr>
						</table>
						<br></br><br></br>
						<table width="90%" border="0" align="center" cellpadding="0" cellspacing="0">
						  <tr> 
							  <td><h3>Script Details</h3></td>
						    <td align="right"><!--select name="select" class="drpDown">
						        <option value="Select Date and Time">Select Date and Time</option>
						      </select--></td>
						  </tr>
						  <tr> 
						    <td height="1" colspan="2"><span class="reporthline"><img src="/framework/images/spacer.gif" width="1" height="1"/></span></td>
						  </tr>
						</table><br></br>
						<div align="center">
							<table width="90%" border="0" cellspacing="0" cellpadding="0" class="reporttablebg">
								<tr>
									<td>
										<table width="100%" border="0" cellspacing="1" align="center" cellpadding="3">
											<tr class="thstyle"  align="center"> 
												<th width="29%" class="thstyle"> 
													Name
												</th>
												<th width="21%" class="thstyle"> 
													Status
												</th>
												<th width="26%" class="thstyle"> 
													Debug Information
												</th>
												<th width="12%" class="thstyle"> 
													Failure
												</th>
												<th width="12%" class="thstyle"> 
													Passed
												</th>
											</tr>
										<xsl:variable name="idName" select="@name"/>
										<xsl:variable name="idNameWithService" select="@namewithservice"/>
										<xsl:variable name="status" select="@status"/>
										<xsl:variable name="debugInfo" select="@debuginfo"/>
											<tr bgcolor="#FFFFFF" align="center"> 
												<td align="left" class="caseidstyle" width="26%"><xsl:value-of select="$idNameWithService"/>
												</td>
												<td class="tdstyle" width="26%"><xsl:value-of select="$status"/>
												</td>
												<td class="tdstyle" width="26%"><xsl:value-of select="$debugInfo"/>
												</td>
												<td class="tdstyle" width="22%"><xsl:value-of select="count($scriptcasenode[@status!='Completed' and @status!='PASSED'])"/>
												</td>
												<td class="tdstyle" width="22%"><xsl:value-of select="count($scriptcasenode[@status='PASSED' or @status='COMPLETED'])"/>
												</td>
											</tr>
										</table>
									</td>
								</tr>
							</table>
							<table width="90%" border="0" cellspacing="0" cellpadding="0" class="">
								<tr>
									<td bgcolor="#FFFFFF" class="tdlinkflevel" align="right"><xsl:value-of select="concat('',' ')"/> <a target="_new" class="tdlinkflevel" href="{concat('/','framework','/','jsp','/','DirectoryList.jsp?file=',$pathToReachAttachmentsDir)}">attachments</a><xsl:value-of select="concat('',' ')"/><a target="_new" class="tdlinkflevel" href="{concat($logsurl,$pathToReachLogsDir,'/',$keyvalwithservice,'/testout.txt')}">outfile</a><xsl:value-of select="concat('',' ')"/> <a target="_new" class="tdlinkflevel" href="{concat($logsurl,$pathToReachLogsDir,'/',$keyvalwithservice,'/testerr.txt')}">errfile</a>
									</td>
								</tr>
							</table>
							
							<br></br>
							<table width="90%" border="0" cellspacing="0" cellpadding="0" class="reporttablebg">
								<tr>
								<xsl:choose> <xsl:when test="document(concat($respxmldir,'/',$keyvalwithservice,'/request.xml'))">

										<td class="reporth3" width="110"><a href="javascript:openBrWindow('{concat($logsurl,$pathToReachReportsDir,'/',$keyvalwithservice,'/request.xml')}','Request');">WSDL Request</a></td>
										</xsl:when>
										<xsl:otherwise><br></br><br></br><td height="250"><b>Request Generation Failed. Refer the logs to know the reason for the failure.</b></td><br></br><br></br>
										</xsl:otherwise>
									</xsl:choose>
									<xsl:choose>
										<xsl:when test="document(concat($respxmldir,'/',$keyvalwithservice,'/response.xml'))">
										<td class="reporth3"><a href="javascript:openBrWindow('{concat($logsurl,$pathToReachReportsDir,'/',$keyvalwithservice,'/response.xml')}','Responae');">WSDL Response</a></td>
									</xsl:when>
									<xsl:otherwise>
										<td height="250"><b>Response Generation Failed. Refer the logs to know the reason for the failure.</b></td></xsl:otherwise>
								</xsl:choose>
						</tr>
							</table>
						<xsl:choose>
						<xsl:when test="count($scriptcasenode)>0">
						<h2><a name="detailedLink"></a></h2>

							<table width="90%" border="0"  cellspacing="0" cellpadding="0" >
								<tr>
									<td bgcolor="#FFFFFF">
										<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0">
										  <tr> 
										    <td class="reporth3">Detailed Report</td>
										  </tr>
										</table>
									</td>
								</tr>						
								<tr>
									<td>
										<table class="reporttablebg" width="100%" border="0" cellspacing="1" align="center" cellpadding="4">
											<tr class="thstyle" align="center"> 
												<td width="29%" class="thstyle"> 
													Action
												</td>
												<td width="21%" class="thstyle"> 
													Status
												</td>
												<td width="25%" class="thstyle"> 
													Debug Information
												</td>
												<td width="25%" class="thstyle"> 
													Remarks
												</td>
											</tr>
											<xsl:for-each select="$scriptnode/scriptcases/case">
											<xsl:sort order="ascending" select="@time" data-type="number"/>
												<xsl:variable name="casenode" select="."/>
												<xsl:variable name="screenshottrue" select="true"/>
												<xsl:variable name="idFromScript" select="@id"/>
												<xsl:variable name="severity" select="@severity"/>
												<xsl:variable name="status" select="@status"/>
												<xsl:variable name="debugInfo" select="@debuginfo"/>
												<xsl:variable name="remarks" select="@logmessage"/>
												<xsl:variable name="isscreenshot" select="@screenshot"/>
												<xsl:variable name="scriptid" select="@scriptid"/>
												<tr bgcolor="#ffffff" align="center"> 
													<td align="left" class="caseidstyle" bgcolor="#FFFFFF"><xsl:value-of select="$idFromScript"/></td>
													<td class="tdstyle" bgcolor="#FFFFFF"><xsl:value-of select="$status"/> </td>
													<td class="tdstyle" bgcolor="#FFFFFF" height="10"><xsl:value-of select="$debugInfo"/> </td>
							<xsl:choose>
								<xsl:when test="$isscreenshot>0">
							           <xsl:variable name="screenshotname" select="@screenshotname"/>
								    <td class="tdstyle" bgcolor="#FFFFFF" height="10">
									    <a href="{concat('screenshots/',$screenshotname)}" target="_new"> <xsl:value-of select="$remarks"/></a>
								    </td>
				   			    </xsl:when>	
							    <xsl:otherwise>
								<td class="tdstyle" bgcolor="#FFFFFF" height="10">
									<xsl:value-of select="$remarks"/> 
									<xsl:if test="$keyval!=@scriptid">
									  <xsl:text>&#x0a;</xsl:text>- Script : <xsl:value-of select="$scriptid"/>
									</xsl:if>	
								</td>
							    </xsl:otherwise>
							</xsl:choose>
												</tr>
											</xsl:for-each>
										</table>
									</td>
								</tr>								
							</table>
						</xsl:when>
						<xsl:otherwise>
							<table width="80%" align="center" cellpadding="0" cellspacing="0" border="0" bgcolor="#ffffff">
						   	    <tr align="center"> 
								<td class="messagestyle">
									<img src="/qehome/images/noscriptfail.gif" alt="NO SCRIPT FAILURES"/>
						   		</td>
							   </tr>
							</table>
						</xsl:otherwise>
						</xsl:choose>
						</div>
		
			<xsl:variable name="scriptnode1" select="."/>
			<xsl:variable name="casereport" select="$scriptnode1/testcases/case"/>
			<xsl:variable name="keyvalwithservice" select="@namewithservice"/> 
			<xsl:variable name="keyval" select="@name"/> 
			<xsl:variable name="logsurl" select="@logsurl"/> 
						<h2><a name="testcaseLink"></a></h2>
			
						<table width="60%" border="0" cellspacing="0" cellpadding="0" align="right">
							<tr>
								<td align="right" bgcolor="#ffffff" class="tdlinkflevel"><a href="#scriptLink" class="tdlinkflevel">Goto Script Report</a>|<a class="tdlinkflevel" href='../../scriptsummary.html'>Scripts Summary</a></td>
							</tr>
						</table>
						<br></br><br></br>
						<table width="90%" border="0" align="center" cellpadding="0" cellspacing="0">
						  <tr> 
							  <td> <h3>Testcase Details</h3></td>
						    
						  </tr>
						  <tr> 
						    <td colspan="2" height="1"><span class="reporthline"><img src="/framework/images/spacer.gif" width="1" height="1"/></span></td>
						  </tr>
						</table><br></br>
						

					<xsl:choose>
					<xsl:when test="count($casereport)>0">
						<table width="90%" align="center" cellpadding="0" cellspacing="0" border="0" bgcolor="#A5AA5A">
        					  <tr> 
					            <td bgcolor="#FFFFFF" align="left"> <h5><font face="Times New Roman, Verdana, Arial, Helvetica, zurich" color="#000000">Report Summary</font></h5></td>
					          </tr>
					          <tr> 
					            <td>       
					                <table width="100%" align="center" cellpadding="5" cellspacing="1" border="0">
					                    <tr class="thstyle" >
				  			      <th>Severity</th>
							<xsl:for-each select="$statusreport">
					                      <th><xsl:value-of select="."/></th>	
				                        </xsl:for-each>
					                      <th>Total</th>
					                    </tr>
			   
				 			<xsl:for-each select="$severityreport">
							  <xsl:variable name="sevname" select="@name"/>	
							    <tr align="center" class="tdstyle" bgcolor="#FFFFFF">
								<td><center><font color="{@color}"><xsl:value-of select="$sevname"/></font></center></td>
	   							<xsl:for-each select="$statusreport">
						        	  <xsl:variable name="statusvalue" select="."/>
								   <td><xsl:value-of select="count($casereport[@status=$statusvalue and @severity=$sevname])"/></td>	
								</xsl:for-each>					
				  				<td><xsl:value-of select="count($casereport[@severity=$sevname])"/></td>
							   </tr>	
							</xsl:for-each>

							  <tr align="center" class="tdstyle" bgcolor="#FFFFFF">
								<td>Total</td>
				 			<xsl:for-each select="$statusreport">
							  <xsl:variable name="statusvalue" select="."/>
							  <xsl:variable name="statcount" select="count($casereport[@status=$statusvalue])"/>		
						          <xsl:choose>
							    <xsl:when test="$statcount>0">
					                      <td > <a href="#{$statusvalue}"><xsl:value-of select="$statcount"/></a></td>
				   			    </xsl:when>	
							    <xsl:otherwise>
				  			      <td > <xsl:value-of select="$statcount"/></td>
							    </xsl:otherwise>
							  </xsl:choose>
							</xsl:for-each>	
				                    	      <td> <xsl:value-of select="count($casereport)"/></td>			   			  
							  </tr>					
							</table>
						    </td>    
					          </tr>
						  <tr>
						    <td bgcolor="#FFFFFF" class="tdlinkflevel" align="right"><a target="_new" class="tdlinkflevel" href="{concat($logsurl,$pathToReachLogsDir,'/',$keyvalwithservice,'/testout.txt')}">outfile</a><xsl:value-of select="concat('',' ')"/> <a target="_new" class="tdlinkflevel" href="{concat($logsurl,$pathToReachLogsDir,'/',$keyvalwithservice,'/testerr.txt')}">errfile</a>
						    </td>
						  </tr>
					        </table>

						<div align="center">
							<br></br>
							<br></br>
							<table width="90%" border="0" cellspacing="0" cellpadding="0" >
								<tr>
									<td class="reporth3" bgcolor="#FFFFFF" align="left">Detailed Report
									</td>
								</tr>
								<tr>
									<td>
										<table class="reporttablebg" width="100%" border="0" cellspacing="1" align="center" cellpadding="4" >
											<tr  class="thstyle" align="center"> 
												<td width="25%" class="thstyle"> 
													Id
												</td>
												<td width="15%" class="thstyle"> 
													Severity
												</td>
												<td width="17%" class="thstyle"> 
													Status
												</td>
												<td width="20%" class="thstyle"> 
													Debug Information
												</td>
												<td width="23%" class="thstyle"> 
													Remarks
												</td>
											</tr>
											<xsl:for-each select="$scriptnode1/testcases/case">

											<xsl:sort order="ascending" select="@time" data-type="number"/>
												<xsl:variable name="casenode" select="."/>
												<xsl:variable name="idFromScript" select="@id"/>
												<xsl:variable name="severity" select="@severity"/>
												<xsl:variable name="status" select="@status"/>
												<xsl:variable name="debugInfo" select="@debuginfo"/>
												<xsl:variable name="remarks" select="@logmessage"/>
												<xsl:variable name="scriptid" select="@scriptid"/>
												<tr bgcolor="#ffffff" align="center"> 
													<td align="left" class="caseidstyle" bgcolor="#FFFFFF"><xsl:value-of select="$idFromScript"/></td>
													<td class="tdstyle" bgcolor="#FFFFFF"><xsl:value-of select="$severity"/> </td>
													<td class="tdstyle" bgcolor="#FFFFFF"><xsl:value-of select="$status"/> </td>
													<td class="tdstyle" bgcolor="#FFFFFF" height="10"><xsl:value-of select="$debugInfo"/> </td>
													<td class="tdstyle" bgcolor="#FFFFFF" height="10"><xsl:value-of select="$remarks"/> 
			<xsl:if test="$keyval!=@scriptid">
				<xsl:text>&#x0a;</xsl:text>- Script : <xsl:value-of select="$scriptid"/>
			</xsl:if>	
								</td>
												</tr>
											</xsl:for-each>
										</table>
									</td>
								</tr>
							</table>
						</div>
					</xsl:when>
					<xsl:otherwise>
						<table width="80%" align="center" cellpadding="0" cellspacing="0" border="0" bgcolor="#ffffff">
						   <tr align="center"> 
							<td class="messagestyle">
								<img src="/qehome/images/notestconf.gif" alt="NO TEST CASE CONFIGURED"/>
						   	</td>
						   </tr>
						</table>
					</xsl:otherwise>
					</xsl:choose>
					</body>
				</html>
			</xalan:write> 
		</xsl:for-each>
		<xalan:write select="concat($repdir,'/','scriptsummary.html')">
			<html>
				<head>
					<xsl:text disable-output-escaping="yes">
					<![CDATA[
<style type="text/css">
body { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
.bodytext { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
a { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal; text-decoration:underline }
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; padding-left: 4px; font-weight:bold}
.thstyle2 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:12px; font-style:normal;}
.thstyle2 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-weight:bold; font-style:normal;}
.thstyle11 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.style4 {color: #FF0000}
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; font-weight:bold}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000CC0}
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
					]]>
					</xsl:text>
					<title>QEngine Web Test Studio : Script Summary</title>
				</head>
				<body bgcolor="#FFFFFF" text="#000000">
				<br></br>
						<table width="90%" border="0" align="center" cellpadding="0" cellspacing="0">
						  <tr> 
						    <td class="reporth3">Script Summary</td>
						    <td align="right"><!--select name="select" class="drpDown">
						        <option value="Select Date and Time">Select Date and Time</option>
						      </select--></td>
						  </tr>
						  <tr> 
						    <td colspan="2" height="1"><span class="reporthline"><img src="/framework/images/spacer.gif" width="1" height="1"/></span></td>
						  </tr>
						</table><br></br>
					   <br></br>
					   <table align="center" width="90%" border="0" cellspacing="0" cellpadding="0"  class="reporttablebg">
					        <tr> 
					            <td>       
					                <table width="100%" align="center" cellpadding="3" cellspacing="1" border="0">
					                    <tr align="center" class="thstyle">
				  			      <th width="26%" rowspan="2" class="thstyle">Name</th>
					                      <th rowspan="1" colspan="2" class="thstyle">Script Result</th>
							      <th rowspan="1" colspan="5" class="thstyle">Testcase Result</th>
							      <th rowspan="1" colspan="2" class="thstyle">Logs</th>
							      <th rowspan="1" colspan="2" class="thstyle">Output</th>
							    </tr>
							    <tr align="center" class="thstyle">
					                      <th rowspan="1" class="thstyle">Failure</th>
					                      <th rowspan="1" class="thstyle">Passed</th>
							      <th rowspan="1" class="thstyle">Passed</th>
							      <th rowspan="1" class="thstyle">Failed</th>
							      <th rowspan="1" class="thstyle">Incomplete</th>
							      <th rowspan="1" class="thstyle">Error</th>
							      <th rowspan="1" class="thstyle">Total</th>
							      <th rowspan="1" class="thstyle">Outfile</th>
							      <th rowspan="1" class="thstyle">Errfile</th>
							      <th rowspan="1" class="thstyle">Request</th>
							      <th rowspan="1" class="thstyle">Response</th>
					                    </tr>
							<xsl:for-each select="$scriptDetails">
							<xsl:variable name="scriptnode1" select="."/>
							<xsl:variable name="scriptcasenode" select="$scriptnode1/scriptcases/case"/>
							<xsl:variable name="casereport" select="$scriptnode1/testcases/case"/>
							<xsl:variable name="keyvalwithservice" select="@namewithservice"/>
							<xsl:variable name="keyval" select="@name"/>
							    <tr bgcolor="#ffffff">
								   <td  width="26%" class="tdstyle" align="left"><a  target="main" href="{concat('./',$keyvalwithservice,'/',$keyval,'.html')}"> <xsl:value-of select="$keyvalwithservice"/></a></td>
								   <td class="tdstyle" align="center"><a target="main" href="{concat('./',$keyvalwithservice,'/',$keyval,'.html#scriptLink')}"><xsl:value-of select="count($scriptcasenode[@status!='Completed' and @status!='PASSED'])"/></a></td>
								   <td class="tdstyle" align="center"><a target="main" href="{concat('./',$keyvalwithservice,'/',$keyval,'.html#detailedLink')}"><xsl:value-of select="count($scriptcasenode[@status='PASSED' or @status='COMPLETED'])"/></a></td>
								   <td class="tdstyle" align="center"><a  target="main" href="{concat('./',$keyvalwithservice,'/',$keyval,'.html#testcaseLink')}"><xsl:value-of select="count($casereport[@status='PASSED'])"/></a></td>
								   <td class="tdstyle" align="center"><a  target="main" href="{concat('./',$keyvalwithservice,'/',$keyval,'.html#testcaseLink')}"><xsl:value-of select="count($casereport[@status='FAILED'])"/></a></td>
								   <td class="tdstyle" align="center"><a  target="main" href="{concat('./',$keyvalwithservice,'/',$keyval,'.html#testcaseLink')}"><xsl:value-of select="count($casereport[@status='INCOMPLETE'])"/></a></td>
								   <td class="tdstyle" align="center"><a  target="main" href="{concat('./',$keyvalwithservice,'/',$keyval,'.html#testcaseLink')}"><xsl:value-of select="count($casereport[@status='Data_Error' or @status='Environment_Error'])"/></a></td>
								   <td class="tdstyle" align="center"><a  target="main" href="{concat('./',$keyvalwithservice,'/',$keyval,'.html#testcaseLink')}" ><xsl:value-of select="count($casereport)"/></a></td>
								   <td  class="tdlinkflevel" align="center"><a target="_new" class="tdlinkflevel" href="{concat($pathToReachLogsDir,'/',$keyvalwithservice,'/testout.txt')}"><img src="/framework/images/reportoutfile.gif" border="0"/></a></td>
								   <td class="tdlinkflevel" align="center"><a target="_new" class="tdlinkflevel" href="{concat($pathToReachLogsDir,'/',$keyvalwithservice,'/testerr.txt')}"><img src="/framework/images/reporterrfile.gif" border="0"/></a></td>
								   <td class="tdlinkflevel" align="center"><xsl:choose> <xsl:when test="document(concat($respxmldir,'/',$keyvalwithservice,'/request.xml'))"><a target="_new" class="tdlinkflevel" href="{concat($pathToReachReportsDir,'/',$keyvalwithservice,'/request.xml')}"><img src="/framework/images/reportoutfile.gif" border="0"/></a></xsl:when><xsl:otherwise>ERR_Req</xsl:otherwise></xsl:choose></td>
								   <td class="tdlinkflevel" align="center"><xsl:choose> <xsl:when test="document(concat($respxmldir,'/',$keyvalwithservice,'/response.xml'))"><a target="_new" class="tdlinkflevel" href="{concat($pathToReachReportsDir,'/',$keyvalwithservice,'/response.xml')}"><img src="/framework/images/reportoutfile.gif" border="0"/></a></xsl:when><xsl:otherwise>ERR_Resp</xsl:otherwise></xsl:choose></td>
							    </tr>
							</xsl:for-each>
							</table>
						    </td>
						</tr>
					   </table>
				</body>
			</html>
		</xalan:write>
		<xalan:write select="concat($repdir,'/','smartsummary.html')">
			<html>
				<head>
					<xsl:text disable-output-escaping="yes">
					<![CDATA[
<style type="text/css">
body { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
.bodytext { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal}
a { font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px;font-weight: normal; font-style:normal; text-decoration:underline }
.reporthline {width: 100%;display: block;border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color: #003267;}
.reporth3 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;letter-spacing: 1px;}
.reporth2 {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 11px; color:#999999;}
.thstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; padding-left: 4px; font-weight:bold}
.thstyle2 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:12px; font-style:normal;}
.thstyle2 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#edebeb; background-image:url(/qehome/images/headerbg.gif); border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-weight:bold; font-style:normal;}
.thstyle11 {font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.style4 {color: #FF0000}
.thstyle1 { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#f7f6f6; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal; font-weight:bold}
.thredstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#fedddd; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.thgreenstyle { font-family: Verdana, Arial, Helvetica, sans-serif; background-color:#d1fecf; border-right:#b0b0b1 1px solid; border-bottom:#b0b0b1 1px solid; color:#000000; font-size:11px; font-style:normal;}
.reporttablebg { border: 1px #b0b0b1 solid; }
.subthstyle {  font: bold 12px Verdana, Arial, Helvetica, sans-serif; color: #000000}
.caseidstyle {  font: 10px Verdana, Arial, Helvetica, sans-serif; color: #000000; width:25%}
.tdstyle{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; color: #000CC0}
.tdstyle1{  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #FFFFFF}
.tdstyle0 {  font: 11px Verdana, Arial, Helvetica, sans-serif; border-right:#b0b0b1 1px solid; background-color: #f7f7f7}
.tdlinkflevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold; LINE-HEIGHT: 17px }
.tdlinkslevel { COLOR: #000000; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 10px; LINE-HEIGHT: 15px }
.bgwhiteforange { BACKGROUND-COLOR: #ffffff; COLOR: #000033; FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-SIZE: 11px; FONT-WEIGHT: bold }
a.tdstyle{  text-decoration: underline;}
a.tdstyle:visited{ text-decoration: underline;}
a.tdstyle:active{text-decoration: underline;}
a.tdstyle:hover{text-decoration: underline;}
a.tdlinkflevel{  text-decoration: underline;}
a.tdlinkflevel:visited{text-decoration: underline;}
a.tdlinkflevel:active{text-decoration: underline;}
a.tdlinkflevel:hover{text-decoration: underline;}
</style>
					]]>
					</xsl:text>
					<title>QEngine Web Test Studio : Smart Summary</title>
				</head>
				<body bgcolor="#FFFFFF" text="#000000">
				<br></br>
						<table width="90%" border="0" align="center" cellpadding="0" cellspacing="0">
						  <tr> 
						    <td class="reporth3">Smart Summary</td>
						  </tr>
						  <tr> 
						    <td height="1"><span class="reporthline"><img src="/framework/images/spacer.gif" width="1" height="1"/></span></td>
						  </tr>
						</table><br></br>
					   <br></br>
					   <table align="center" width="90%" border="0" cellspacing="0" cellpadding="0"  class="reporttablebg">
					        <tr> 
					            <td>       
					                <table width="100%" align="center" cellpadding="5" cellspacing="1" border="0">
					                    <tr align="center" class="thstyle">
				  			      <th width="20%" rowspan="2" class="thstyle">Name</th>
				  			      <th width="26%" rowspan="2" class="thstyle">Debug Info</th>
							      <th rowspan="1" colspan="2" class="thstyle">Logs</th>
							      <th rowspan="1" colspan="2" class="thstyle">Output</th>
						      	    </tr>
						      	    <tr>
							      <th rowspan="1" class="thstyle">Outfile</th>
							      <th rowspan="1" class="thstyle">Errfile</th>
							      <th rowspan="1" class="thstyle">Request</th>
							      <th rowspan="1" class="thstyle">Response</th>
					                    </tr>
							<xsl:for-each select="$scriptDetails">
							<xsl:variable name="scriptnode1" select="."/>
							<xsl:variable name="keyvalwithservice" select="@namewithservice"/>
							<xsl:variable name="keyval" select="@name"/>
							<xsl:variable name="debugInfo" select="@debuginfo"/>
							    <tr bgcolor="#ffffff">
								    <td  width="20%" class="tdstyle" align="left"> <xsl:value-of select="$keyvalwithservice"/></td>
								    <td  width="26%" class="tdstyle" align="left"> <xsl:value-of select="$debugInfo"/></td>
								   <td  class="tdlinkflevel" align="center"><a target="_new" class="tdlinkflevel" href="{concat($pathToReachLogsDir,'/',$keyvalwithservice,'/testout.txt')}"><img src="/framework/images/reportoutfile.gif" border="0"/></a></td>
								   <td class="tdlinkflevel" align="center"><a target="_new" class="tdlinkflevel" href="{concat($pathToReachLogsDir,'/',$keyvalwithservice,'/testerr.txt')}"><img src="/framework/images/reporterrfile.gif" border="0"/></a></td>
								   <td class="tdlinkflevel" align="center"><xsl:choose> <xsl:when test="document(concat($respxmldir,'/',$keyvalwithservice,'/request.xml'))"><a target="_new" class="tdlinkflevel" href="{concat($pathToReachReportsDir,'/',$keyvalwithservice,'/request.xml')}"><img src="/framework/images/reportoutfile.gif" border="0"/></a></xsl:when><xsl:otherwise>ERR_Req</xsl:otherwise></xsl:choose></td>
								   <td class="tdlinkflevel" align="center"><xsl:choose> <xsl:when test="document(concat($respxmldir,'/',$keyvalwithservice,'/response.xml'))"><a target="_new" class="tdlinkflevel" href="{concat($pathToReachReportsDir,'/',$keyvalwithservice,'/response.xml')}"><img src="/framework/images/reportoutfile.gif" border="0"/></a></xsl:when><xsl:otherwise>ERR_Resp</xsl:otherwise></xsl:choose></td>								   
							    </tr>
							</xsl:for-each>
							</table>
						    </td>
						</tr>
					   </table>
				</body>
			</html>
		</xalan:write>
		<xalan:write select="concat($repdir,'/','index.html')">
			<html>
				<head>
				<title>QEngine Web Test Studio : Script Report</title>
				</head>
					<frameset rows="*" framespacing="0" border="1" frameborder="YES" cols="170,*">
						<frame src="left.html" scrolling="auto" name="left"/>
						<frame src="scriptsummary.html" name="main"/>
					</frameset>
				<noframes> 
					<body bgcolor="#FFFFFF" text="#000000">
					</body>
				</noframes> 
			</html>
		</xalan:write>
	</xsl:template>
</xsl:stylesheet>

