export HELP="--help"


if [ "test"$1 == "test"$HELP ]
then
	echo For execution Usage: sh CommandLineWebTest.sh . SERVER_NAME SERVER_PORT BROWSER BROWSER_VERSION REGRESSION_ID TEST_TYPE CONNECTION_TYPE PROXY_HOST PROXY_PORT PROXY_USERNAME PROXY_PASSWORD
	echo CONNECTION_TYPE and PROXY Properties needed only if the server and client are proxy/firewall protected
	exit
fi

if [ $1"test" == "test" ]
then
	. setEnv.sh
fi

#Setting CommandLine Directory path for Scheduler
if [ $1"test" != "test" ]
then
	cd $1
	if [ $# -lt 7 ]
	then
		echo For execution Usage: sh CommandLineWebTest.sh . SERVER_NAME SERVER_PORT BROWSER BROWSER_VERSION REGRESSION_ID TEST_TYPE CONNECTION_TYPE PROXY_HOST PROXY_PORT PROXY_USERNAME PROXY_PASSWORD
		echo CONNECTION_TYPE and PROXY Properties needed only if the server and client are proxy/firewall protected
		exit
	fi
	export SERVER_NAME=$2
	export PORT=$3
	export BROWSER=$4
	export BROWSERVERSION=$5
	export REGRESSIONID=$6
	export TEST_TYPE=$7
	export CONNECTION_TYPE=DIRECT
	if [ $8"test" != "test" ]
	then
		export CONNECTION_TYPE=$8
		export PROXY_HOST=$9
		export PROXY_PORT=$10
		export USERNAME=$11
		export PASSWORD=$12
	fi
fi	


QE_FILE="qe_moz_$BROWSERVERSION.sh"
if [ $BROWSER == 'Firefox' ]
then
	QE_FILE="qe_ff_$BROWSERVERSION.sh"
fi

if [ ! -f  ~/qenginecmd/$QE_FILE ] 
then
  echo "~/qenginecmd/$QE_FILE is not found"
  echo "Please connect the server with $BROWSER $BROWSERVERSION browser using  QEngine toolbar once and then execute Command Line "
  exit		 
fi

. ~/qenginecmd/$QE_FILE
cd $mozilla_path 
executebrowser='mozilla'
export XPCOM_CHECK_THREADSAFE=0
export COMMAND_LINE_EXECUTION=true


if [ $browser == 'Firefox' ]
then
	executebrowser="firefox"
elif [ $browser == 'firefox' ]
then
	executebrowser="firefox"
elif [ $browser == 'FIREFOX' ]
then
	executebrowser="firefox"
elif [ $browser == 'FireFox' ]
then
	executebrowser="firefox"

fi

xhost +

echo $executebrowser
#pkill -9 $executebrowser

./$executebrowser -P $PROFILENAME about:blank &
