@echo off
rem $Id: GenerateWPReports.bat,v 1.1.6.6 2010/04/19 07:10:24 muthuselvan Exp $

set SUITENAME=%1
set TESTCASENAME=%2
set REPORTSDIR=%4
set DB_NAME=%3
set SESSIONID=%5
set HISTORYDIR=%6
set USER_NAME=%7
set REGRESSION=%8

if "%SUITENAME%" == "" goto END_USAGE

if "%TESTCASENAME%" == "" goto END_USAGE

if "%DB_NAME%" == "" set DB_NAME="LATEST"

if "%SESSIONID%" == "" set SESSIONID="runtimesession"

if "%HISTORYDIR%" == "" set HISTORYDIR="LATEST"

if "%REPORTSDIR%" == "" set REPORTSDIR="LATEST"

if "%USER_NAME%" == "" set USER_NAME="QENGINE"

if "%REGRESSION%" == "" set REGRESSION="false"

if EXIST .\bin\setCommonEnv.bat goto setcommonenv
cd ..

:setcommonenv


call .\bin\setCommonEnv.bat

SET PATH=%PATH%;

SET JAVA=%JAVA_HOME%\bin\java

SET JAVAW=%JAVA_HOME%\bin\javaw

set COMMON_OPTS= -Djava.library.path=".\lib\native" -Dcatalina.home="%SERVER_HOME%" -Dserver.home="%SERVER_HOME%" -Dpython.path=%PY_PATH% -Dserver.stats=10000  -Dlog.dir="%SERVER_HOME%" -Ddb.home="%DB_HOME%" -Dcheck.tomcatport="true" 

set QE_OPTS= -Dpy.path=%SERVER_HOME%\jars -Dmysql.home="%DB_HOME%"

set JAVA_OPTS=%COMMON_OPTS% %QE_OPTS%

set QE_CLASSPATH=%SERVER_HOME%\jars;%FWK_CLASSPATH%;%WF_CLASSPATH%;%WP_CLASSPATH%;%WS_CLASSPATH%;%DB_CLASSPATH%

set CLASS_PATH=%QE_CLASSPATH%;%SERVER_HOME%\bin\run.jar;%SERVER_HOME%\jars\poi-3.0.1-FINAL-20070705.jar;%SERVER_HOME%\jars\jdt-compiler.jar;%SERVER_HOME%\lib\AdvCoreLogging.jar;%SERVER_HOME%\lib\AdventNetNPrevalent.jar;%SERVER_HOME%\lib\tomcat\servlet-api.jar;C:\PROGRA~1\Java\jdk1.5.0_10\lib\tools.jar;%SSH_CLASSPATH%
%JAVA% %JAVA_OPTS% -Dfile.encoding=UTF-8 -Dtest.dir="%SERVER_HOME%" -Duser.language=en -Xms250m -Xmx750m -Dtest.dir="%SERVER_HOME%" -cp "%CLASS_PATH%" com.adventnet.qengine.load.report.WebLoadReportGenerator SUITENAME %SUITENAME% TESTCASENAME %TESTCASENAME% DB_NAME %DB_NAME% SESSION %SESSIONID% HISTORYDIR %HISTORYDIR% REPORTSDIR %REPORTSDIR% USERNAME %USER_NAME% REGRESSION %REGRESSION%

:END_USAGE
echo Usage GenerateWPReports.bat SUITENAME LOADTESTNAME


