# This script file is used to start the QEngine Web Performance Distributed Agents

#  echo Usage: sh StartDistributedAgent.sh [port]

cd ..

if [ ! -f  ./bin/setCommonEnv.sh ] 
then
  cd bin
  echo "setCommonEnv.sh is not found"
  exit		 
fi

. ./bin/setCommonEnv.sh

CLASSPATH=$SERVER_HOME/jars:$DB_CLASSPATH:$FWK_CLASSPATH:$WP_CLASSPATH:$WS_CLASSPATH:$SERVER_HOME/lib:$SERVER_HOME/lib/AdventNetNPrevalent.jar:$SERVER_HOME/lib/AdvCoreLogging.jar

export LD_LIBRARY_PATH=./lib/native:

export CLASSPATH	


export RMIPORT="-Drmi.registery.port=$RMI_PORT"
export RMIHOST="-Djava.rmi.server.hostname=$RMI_HOSTNAME"

if [$RMI_PORT== ""];
then
	export RMIPORT=
fi

if [$RMI_HOSTNAME==""];
then
	export RMIHOST=
fi

$JAVA -Xmx200m -Dtest.dir=. -Dmysql.home=$DB_HOME -Djava.security.manager -Djava.security.policy="conf/policy" $RMIPORT $RMIHOST -Xbootclasspath/p:$BOOT_CLASSPATH com.adventnet.qengine.agent.server.RemoteServer $1


cd bin
