// $Id: loadtest.js,v 1.4.4.4 2010/03/24 06:53:56 muthuselvan Exp $
var cellrow=1;
var j=1;
var http;
var recMore = false;
var recordMode = false;

function getHTTPObject() 
{
	var xmlhttp;
 	/*@cc_on
  	@if (@_jscript_version >= 5)
  	  try 
  	  {
  	    xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
  	  } catch (e) 
  	  {
  	    try 
  	    {
  	      xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  	    } catch (E) 
  	    {
  	      xmlhttp = false;
  	    }
  	  }
  	@else
  	xmlhttp = false;
	  @end @*/
	if (!xmlhttp && typeof XMLHttpRequest != 'undefined') 
	{
	  try 
          {
      	    xmlhttp = new XMLHttpRequest();
    	  } catch (e) 
    	  {
      	    xmlhttp = false;
    	  }
  	}
	return xmlhttp;
}

// check user has owner privilege to allow actions
function checkPrivilege(showmess)
{
	privilege = document.getElementById("suiteprivilege").value;
	if(privilege == "false")
	{
		if(showmess)
		{
			showStatusDiv();
			document.getElementById("save_status").innerHTML = "You are not authorized to modify the load test.";
			return false;
		}
		else
		{
			return false;
		}
	}

	return true;
}

function hasToolbar()
{
	if(toolbarState=="false" || toolbarState==false)
	{
		return false;
	}
	else
	{
		return true;
	}
}

function insertTransInfoRow()
{
	row = tab.insertRow(0);
	row.id = "transInfoHelp";
	
	col = row.insertCell(0);
	col.colSpan="5";
	col.align="center";
	col.className="header";
	col.valign="middle";
	//col.innerHTML = "<br>You need to create a New Transaction to start a Load Test. <br><br><a href=\"#\" onClick=\"addTrans(event,'new');\" class=\"header\"Create a New Transaction</a>";
	col.innerHTML = "<br><br>You need to create a <a href=\"#\" onClick=\"addTrans(event,'new');\" class=\"header\">New Transaction</a> to start a Load Test.";
}

function insertTransactionIntoProfile(tab,rowindex,transName,percentLoad,suitename,profilename)
{
	row = tab.insertRow(rowindex);

	if(rowindex%2 == 1)
	{
		rowClassName="graytable";
	}
	else if(rowindex%2 == 0)
	{
		rowClassName="whitetable";
	}
	
	row.className=rowClassName;
	row.vAlign="middle";


	col1 = row.insertCell(0);
	col1.colSpan="2";
	col1.className="bigtext";
	colHtml = '<a href="#" onClick="showEditTransactions(\''+transName+'\',\''+suitename+'\',\''+profilename+'\')">'+transName+'</a>';;
	col1.innerHTML= colHtml;
	col1.width="30%";

	col2 = row.insertCell(1);
	col2.align="left";
	col2HTML = '<select class="textbox" id="prof_percentage_'+transName+'" name="prof_percentage_'+transName+'"><option value="100">100</option><option value="95">95</option><option value="90">90</option><option value="85">85</option><option value="80">80</option><option value="75">75</option><option value="70">70</option><option value="65">65</option><option value="60">60</option><option value="55">55</option><option value="50">50</option><option value="45">45</option><option value="40">40</option><option value="35">35</option><option value="30">30</option><option value="25">25</option><option value="20">20</option><option value="15">15</option><option value="10">10</option><option value="5">05</option></select><span id="'+transName+'_percenterr" align="left" class="information"></span>';
	col2.innerHTML = col2HTML;
	col2.width="13%";

	load = percentLoad;
	selindex=20-load/5;  // calculation to find the index to select. consideration first element in combo is 100. If it is not 100 then dont subtratct it from 10.
	document.getElementById("prof_percentage_"+transName).selectedIndex=selindex;

	col3 = row.insertCell(2);
	col3.align="center";
	col3HTML = '<a href="#" onClick="parameterizeTransaction(\''+transName+'\',\''+suitename+'\')">Edit</a>';
	//col4HTML = '<a href="#" onClick="parameterizeTransaction(\''+transName+'\',\''+suitename+'\')"><img src="/framework/images/edit.gif" height="18" widht="18" border="0"></a>';
	col3.innerHTML = col3HTML;
	col3.width="20%";

	//col4 = row.insertCell(3);
	//col4.align="center";
	//col4HTML = '<a href="javascript:showValidationPage(\''+transName+'\',\''+suitename+'\')">Configure</a>';
	//col3HTML = '<a href="#" onClick="showProfileDetails(\''+transName+'\',\''+suitename+'\',\''+profilename+'\')"><img src="/framework/images/settings.gif" height="18" widht="18" border="0"></a>';
	//col4.innerHTML = col4HTML;
	//col4.width="20%";

	col5 = row.insertCell(3);
	col5.align="center";
	//col5HTML = '<a href="#" onClick="removeTransaction(this,\''+transName+'\',\''+suitename+'\',\''+profilename+'\')">DEL</a> | <a href="#" onClick="showRenameTransDiv(this,event,\''+transName+'\'>REN</a>';
	 col5HTML = '<a href="#" onClick="recordMore(\''+transName+'\',event);"> <img src="/framework/images/record.gif" height="20" title="Record More" alt="Record More"  align="absmiddle" widht="20" border="0"></a> <a href="#" onClick="parameterizeTransaction(\''+transName+'\',\''+suitename+'\')"><img src="/framework/images/loadtestconfig.gif" height="18" align="absmiddle" title="Parameterize" width="18" border="0"></a>&nbsp;<a href="#" onClick="showRenameTransDiv(this,event,\''+transName+'\')"><img src="/framework/images/rename.gif" height="18" align="absmiddle" title="Rename" width="18" border="0"></a>  <a href="#" onClick="removeTransaction(this,\''+transName+'\',\''+suitename+'\',\''+profilename+'\')"><img src="/framework/images/del.gif" height="20" align="absmiddle" title="Delete" widht="20" border="0"></a>';
	col5.innerHTML = col5HTML;
	col5.width="17%";


	document.getElementById("lasttransactionname").value = transName;
	setLoadTestTransaction(transName);
}

function setLoadTestTransaction(transname)
{
	loadTestTransactions = document.getElementById("lttransactions").value;
	if(loadTestTransactions=="")
	{
		loadTestTransactions = transname;
	}
	else
	{
		loadTestTransactions = loadTestTransactions+":_QESEP_:"+transname;
	}

	document.getElementById("lttransactions").value = loadTestTransactions;
}


// Following function will show transaction details fetched from profile and transaction script
function showProfileDetails(transname,suite,profname)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	hideAllDiv();
	var transfrm = document.getElementById("transDetframe");
	transfrm.src = "/webload/jsp/WLTransactionDetails.jsp?suitename="+suite+"&bcname="+transname+"&profile="+profname; 
	
	transdiv = document.getElementById("transdetailsdiv");

	if(isIE)
	{
		removeDynamicFrame();
		transfrm.width="650";
		transfrm.height="350";
		insertDynamicFrame(transdiv,"50","62","650","350");
	}
	else
	{
		transfrm.width="650";
		transfrm.height="350";
	}
	
	eval("transdiv.style.display = 'block';");
}
// Show editTransactions
function showEditTransactions(transname,suite,profname)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	hideAllDiv();
	var transfrm = document.getElementById("transDetframe");
	transfrm.src = "/webload/jsp/WLEditTransaction.jsp?suitename="+suite+"&bcname="+transname+"&profile="+profname; 

	transdiv = document.getElementById("transdetailsdiv");
	transdiv.style.zIndex = "2";

	if(isIE)
	{
		transfrm.width="650";
		transfrm.height="350";
		insertDynamicFrame(transdiv,"50","62","650","350");
	}
	else
	{
		transfrm.width="650";
		transfrm.height="350";
	}
	
	eval("transdiv.style.display = 'block';");
}
//end editTransactions
function hideTransDetailsDiv()
{
	transdiv = document.getElementById("transdetailsdiv");
	eval("transdiv.style.display = 'none';");
	if(isIE)
	{
		removeDynamicFrame();
	}
}
// End of show transaction details

// This will show parameterization details of transaction
function parameterizeTransaction(transname,suite)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	hideAllDiv();
	//parent.window.showParameterizeDiv(transname,suite);
	hgt = screen.availHeight;
	wth = screen.availWidth;
	window.open('/webload/jsp/WLParameterizeScreen.jsp?suitename='+suite+'&titlename=Parameterization&bcname='+transname,"Parameterization",'scrollbars=no,location=no,directories=no,status=no,menubar=no,toolbar=no,resizable=yes,height='+hgt+',width='+wth+',top=auto,left=auto');

}
function showValidationPage(transname,suite)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	hideAllDiv();
	//parent.window.showParameterizeDiv(transname,suite);
	window.open('/webload/jsp/WLParameterizeScreen.jsp?titlename=Validation&bcname='+transname,"Parameterization",'scrollbars=no,location=no,directories=no,status=no,menubar=no,toolbar=no,resizable=yes');

}
function hideParameterizeDiv()
{
	paramdiv = parent.document.getElementById("transparamdiv");
	eval("paramdiv.style.display = 'none';");
}
// End of Parameterize transaction
function insertDynamicFrame(node,left,top,width,height)
{
	node.insertAdjacentHTML("afterEnd",'<IFRAME src="javascript:false;" frameBorder="1" scrolling="no" id="dynFrame"></IFRAME>');
	iFrame = document.getElementById("dynFrame");
	
	iFrame.style.position="absolute";
	iFrame.style.left = left+'px';
	iFrame.style.top = top+'px';
	iFrame.style.width = width+'px';
	iFrame.style.height = height+'px';
	iFrame.style.display = "block";
	iFrame.style.zIndex = "1";

}

function removeDynamicFrame()
{
	dynIframe = document.getElementById("dynFrame");
	if(dynIframe != null && dynIframe != 'undefined')
	{
		document.body.removeChild(dynIframe);
	}
}

// This will create new transaction for the loadtest
function addTrans(event,mode)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	hideAllDiv();
	if(!checkPrivilege(true))
	{
		return;
	}
	
	newTransdiv = document.getElementById("addtrans");
	document.getElementById("create_error").innerHTML = "";
	document.getElementById("import_error").innerHTML = "";
	var xPos = Math.floor(event.clientX);
	var yPos = Math.floor(event.clientY);
	newTransdiv.style.left = (xPos+5)+"px";
	if(yPos < 160)
		yPos=200;
	newTransdiv.style.top = (yPos-110)+"px";

	newTransdiv.style.zIndex = "3";
	if(isIE)
	{
		removeDynamicFrame();
		insertDynamicFrame(newTransdiv,(xPos+5),(yPos-110),"350","185");
	}

	eval("newTransdiv.style.display = 'block';");
	changetab(mode);
}

function hideAddTrans()
{
	newTransdiv = document.getElementById("addtrans");
	eval("newTransdiv.style.display = 'none';");
	if(isIE)
	{
		removeDynamicFrame();
	}
}
// End of create new transaction 

// change between import and create transaction in add transaction div
function changetab(mode)
{
	if(mode=='new')
	{
		document.getElementById("transname").value = "";
		document.getElementById("importtransname").value = "";
		document.getElementById("import_error").innerHTML="";
		document.getElementById("create_error").innerHTML="";
		document.getElementById("importrow").className="hide";
		document.getElementById("import").className="hide";
		document.getElementById("createrow").className="show";	
		document.getElementById("createnew").className="show";
		document.getElementById("importtab").className="nonselectedtab";
		document.getElementById("createtab").className="selectedtab";
		document.getElementById("transaction").value="Create New";
		document.getElementById("transaction").disabled=false;
		document.getElementById("transname").focus();
	}
	if(mode=='import')
	{
		document.getElementById("transname").value = "";
		document.getElementById("importtransname").value = "";
		document.getElementById("import_error").innerHTML="";
		document.getElementById("create_error").innerHTML="";
		document.getElementById("importrow").className="show";
		document.getElementById("import").className=""
		document.getElementById("createrow").className="hide";	
		document.getElementById("createnew").className="hide";
		document.getElementById("importtab").className="selectedtab";
		document.getElementById("createtab").className="nonselectedtab";
		document.getElementById("transaction").value="Save As";
		document.getElementById("importtransname").disabled = false;
		getAvailableTransactions();
	}
}
// End of change tab

// send ajax request to fetch available transaction
function getAvailableTransactions()
{
	http = getHTTPObject();
	suitename = document.getElementById("suitename").value;
	var url = "/webload/jsp/WLTransactionUtil.jsp?suitename="+suitename+"&method=gettransactions";
	http.open("GET",url,true);
	http.onreadystatechange = fillTransaction;
	http.send(null);
}

function fillTransaction()
{
	if(http.readyState == 4)
	{
		var response = http.responseText;

		trIndex = response.indexOf("[TRANSACTIONS]");
		trIndex = trIndex+14;

		etrIndex = response.indexOf("[/TRANSACTIONS]");

		allTrans = response.substring(trIndex,etrIndex);
		populateTransactions(allTrans);
	}
}

function isTransInProfile(arr,transname)
{
	for(j=0;j<arr.length;j++)
	{
		if(arr[j]!="" && arr[j]==transname)
		{
			return true;
		}
	}

	return false;
}

function populateTransactions(trans)
{
	var profileTransactions = document.getElementById("lttransactions").value;
	var profTransArr = profileTransactions.split(":_QESEP_:");
	var transArr = trans.split(":-:");
	transCombo = document.getElementById("transactions");
	transCombo.options.length=0;
	var transcount = 0;
	for(i=0;i<transArr.length;i++)
	{
		optname = transArr[i];
		if(optname=="")
		{
			continue;
		}

		transcount++;
		if(isTransInProfile(profTransArr,optname))
		{
			continue;
		}

		option = document.createElement("OPTION");
		option.value = optname;
		option.text = optname;

		if(isIE)
		{
			transCombo.add(option,i);
		}
		else if(isGecko)
		{
			transCombo.add(option,null);
		}
	}
	if(transCombo.options.length==0)
	{
		if(transcount == 0)
		{
			document.getElementById("import_error").innerHTML = "No transaction exist to import to the loadtest.";
		}
		else
		{
			document.getElementById("import_error").innerHTML = "All the transactions are already added to the loadtest.";
		}
		document.getElementById("transactions").disabled = true;
		document.getElementById("importtransname").disabled = true;
		document.getElementById("transaction").disabled = true;
	}
	else
	{
		transCombo.selectedIndex = 0;
		document.getElementById("importtransname").focus();
	}
}
// End of fetching available transaction

function createNewTransaction(evt)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	if(document.getElementById("transaction").value	== "Create New")
	{
		transactionName = document.getElementById("transname").value;

		if(toolbarState=="false" || toolbarState==false)
		{
			hideAddTrans();
			showinstalltoolbardiv(evt.clientX,evt.clientY);
			return;
		}
		else if(toolbarState=="unsupported")
		{
			alert("Browser currently not supported for automation");
			document.getElementById("create_error").innerHTML = "Browser currently not supported for automation.";
			document.getElementById("transname").focus();
			return;
		}

		
		if(transactionName == "")
		{
			//alert("Please configure the transaction name to save. ");
			document.getElementById("create_error").innerHTML = "Please provide the transaction name to save. ";
			document.getElementById("transname").focus();
			return;
		}
		else if(!parent.checkForSplChar(transactionName,"Transaction name"))
		{
			document.getElementById("create_error").innerHTML = "Special character not allowed in Transaction name. ";
			document.getElementById("transname").focus();
			return;
		}

		sname = document.getElementById("suitename").value;
		checkTransactionExist(transactionName,sname);
	}
	else if(document.getElementById("transaction").value == "Save As")
	{
		oldTransactionName = document.getElementById("transactions").options[document.getElementById("transactions").selectedIndex].value;
		transactionName = document.getElementById("importtransname").value;
		if(transactionName == "")
		{
			//alert("Please configure the transaction name to save. ");
			document.getElementById("import_error").innerHTML = "Please enter the transaction name to save. ";
			document.getElementById("importtransname").focus();
			return;
		}
		else if(!parent.checkForSplChar(transactionName,"Transaction name"))
		{
			document.getElementById("import_error").innerHTML = "Special character not allowed in Transaction name. ";
			document.getElementById("importtransname").focus();
			return;
		}
	
		sname = document.getElementById("suitename").value;
		saveImportedTransaction(transactionName,oldTransactionName,sname);
	}
}

function installToolbar()
{
	parent.parent.location.href="/framework/jsp/InstallToolBar.jsp";
}

function hideinstalltoolbardiv()
{
	if(isIE)
	{
		removeDynamicFrame();
	}
	document.getElementById("installtoolbar").style.display="none";
}

function showinstalltoolbardiv(x,y)
{
	hideAllDiv();
	divElem = document.getElementById("installtoolbar");
	lAlign = x;
	if(lAlign > 500)
	{
		lAlign = lAlign - 400;
	}
	tAlign = y + 10;
	if(tAlign > 450)
	{
		tAlign = tAlign - 130;
	}
	divElem.style.left = lAlign +"px";
	divElem.style.top = tAlign + "px";
	divElem.style.display = "block";
	if(isIE)
	{
		removeDynamicFrame();
		insertDynamicFrame(divElem,lAlign+"",tAlign+"",450,120);
	}
}

function removeTransaction(elem,transName,suite,profile)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	if(!checkPrivilege(true))
	{
		return;
	}

	if(!confirm("Do you really want to remove the transaction from the loadtest ?"))
	{
		return;
	}
	//delete the transaction row from table
	tab = document.getElementById("profileTable");
	row = elem.parentNode.parentNode.rowIndex;
	tab.deleteRow(row);

	row = tab.rows.length;
	if(row == 0)
	{
		insertTransInfoRow();
	}

	// delete transaction in profile
	pflPath = document.getElementById("ltencprofilepath").value;
	loadTest = document.getElementById("ltname").value;
	
	http = getHTTPObject();
	var url = "/webload/jsp/WLTransactionUtil.jsp?suitename="+suite+"&transname="+transName+"&profile="+profile+"&profilepath="+pflPath+"&loadtest="+loadTest+"&method=removetransaction";
	http.open("GET",url,true);
	http.onreadystatechange = handleRemove;
	http.send(null);
}

function handleRemove()
{
	if(http.readyState == 4)
	{
		
		response = http.responseText;
		trIndex = response.indexOf("[TRANSACTIONS]");
		trIndex = trIndex+14;

		etrIndex = response.indexOf("[/TRANSACTIONS]");
		response = response.substring(trIndex,etrIndex);

		if(response.indexOf("SUCCESS_")!=-1)
		{
			trans = response.substring(8,response.length);
			replaceTransaction(trans,"");
		}

		
	}
}

function replaceTransaction(transName,repName)
{
	loadTestTransactions = document.getElementById("lttransactions").value;
	if(loadTestTransactions.indexOf(transName)!=-1)
	{
		if(loadTestTransactions.indexOf(":_QESEP_:")!=-1)
		{
			transArr = loadTestTransactions.split(":_QESEP_:");
			loadTestTransactions = "";
			for(i=0;i<transArr.length;i++)
			{
				if(transArr[i]!=transName)
				{
					if(loadTestTransactions=="")
					{
						loadTestTransactions = transArr[i];
					}
					else
					{
						loadTestTransactions = loadTestTransactions+":_QESEP_:"+transArr[i];
					}
				}
				else
				{
					if(repName!="")
					{
						if(loadTestTransactions=="")
						{
							loadTestTransactions = repName;
						}
						else
						{
							loadTestTransactions = loadTestTransactions+":_QESEP_:"+repName;
						}
					}
				}
			}
		}
		else
		{
			loadTestTransactions = repName;
		}
	}
	document.getElementById("lttransactions").value=loadTestTransactions;
}

function showRenameTransDiv(elem,event,transName)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	if(!checkPrivilege(true))
	{
		return;
	}

	document.getElementById("renoldtransname").value = transName;
	document.getElementById("renrowid").value = elem.parentNode.parentNode.rowIndex;

	rendiv = document.getElementById("renamediv");
	var xPos = Math.floor(event.clientX);
	var yPos = Math.floor(event.clientY);
	rendiv.style.left = (xPos-300)+"px";
	rendiv.style.top = (yPos+5)+"px";

	eval("rendiv.style.display = 'block' ;");

	document.getElementById("newtransname").focus();
	
}

function hideRenameTransDiv()
{
	rendiv = document.getElementById("renamediv");
	eval("rendiv.style.display = 'none';");
}

function renameTransaction()
{
	if(!checkPrivilege(true))
	{
		document.getElementById("ren_error").innerHTML = "You are not authorized to do this operation.";
		return;
	}
	newTransName = document.getElementById("newtransname").value;
	if(newTransName == "")
	{
		//alert("Kindly provide the transaction name.");
		document.getElementById("ren_error").innerHTML = "Kindly provide the transaction name.";
		document.getElementById("newtransname").focus();
		document.getElementById("newtransname").select();
		return;
	}
	
	if(!isProper(newTransName))
	{
		document.getElementById("ren_error").innerHTML = "Special characters not allowed in transaction name.";
		document.getElementById("newtransname").focus();
		document.getElementById("newtransname").select();
		return;
	}
	oldTransName = document.getElementById("renoldtransname").value;
	suitename = document.getElementById("suitename").value;
	profile = document.getElementById("ltprofilename").value;
	pflPath = document.getElementById("ltencprofilepath").value;
	loadTest = document.getElementById("ltname").value;

	http = getHTTPObject();
	var url = "/webload/jsp/WLTransactionUtil.jsp?suitename="+suitename+"&newtransaction="+newTransName+"&oldtransaction="+oldTransName+"&profile="+profile+"&profilepath="+pflPath+"&loadtest="+loadTest+"&method=renametransaction";
	http.open("GET",url,true);
	http.onreadystatechange = handleRename;
	http.send(null);
}

function handleRename()
{
	if(http.readyState == 4)
	{
		response = http.responseText;
		trIndex = response.indexOf("[TRANSACTIONS]");
		trIndex = trIndex+14;

		etrIndex = response.indexOf("[/TRANSACTIONS]");
		message = response.substring(trIndex,etrIndex);

		if(message.indexOf("FAILED")!=-1)
		{
			//alert("Rename Transaction Failed" + message);
			document.getElementById("ren_error").innerHTML = "Rename Transaction Failed "+message;
			document.getElementById("newtransname").value = "";
			document.getElementById("newtransname").focus();
		}
		else if(message.indexOf("TRANSACTION_EXIST")!=-1)
		{
			newTransName = document.getElementById("newtransname").value;
			document.getElementById("ren_error").innerHTML = "Transaction with name \""+newTransName+"\" already exist.\n Kindly provide a new name.";
			//alert("Transaction with name \""+newTransName+"\" already exist.\n Kindly provide a new name.");
			document.getElementById("newtransname").value = "";
			document.getElementById("newtransname").focus();
		}
		else
		{
			tab = document.getElementById("profileTable");
			row = document.getElementById("renrowid").value;

			// getting old transaction details
			oldtransname = document.getElementById("renoldtransname").value;
			transPercentCombo = document.getElementById("prof_percentage_"+oldtransname);
			loadPercent = transPercentCombo.options[transPercentCombo.selectedIndex].value;
			newname = document.getElementById("newtransname").value;
			sname = document.getElementById("suitename").value;
			profilename = document.getElementById("ltprofilename").value;

			//delete the old transaction row
			tab.deleteRow(row);

			//updating lttransaction field with new trans name
			replaceTransaction(oldtransname,"");

			//insert new transaction row
			insertTransactionIntoProfile(tab,row,newname,loadPercent,sname,profilename);
			document.getElementById("newtransname").value = "";
			document.getElementById("ren_error").innerHTML = "";
			hideRenameTransDiv();
		}
	}
}

// import transaction in to Load test functions
function saveImportedTransaction(newTransaction,oldTransaction,suitename)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	http = getHTTPObject();
	var url = "/webload/jsp/WLTransactionUtil.jsp?suitename="+suitename+"&newtransaction="+newTransaction+"&oldtransaction="+oldTransaction+"&method=importtransaction";
	http.open("GET",url,true);
	http.onreadystatechange = importTransaction;
	http.send(null);
}

function importTransaction()
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	if(http.readyState == 4)
	{
		response = http.responseText;
		trIndex = response.indexOf("[TRANSACTIONS]");
		trIndex = trIndex+14;

		etrIndex = response.indexOf("[/TRANSACTIONS]");
		transactionName = response.substring(trIndex,etrIndex);

		if(transactionName.indexOf("FAILED")!=-1)
		{
			statusMes = transactionName.substring(6,transactionName.length);
			if(statusMes!="")
			{
				statusMes = statusMes.substring(1,statusMes.length);
			}
			if(statusMes=="TRANSACTION_ALREADY_EXIST")
			{
				statusMes = "Transaction already exists.";
			}
			document.getElementById("import_error").innerHTML = "Importing transaction failed. " +statusMes;
			document.getElementById("importtransname").focus();
			return;
		}

		suitename = document.getElementById("suitename").value;
		profilename = document.getElementById("ltprofilename").value;

		tab = document.getElementById("profileTable");

		if(document.getElementById("transInfoHelp"))
		{
			tab.deleteRow(0);
		}
		rowcount = tab.rows.length;
		
		hideAddTrans();
		percentload="100";
		if(rowcount==1)
		{
			percentload = "50";
			lastTransation = document.getElementById("lasttransactionname").value;
			percentCombo = document.getElementById("prof_percentage_"+lastTransation);
			percentCombo.selectedIndex = 10;
		}
		
		insertTransactionIntoProfile(tab,rowcount,transactionName,percentload,suitename,profilename);
		document.getElementById("lasttransactionname").value = transactionName;
		profile = document.getElementById("ltprofilename").value;
		saveTransactionInProfile(transactionName,profile);
	}
}

function saveTransactionInProfile(transactionName,profile)
{
	transPercentCombo = document.getElementById("prof_percentage_"+transactionName);
	loadPercent = transPercentCombo.options[transPercentCombo.selectedIndex].value;
	suitename = document.getElementById("suitename").value;
	pflPath = document.getElementById("ltencprofilepath").value;
	
	try
	{
		http = getHTTPObject();
		var url = "/webload/jsp/WLTransactionUtil.jsp?suitename="+suitename+"&transname="+transactionName+"&profile="+profile+"&percentload="+loadPercent+"&profilepath="+pflPath+"&method=addtransactioninprofile";
		http.open("GET",url,true);
		http.onreadystatechange = handleSaveInProfile;
		http.send(null);
	}
	catch(e)
	{
		alert("Error in save transaction in profile "+e);
	}
}

function handleSaveInProfile()
{
	if(http.readyState == 4)
	{
		response = http.responseText;
		trIndex = response.indexOf("[TRANSACTIONS]");
		trIndex = trIndex+14;
		etrIndex = response.indexOf("[/TRANSACTIONS]");

		message = response.substring(trIndex,etrIndex);
		
		if(message.indexOf("FAILED")!=-1)
		{
			alert("adding transaction in profile failed "+message);
		}
		else
		{
			document.getElementById("importtransname").value="";
		}
	}
}

// End of import transaction

// Create new transaction functions
function checkTransactionExist(transName,sname)
{
	http = getHTTPObject();
	var url = "/webload/jsp/WLTransactionUtil.jsp?suitename="+sname+"&transname="+transName+"&method=checktransexist";
	http.open("GET",url,true);
	http.onreadystatechange = addTransaction;
	http.send(null);
}


function addTransaction()
{
	if(http.readyState == 4)
	{
		response = http.responseText;
		trIndex = response.indexOf("[TRANSACTIONS]");
		trIndex = trIndex+14;
		etrIndex = response.indexOf("[/TRANSACTIONS]");

		message = response.substring(trIndex,etrIndex);

		transactionName = document.getElementById("transname").value;
		if(message.indexOf("TRANSACTION_EXIST")!=-1)
		{
			document.getElementById("create_error").innerHTML = "Transaction with name \""+transactionName+"\" already exist.";
			document.getElementById("transname").focus();
			return;
		}
		
		hideAddTrans();
		document.getElementById("transname").value="";
		startRecording(transactionName);
	}
}

function recordMore(transName,evt)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	if(!checkPrivilege(true))
	{
		return false;
	}	

	if(toolbarState=="false" || toolbarState==false)
	{
		hideTransDetailsDiv();
		showinstalltoolbardiv(evt.clientX,evt.clientY);
		return;
	}
	hideTransDetailsDiv();
	recMore = true;
	startRecording(transName);
}

function startRecording(transactionName)
{
	recDiv = document.getElementById("recorderDiv");
	recFrame = document.getElementById("recorderframe");
	setUIWidth("recorderDiv","recorderframe");
	suitename = document.getElementById("suitename").value;
	recFrame.src = "/webload/jsp/WLTransactionRecorder.jsp?transname="+transactionName+"&suitename="+suitename;
	document.getElementById("lasttransactionname").value=transactionName;
	eval("recDiv.style.display = 'block';");
	document.getElementById("stoprecord").disabled= true;
	recordMode = true;
}

function stopPlay()
{
	parent.stopPlayFromUI(false);
}

// Handle Multiple IE process error
function handleRecordError(state)
{
	if(state.indexOf("MULTIPLE_IE_PROCESS_FOUND") !=-1)
	{
		document.getElementById("errorTitle").innerHTML = "Record Error";
		_LEFT = document.body.offsetWidth/4;
	  	_TOP = document.body.offsetHeight/4;
		var divElem = document.getElementById("recordErrorDiv");
		document.getElementById("recordErrorDiv").style.left = _LEFT+"px";
		document.getElementById("recordErrorDiv").style.top = _TOP+"px";
		document.getElementById("recordErrorDiv").style.display = "block";
		document.getElementById("errmessage").innerHTML = "<table border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tr><td colspan=\"2\" class=\"subTableSubHeader\" style=\"font-size:16px; color:#ff0000;\">You have multiple Internet Explorer browser opened.<br><br></td></tr><tr><td height=\"30\" class=\"subTableSubHeader\" colspan=\"2\" style=\"font-size:12px\"> Which will cause : </td></tr><tr><td>&nbsp;</td><td class=\"subTableSubHeader\"> &nbsp; Malfunctioning of QEngine Toolbar.<br><br></td></tr><tr><td class=\"subTableSubHeader\" style=\"font-size:12px;\" colspan=\"2\">Solutions : </td></tr><tr><td class=\"subTableSubHeader\" height=\"30\" colspan=\"2\">Click <input name=\"button2\" type=\"button\" class=\"buttonstyleMain\" onClick=\"sendHandlingMessage('ok','record');\" value=\"Close All \" style=\"width: 120px;\"> to close rest of IE windows automatically and continue recording.</td></tr><tr><td height=\"30\" class=\"subTableSubHeader\" colspan=\"2\">Or &nbsp; &nbsp; <input name=\"button3\" type=\"button\" class=\"buttonstyleMain\" onClick=\"sendHandlingMessage('cancel','record');\" value=\"Stop Recording\" style=\"width: 120px;\"></td></tr><tr> <td colspan=\"2\">&nbsp;</td></tr><tr><td colspan=\"2\">Note: If you start the recording from the \"QEngine Toolbar\" you may avoid these errors.</td></tr></table>" ;
	}
	if(isIE)
	{
		insertDynamicFrame(divElem,_LEFT,_TOP,296,40);
	}
}

function hiderecErrorDiv()
{
	document.getElementById("recordErrorDiv").style.display = "none";
	if(isIE)
	{
		removeDynamicFrame();
	}
	if(!continueRecording)
	{
		hideRecordDiv();
	}
}
var continueRecording = false;
function sendHandlingMessage(action,mode)
{
	if(action=="ok")
	{
		try
		{
			continueRecording = true;
			var todo=""
			if(mode=="record")
			{
				todo="closebrowserforrecord";
			}
			else if(mode=="play")
			{
				todo="closebrowserforplay";
			}

			http = getHTTPObject();
			var url="/framework/jsp/HandleRecordPlayFromUI.jsp?ttype=wpt&todotype="+todo;
			http.open("GET", url, true);
			http.onreadystatechange = handleResponse; 
			http.send(null);
		}
		catch(e)
		{
			//alert("stop rec error");
		}
	}
	else if(action == "cancel")
	{
		try
		{
			continueRecording = false;
			parent.setRecordMode("false");
			parent.setPlayMode("false");
			handleResponse();
		}
		catch(e)
		{
			//alert("stop rec error");
		}
	}
}

function handleResponse()
{
	hiderecErrorDiv();
}

function stopRecording()
{
	recordMode = false;
	if(document.getElementById("recordErrorDiv").style.display=='block')
	{
		hiderecErrorDiv();
	}
	else
	{
		parent.stopRecordFromUI(false);
	}
}

function handleStopRecordFromToolbar()
{
	recordMode = false;
	hideRecordDiv();
	
	// On Recording started from transaction details screen, we should not add transaction in profile table.
	if(recMore)
	{
		recMore = false;
		return;
	}
	
	tab = document.getElementById("profileTable");

	if(document.getElementById("transInfoHelp"))
	{
		tab.deleteRow(0);
	}

	rowcount = tab.rows.length;

	transactionName = document.getElementById("lasttransactionname").value;
	suitename = document.getElementById("suitename").value;
	profilename = document.getElementById("ltprofilename").value;
	
	percentload="100";
	if(rowcount==1)
	{
		percentload = "50";
		transInProfile = document.getElementById("lttransactions").value;
		percentCombo = document.getElementById("prof_percentage_"+transInProfile);
		percentCombo.selectedIndex = 10;
	}
	
	insertTransactionIntoProfile(tab,rowcount,transactionName,percentload,suitename,profilename);
	saveTransactionInProfile(transactionName,profilename);
}

function hideRecordDiv()
{
	if(recordMode)
	{
		if(confirm(" Recording will be stopped. Do you want to continue ?"))
		{
			stopRecording();
		}
		else
		{
			return;
		}
	}
	
	recDiv = document.getElementById("recorderDiv");
	eval("recDiv.style.display = 'none';");
}
// create transaction functions ends here

function setUIWidth(divid,frameid)
{
	_WID = document.body.offsetWidth-40;
  	_HEI = parent.document.body.offsetHeight;
	_HEI= _HEI * 0.80;
	_DIVELEM = document.getElementById(divid);
	if(_DIVELEM)
	{
		_DIVELEM.style.width=_WID+"px";
		_DIVELEM.style.height=_HEI+"px";
	}
	if(document.getElementById(frameid))
	{
		document.getElementById(frameid).height=_HEI+"px";
		document.getElementById(frameid).width=_WID+"px";
	}
}

function hideAllLoadDiv()
{
	var divtohide=document.getElementById("normaldiv");
	eval("divtohide.style.display = 'none';");
	
	divtohide = document.getElementById("rampupdiv");
	eval("divtohide.style.display = 'none';");

	divtohide = document.getElementById("rampdowndiv");
	eval("divtohide.style.display = 'none';");

	divtohide = document.getElementById("burnindiv");
	eval("divtohide.style.display = 'none';");

	divtohide = document.getElementById("alldaydiv");
	eval("divtohide.style.display = 'none';");
}

function showLoadDiv(mode)
{
	hideAllLoadDiv();
	if(mode=="normal")
	{
		var divtoshow=document.getElementById("normaldiv");
		eval("divtoshow.style.display = 'block';");
	}
	else if(mode=="ramp-up")
	{
		var divtoshow=document.getElementById("rampupdiv");
		eval("divtoshow.style.display = 'block';");
	}
	else if(mode=="ramp-down")
	{
		var divtoshow=document.getElementById("rampdowndiv");
		eval("divtoshow.style.display = 'block';");
	}
	else if(mode=="burn-in")
	{
		var divtoshow=document.getElementById("burnindiv");
		eval("divtoshow.style.display = 'block';");
	}
	else if(mode=="allday")
	{
		var divtoshow=document.getElementById("alldaydiv");
		eval("divtoshow.style.display = 'block';");
	}
}
	
function callAddRow(rowcount,mode)
{
	var table;
	table=document.getElementById('alldaydetailsgecko');

	var rowcount= table.rows.length;
	var prevrow= rowcount-1;
	if(mode=="mixedload")
	{
		if(rowcount>=1)
		{
		}
		else
		{
			var x=table.insertRow(rowcount);	
			x.height="15";
			var y1=x.insertCell(0);
			y1.width="15%";
			y1.align="center";
			var y2=x.insertCell(1);
			y2.width="20%";
			y2.align="center";
			var y3=x.insertCell(2);
			y3.width="20%";
			y3.align="center";
			var y4=x.insertCell(3);
			y4.width="10%";
			y4.align="center";
			var y5=x.insertCell(4);
			y5.width="10%";
			y5.align="center";
			var y6=x.insertCell(5);
			y6.width="15%";
			y6.align="center";
			var y7=x.insertCell(6);
			var y8=x.insertCell(7);
			y1.innerHTML="<select class=\"drpDown\" id=\"alldaymode["+rowcount+"]\" name=\"alldaymode["+rowcount+"]\" onChange=\"disableStepFields(this)\;\" >	<option value=\"SteadyState\">SteadyLoad</option><option value=\"Increment\">RampUp</option><option value=\"Decrement\">RampDown</option></select>";
			y2.innerHTML="<input class=\"txtBoxStyleallday\" type=\"text\" id=\"alldayusercount["+rowcount+"]\" name=\"alldayusercount["+rowcount+"]\" onChange=\"isNumber(this);fillEndsWithUsers(this);\" ><span id=\"aducerr["+rowcount+"]\" align=\"left\" class=\"information\"></span>";
			y3.innerHTML="<input class=\"txtBoxStyleallday\" type=\"text\" id=\"alldaysteps["+rowcount+"]\" name=\"alldaysteps["+rowcount+"]\" onChange=\"isNumber(this);validatestepvalue(this);\" ><span id=\"adsteperr["+rowcount+"]\" align=\"left\" class=\"information\"></span>";
			document.getElementById("alldaysteps["+rowcount+"]").readOnly  = true;
			y4.innerHTML="<input class=\"txtBoxStylealldaysmall\" type=\"text\" id=\"foreveryduration["+rowcount+"]\" name=\"foreveryduration["+rowcount+"]\" onChange=\"isNumber(this);\" ><span id=\"adfdurerr["+rowcount+"]\" align=\"left\" class=\"information\"></span>";
			document.getElementById("foreveryduration["+rowcount+"]").readOnly  = true;
			y5.innerHTML="<input class=\"txtBoxStylealldaysmall\" type=\"text\" id=\"alldayduration["+rowcount+"]\" name=\"alldayduration["+rowcount+"]\" onChange=\"isNumber(this);fillEndsWithUsers(this);\" >";
			y6.id="endswithusers["+rowcount+"]";
			//y6.innerHTML = "";
			var endswithusersempty="";
			y6.innerHTML ="<div style='width: 100px;'>" +endswithusersempty+ "</div>";
			y8.innerHTML="<input class=\"txtBoxStyleallday\" type=\"hidden\" id=\"endswithusershid["+rowcount+"]\" name=\"endswithusershid["+rowcount+"]\"  ><span id=\"adadurerr["+rowcount+"]\" align=\"left\" class=\"information\"></span>";
			document.getElementById("endswithusers["+rowcount+"]").readOnly = true;
			y7.innerHTML="<img src=\"/framework/images/del.gif\" style=\"cursor:hand\; cursor:pointer\;\" alt=\"Delete\" title=\"Delete\" onClick=\"DeleteAllDayRow(this);\">";
			y7.align="left";	
		}
	}
	else
	{
		var x=table.insertRow(rowcount);	
		x.height="15";
		var y1=x.insertCell(0);
		var y2=x.insertCell(1);
		var y3=x.insertCell(2);	
		var y4=x.insertCell(3);
		var y5=x.insertCell(4);
		var y6=x.insertCell(5);
		var y7=x.insertCell(6);
		var y8=x.insertCell(7);
		y1.innerHTML="<select class=\"drpDown\" id=\"alldaymode["+rowcount+"]\" name=\"alldaymode["+rowcount+"]\" onChange=\"disableStepFields(this)\;\" >	<option value=\"SteadyState\">SteadyLoad</option><option value=\"Increment\">RampUp</option><option value=\"Decrement\">RampDown</option></select>";
		y2.innerHTML="<input class=\"txtBoxStyleallday\" type=\"text\" id=\"alldayusercount["+rowcount+"]\" name=\"alldayusercount["+rowcount+"]\" onChange=\"isNumber(this);fillEndsWithUsers(this);\" ><span id=\"aducerr["+rowcount+"]\" align=\"left\" class=\"information\"></span>";
		y3.innerHTML="<input class=\"txtBoxStyleallday\" type=\"text\" id=\"alldaysteps["+rowcount+"]\" name=\"alldaysteps["+rowcount+"]\" onChange=\"isNumber(this);validatestepvalue(this);\" ><span id=\"adsteperr["+rowcount+"]\" align=\"left\" class=\"information\"></span>";
		document.getElementById("alldaysteps["+rowcount+"]").readOnly  = true;
		y4.innerHTML="<input class=\"txtBoxStylealldaysmall\" type=\"text\" id=\"foreveryduration["+rowcount+"]\" name=\"foreveryduration["+rowcount+"]\" onChange=\"isNumber(this);\" ><span id=\"adfdurerr["+rowcount+"]\" align=\"left\" class=\"information\"></span>";
		document.getElementById("foreveryduration["+rowcount+"]").readOnly  = true;
		y5.innerHTML="<input class=\"txtBoxStylealldaysmall\" type=\"text\" id=\"alldayduration["+rowcount+"]\" name=\"alldayduration["+rowcount+"]\" onChange=\"isNumber(this);fillEndsWithUsers(this);\" ><span id=\"adadurerr["+rowcount+"]\" align=\"left\" class=\"information\"></span>";
		y6.id="endswithusers["+rowcount+"]";
		var endswithusersempty="";
		y6.innerHTML ="<div style='width: 100px;'>" +endswithusersempty+ "</div>";
		y8.innerHTML="<input class=\"txtBoxStyleallday\" type=\"hidden\" id=\"endswithusershid["+rowcount+"]\" name=\"endswithusershid["+rowcount+"]\"  >";
		document.getElementById("endswithusers["+rowcount+"]").readOnly = true;
		y7.innerHTML="<img src=\"/framework/images/del.gif\" style=\"cursor:hand\; cursor:pointer\;\" alt=\"Delete\" title=\"Delete\" onClick=\"DeleteAllDayRow(this);\">";
		y7.align="left";	
	}
	
	for(y=0;y<rowcount;y++)
	{
		currentendwithval=document.getElementById("endswithusershid["+y+"]").value;
		if(currentendwithval!="")
		{
			document.getElementById("alldayusercount["+(y+1)+"]").value = currentendwithval;
		}
	}
	cellrow++;
	var usrval="";
	var durval="";
	var alldaymode="SteadyLoad";
	j=j+1;
}	

function showDefaultTable()
{
	table=document.getElementById('alldaydetailsgecko');

	var rowcount= table.rows.length;

	if(rowcount==0)
	{
		callAddRow("1","");
	}
}

function calculateSamplePeriod()
{
	//var samCnt = document.getElementById("samplecount").value;
	//var tstdur = document.getElementById("testduration").value;
	//var samPer = Math.round(tstdur/samCnt);
	//document.getElementById("sampleperiod").value = samPer;
}

function disableStepFields(elem)
{
	table=document.getElementById('alldaydetailsgecko');
	var idarr =  new Array();
	cells = table.getElementsByTagName("select");
	for(i=0;i<cells.length;i++)
	{
		modeid = cells[i].id;
		modeval = cells[i].value;
		var ind = modeid.indexOf("alldaymode[");
		var ind1 = modeid.indexOf("]");
		newid = modeid.substring(ind+11,ind1);
		idarr[i] = newid;
	}
	for(y=0;y<idarr.length;y++)
	{
		ind=idarr[y];
		ind2 = idarr[y+1];
		currentmodeval =document.getElementById("alldaymode["+ind+"]").value;
		if(currentmodeval=="SteadyState")
		{
			document.getElementById("alldaysteps["+ind+"]").value = "";
			document.getElementById("alldaysteps["+ind+"]").readOnly = true;
			document.getElementById("foreveryduration["+ind+"]").value = "";

			document.getElementById("foreveryduration["+ind+"]").readOnly = true;
			document.getElementById("endswithusershid["+ind+"]").readOnly =false;
			//document.getElementById("endswithusershid["+ind+"]").value =""
			document.getElementById("endswithusershid["+ind+"]").readOnly =true;

		}
		else
		{
			document.getElementById("alldaysteps["+ind+"]").readOnly = false;
			//document.getElementById("alldaysteps["+ind+"]").value = "";
			document.getElementById("foreveryduration["+ind+"]").readOnly = false;
			//document.getElementById("foreveryduration["+ind+"]").value = "";

		}
		//document.getElementById("alldayusercount["+ind+"]").value = "";
	}	
}

function validatestepvalue(elem)
{
	rowindex = elem.parentNode.parentNode.rowIndex;
	selind = document.getElementById("alldaymode["+rowindex+"]").selectedIndex;
	selmode = document.getElementById("alldaymode["+rowindex+"]").options[selind].value;
	if(selmode=="Decrement")
	{
		decsteps = document.getElementById("alldaysteps["+rowindex+"]").value;
		decstartval = document.getElementById("alldayusercount["+rowindex+"]").value;
		if(parseInt(decsteps)>parseInt(decstartval))
		{
			alert("Decrement steps value cannot be greater than startwithusers");
			document.getElementById("alldaysteps["+rowindex+"]").value="";
		}
	}
}

function fillEndsWithUsers(elem)
{

	var table;
	var idarr =  new Array();
	table=document.getElementById('alldaydetailsgecko');

	cells = table.getElementsByTagName("select");
	for(i=0;i<cells.length;i++)
	{
		modeid = cells[i].id;
		modeval = cells[i].value;
		var ind = modeid.indexOf("alldaymode[");
		var ind1 = modeid.indexOf("]");
		newid = modeid.substring(ind+11,ind1);
		idarr[i] = newid;
	}
	for(y=0;y<idarr.length;y++)
	{
		ind=idarr[y];
		ind2 = idarr[y+1];
		currentmodeval =document.getElementById("alldaymode["+ind+"]").value;
		//alert("currentmodeval"+currentmodeval);
		if(currentmodeval=="SteadyLoad")
		{
			currentmodeval = "SteadyState";
		}
		else if(currentmodeval=="RampUp")
		{
			currentmodeval = "Increment";
		}
		else if(currentmodeval=="RampDown")
		{
			currentmodeval = "Decrement";
		}
		if(currentmodeval=="SteadyState")
		{ 
			startwithval = document.getElementById("alldayusercount["+ind+"]").value;
			document.getElementById("endswithusers["+ind+"]").innerHTML="<div style='width: 100px;'>" +startwithval+ "</div>";
			document.getElementById("endswithusershid["+ind+"]").value = startwithval;
		}
		else
		{
			startwithusers = document.getElementById("alldayusercount["+ind+"]").value;
			stepsduration = document.getElementById("foreveryduration["+ind+"]").value;
			totalduration = document.getElementById("alldayduration["+ind+"]").value;
			steps = document.getElementById("alldaysteps["+ind+"]").value;
			if(startwithusers=="" || stepsduration=="" || totalduration=="")
			{
				var emptyval ="";
				document.getElementById("endswithusers["+ind+"]").innerHTML="<div style='width: 100px;'>" +emptyval+ "</div>";
				document.getElementById("endswithusershid["+ind+"]").value = "";
			}
			else
			{

				var sample = totalduration/stepsduration;
				sample = parseInt(sample);
				var userval = sample*steps;
				if(currentmodeval=="Increment")
				{
					var endswithval = parseInt(userval)+parseInt(startwithusers);
					document.getElementById("endswithusers["+ind+"]").innerHTML="<div style='width: 100px;'>" +endswithval+ "</div>";
					document.getElementById("endswithusershid["+ind+"]").value = endswithval;
					if(ind2==undefined)
					{
					}
					else
					{
						document.getElementById("alldayusercount["+ind2+"]").value = endswithval;
					}
				}
				else if(currentmodeval=="Decrement")
				{
					var decendswithval = parseInt(startwithusers)-parseInt(userval);
					document.getElementById("endswithusers["+ind+"]").innerHTML="<div style='width: 100px;'>" +decendswithval+ "</div>";
					document.getElementById("endswithusershid["+ind+"]").value = decendswithval;
					if(ind2==undefined)
					{
					}
					else
					{
						document.getElementById("alldayusercount["+ind2+"]").value = decendswithval;
					}
				}
			}

		}

		currentendwithval=document.getElementById("endswithusers["+ind+"]").innerHTML;
		currentendwithval=document.getElementById("endswithusershid["+ind+"]").value;
		if(ind2==undefined)
		{
		}
		else
		{
			currentstartval = document.getElementById("alldayusercount["+ind2+"]").value;
			if(currentendwithval==currentstartval)
			{
			}
			else if(currentstartval=="")
			{
			}
			else
			{
				alert("startwith users value  should be equal to previous endwith users value");
				newstartwithval = document.getElementById("alldayusercount["+ind2+"]").value = currentendwithval;
			}
		}
	}//fory 		
	

}

function DeleteAllDayRow(elem)
{	
	rowindex = elem.parentNode.parentNode.rowIndex;
	table=document.getElementById('alldaydetailsgecko');

	var rowval = table.rows.length;

	if(rowval=="1")
	{
		alert("Atleast one row should be present");
		return 0;
	}

	table.deleteRow(rowindex);
	rowcount =table.rows.length;
	alldayrowcount=rowcount-1;
	var usrval="";
	var durval="";
	var alldaymode="SteadyLoad";
}

// Modem Simulation functions starts
function showModemSimDiv(event)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	hideAllDiv();
	msdiv = document.getElementById("modem-sim-div");
	var xPos = Math.floor(event.clientX);
	var yPos = Math.floor(event.clientY);
	msdiv.style.left=(xPos-35)+"px";	
	msdiv.style.top=(yPos-150)+"px";
	msfrm = document.getElementById("modemsimframe");
	suitename = document.getElementById("suitename").value;
	loadtest = document.getElementById("ltname").value;
	msfrm.src="/webload/jsp/WLModemSimulation.jsp?suitename="+suitename+"&loadtest="+loadtest;
	eval("msdiv.style.display = 'block';");
}

function hideModemSimulationDiv()
{
	msdiv = document.getElementById("modem-sim-div");
	eval("msdiv.style.display = 'none';");
}

function saveModemSimulation()
{
	if(!checkPrivilege(true))
	{
		return false;
	}
	window.modemsimframe.submitForm();
	hideModemSimulationDiv();
}

function handleTestCaseSave()
{
	if(http.readyState == 4)
	{
		hideAllDiv();
	}
}

function hideAllDiv()
{
	hideExitCriteriaDiv();
	hideModemSimulationDiv();
	hideServMonDiv();
	hideDbMonDiv();
	hideTransDetailsDiv();
	hideParameterizeDiv();
	hideAddTrans();
	hideinstalltoolbardiv();
}

// Modem Simulation function ends

// Server Monitoring function starts

function showServMonDiv(event)
{
	if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	hideAllDiv();
	smdiv = document.getElementById("server-mon-div");
	var xPos = Math.floor(event.clientX);
	var yPos = Math.floor(event.clientY);
	smdiv.style.left=60+"px";		
	smdiv.style.top=yPos-380+"px";
	
	smfrm = document.getElementById("servmonframe");
	smfrm.height="400px";	
	smfrm.width="600px";
	suitename = document.getElementById("suitename").value;
	loadtest = document.getElementById("ltname").value;
	smfrm.src = "/webload/jsp/LoadTestServerMonitors.jsp?suitename="+suitename+"&loadtest="+loadtest;
	
	eval("smdiv.style.display = 'block';");
}

function hideServMonDiv()
{
	smdiv = document.getElementById("server-mon-div");
	eval("smdiv.style.display = 'none';");
}

function saveServerMonitorDetails()
{
	window.servmonframe.saveServerMonitorDetails();
	hideServMonDiv();
}

function showDescriptionDiv(event)
{
	mdiv = document.getElementById("descriptiondiv");
	var xPos = Math.floor(event.clientX);
	var yPos = Math.floor(event.clientY);
	
	mdiv.style.left=xPos-380+"px";		
	mdiv.style.top=yPos-100+"px";
	mdiv.style.display="block";
}

function hideDescriptionDiv()
{
	document.getElementById("descriptiondiv").style.display="none";
}
// server monitor functions ends here

// DB Monitor functions starts here

function saveDBMonitorDetails()
{
	window.dbmonframe.saveDBMonitorDetails();
	hideDbMonDiv();
}

function showDBMonDiv(event)
{
if(parent.recordMode)
	{
		alert("Please stop recording and then continue");
		return false;
	}
	else if(parent.playMode)
	{
		alert("Please stop the play and then continue");
		return false;
	}
	hideAllDiv();
	dbmdiv = document.getElementById("db-mon-div");
	var xPos = Math.floor(event.clientX);
	var yPos = Math.floor(event.clientY);
	dbmdiv.style.left=60+"px";	
	dbmdiv.style.top=yPos-380+"px";

	dbfrm = document.getElementById("dbmonframe");
	dbfrm.height="400px";	
	dbfrm.width="600px";
	suitename = document.getElementById("suitename").value;
	loadtest = document.getElementById("ltname").value;
	dbfrm.src = "/webload/jsp/LoadTestDBMonitors.jsp?suitename="+suitename+"&loadtest="+loadtest;
	
	eval("dbmdiv.style.display = 'block';");
}

function hideDbMonDiv()
{
	dbmdiv = document.getElementById("db-mon-div");
	eval("dbmdiv.style.display = 'none';");
}


// DB Monitor functions ends here

// Exit criteria functions start here

function showExitCriteriaDiv()
{
	hideAllDiv();
	var ecfrm = document.getElementById("exitcriteriaframe");
	suitename = document.getElementById("suitename").value;
	encwlpath = document.getElementById("ltencworkloadpath").value;
	ecfrm.src = "/webload/jsp/ExitCriteriaConfiguration.jsp?suitename="+suitename+"&workloadpath="+encwlpath;

	if(isIE)
	{
		ecfrm.width="700";
		ecfrm.height="160";
	}
	else
	{
		ecfrm.width="650";
		ecfrm.height="90%";
	}
	
	ecdiv = document.getElementById("exitcriteriadiv");
	eval("ecdiv.style.display = 'block';");
}

function hideExitCriteriaDiv()
{
	ecdiv = document.getElementById("exitcriteriadiv");
	eval("ecdiv.style.display = 'none';");
}

function saveExitCriteria()
{
	window.exitcriteriaframe.saveConfiguration();
}

function enableExitCriteriaOptions()
{
	if(document.getElementById("exitservcrash").checked == true)
	{
	}	
	
	if(document.getElementById("exittestdurexceed").checked == true)
	{
		document.getElementById("testdurationexceed").disabled=false;
		//document.getElementById("testdurationexceed").value=60;
	}
	else
	{
		document.getElementById("testdurationexceed").disabled=true;
	}	

	if(document.getElementById("resptimelessthan").checked == true)
	{
		document.getElementById("resptimecol").className="";
		document.getElementById("percenttimecol").className="";
		document.getElementById("resptime1col").className="";
		
	}
	else
	{
		document.getElementById("resptimecol").className="hide";
		document.getElementById("percenttimecol").className="hide";
		document.getElementById("resptime1col").className="hide";
		
	}

	if(document.getElementById("exitcpu").checked == true)
	{
		document.getElementById("servercombo").disabled=false;
		document.getElementById("cpupercent").disabled=false;
	}
	else
	{
		document.getElementById("servercombo").disabled=true;
		document.getElementById("cpupercent").disabled=true;
	}
}

function callServerMonitor()
{
	openWindow('/webload/jsp/WLServerMonitorScreen.jsp','ServerMonitor','600','350');   	
}

function fillMaxTime()
{
	var mintime=document.getElementById("percenttime").value;
	var maxtime = 100-mintime;
	document.getElementById("percenttime1").value=maxtime;
}

function fillServerMonitors()
{
	http = getHTTPObject();
	sname = document.getElementById("suitename").value;
	var url = "/webload/jsp/WLTransactionUtil.jsp?suitename="+sname+"&method=getservermonitors";
	http.open("GET", url, true);
	http.onreadystatechange = fillMonitors;
	http.send(null);
}

function fillMonitors()
{
	if(http.readyState == 4)
	{
		var message = http.responseText;
		if(message.indexOf("[MONITORS]")!=-1)
		{
			trIndex = message.indexOf("[MONITORS]");
			trIndex = trIndex+10;

			etrIndex = message.indexOf("[/MONITORS]");

			monitors = message.substring(trIndex,etrIndex);
			monitorArr = monitors.split(":_QESEP_:");
			servMonCombo = document.getElementById("servercombo");
			defaultState = false;
			if(servMonCombo.disabled)
			{
				defaultState = true;
				servMonCombo.disabled = false;
			}
			servMonCombo.options.length=0;
			for(m=0;m<monitorArr.length;m++)
			{
				mon = monitorArr[m]
				if(mon=="")
				{
					continue;
				}
				
				option = document.createElement("OPTION");
				option.value = mon;
				option.text =mon;	
				option.id = "servmon_"+mon;
				if(isIE)
				{
					servMonCombo.add(option,m);
				}
				if(isGecko)
				{
					servMonCombo.add(option,null);
				}
				if(m==0)
				{
				       option.selected=true;
				}
			}
			if(defaultState)
			{
				servMonCombo.disabled = true;
			}
		}
	}
	
}

// End of Exit criteria functions

function isValid(val)
{
	if(val.length > 0 && !val.match(/^[0-9]+$/g))
	{
		return false;
	}
	else if(val.length ==0)
	{
		return false;
	}

	if(parseInt(val)<1)
	{
		return false;
	}
		
	return true;
}

var errorInt;
function showStatusDiv()
{
	document.getElementById("alerttable").className = "alertbox";
	lAlign = (document.body.offsetWidth)/4;
	divElem = document.getElementById("alert");
	divElem.style.left = lAlign+"px";
	if(isIE)
	{
		insertDynamicFrame(divElem,lAlign+"","230",296,60);
	}
	eval("divElem.style.display = 'block';");
	errorInt = setInterval("hideErrorDiv()",2*1000);
}

function hideErrorDiv()
{	if(isIE)
	{
		removeDynamicFrame();
	}
	clearInterval(errorInt);
	divElem = document.getElementById("alert");
	eval("divElem.style.display = 'none';");
	
}

function checkForAllowedVUCount(ucount)
{
	lic_user_count = document.getElementById("lic_uc").value;
	lic_user_type = document.getElementById("lic_ut").value;
	lic_category = document.getElementById("lic_cat").value;

	errMessage = "";
	licensError = false;
	if(lic_user_count == -1)
	{
		licensError = false;
	}
	else if(parseInt(ucount) > parseInt(lic_user_count))
	{
		licensError = true;
		if(lic_user_type == "F")
		{
			errMessage = "Configured usercount exceeds the license limit.<br> Free version will support maximum of 5 virtual users.";
		}
		else if(lic_user_type == "T")
		{
			errMessage = "Configured usercount exceeds the license limit.<br> Trial version will support maximum of 25 virtual users.";
		}
		else if(lic_user_type == "R")
		{
			errMessage = "Configured usercount exceeds license limit.<br> Number of virtual user allowed is "+lic_user_count+".";
		}
		else if(lic_category == "DEMO" || lic_category == "Demo")
		{
			errMessage = "Configured usercount exceeds the license limit.<br> Demo version will support 3 virtual users.";
		}

		showStatusDiv();
		document.getElementById("save_status").innerHTML = errMessage;
	}

	return licensError;
}

function checkForIterationCount(itrcount)
{
	lic_user_type = document.getElementById("lic_ut").value;
	errMessage = "";
	licensError = false;


	if(lic_user_type == "F")
	{
		if(parseInt(itrcount) > parseInt("1"))
		{
			errMessage = "Configured iterations exceeds the license limit.<br> Free version will support maximum of 1 Iterations.";
		}
	}
	else if(lic_user_type == "T")
	{
		if(parseInt(itrcount) > parseInt("5"))
		{
			errMessage = "Configured iterations exceeds the license limit.<br> Trial version will support maximum of 5 Iterations.";
		}
	}
	else if(lic_user_type == "R")
	{
	}
	else if(lic_category == "DEMO" || lic_category == "Demo")
	{
		if(parseInt(itrcount) > parseInt("5"))
		{
			errMessage = "Configured iterations exceeds the license limit.<br> Demo version will support maximum of 5 Iterations.";
		}
	}
	if(errMessage=="")
	{
		licensError = false;
	}
	else
	{
		licensError = true;
		showStatusDiv();
		document.getElementById("save_status").innerHTML = errMessage;
	}

	return licensError;
}

function checkForTime(time)
{
	lic_user_type = document.getElementById("lic_ut").value;

	errMessage = "";
	licensError = false;


	if(lic_user_type == "F")
	{
			errMessage = "Free version does not support time-based testing.";
	}
	else if(lic_user_type == "T")
	{
		if(parseInt(time) > parseInt(5* 60 * 60))
		{
			errMessage = "Configured time exceeds the license limit.<br> Trial version will support maximum of 5 hours.";
		}
	}
	else if(lic_user_type == "R")
	{
	}
	else if(lic_category == "DEMO" || lic_category == "Demo")
	{
		if(parseInt(itrcount) > parseInt(1 * 60 * 60))
		{
			errMessage = "Configured time exceeds the license limit.<br> Demo version will support maximum of 1 hour.";
		}
	}
	if(errMessage=="")
	{
		licensError = false;
	}
	else
	{
		licensError = true;
		showStatusDiv();
		document.getElementById("save_status").innerHTML = errMessage;
	}

	return licensError;
}


function validateLoadTest(evt)
{
	

	if(document.getElementById("savemode").value=="execute" && !hasToolbar())
	{
		document.getElementById("savemode").value = "";
		showinstalltoolbardiv(x,y);
		return false;
	}
	//checking for user privilege
	if(!checkPrivilege(true))
	{
		if(document.getElementById("savemode").value=="execute")
		{
			document.getElementById("save_status").innerHTML = "Starting test execution...";
			document.getElementById("savemode").value = "";
			executeTimer = setInterval("executeLoadFromUI()",1000);
		}
		return false;
	}
	//end of checking user privilege
	var formsubmit = true;
	var errHighlight = "*";
	var minusercount = -1;
	var maxusercount = -1;
	var userField;
	var uerrid = "";

	// checking for no of transaction created for loadtest
	var noOfTransaction = 0;
	loadTransactions = document.getElementById("lttransactions").value;
	if(loadTransactions == "")
	{
		showStatusDiv();
		document.getElementById("save_status").innerHTML = "You need to add a Transaction to run a Load Test.";
		document.getElementById("savemode").value = "";
		return false;
	}
	else
	{
		totalPercentage = 0;
		transArr = loadTransactions.split(":_QESEP_:");
		noOfTransaction = transArr.length;
		for(k=0;k<transArr.length;k++)
		{
			trans = transArr[k];
			transPercentCombo = document.getElementById("prof_percentage_"+trans);
			transPercent = transPercentCombo.options[transPercentCombo.selectedIndex].value;
			totalPercentage = totalPercentage+parseInt(transPercent);
		}
		
		if(totalPercentage!=100)
		{
			showStatusDiv();
			document.getElementById("save_status").innerHTML = "Load not distributed properly.";
			for(k=0;k<transArr.length;k++)
			{
				trans = transArr[k];
				elem = document.getElementById(trans+"_percenterr");
				elem.innerHTML = errHighlight;
			}
			document.getElementById("savemode").value = "";
			return false;
		}

	}
	// end of transaction check

	
	// checking for workload details configured
	if(document.getElementById("normalrad").checked)
	{
		uc = document.getElementById("usercount").value;
		userField = document.getElementById("usercount");
		uerrid = "norucerr"; 
		noOfTimes = document.getElementById("samplecount").value;
		//duration = document.getElementById("testduration").value;
		if(!isValid(uc))
		{
			document.getElementById("usercount").value = "";
			document.getElementById("usercount").focus();
			formsubmit = false;
			document.getElementById("norucerr").innerHTML = errHighlight;
		}
		else if(checkForAllowedVUCount(uc))
		{
			document.getElementById("norucerr").innerHTML = errHighlight;
			document.getElementById("savemode").value = "";
			return false;
		}
		else
		{
			if(document.getElementById("iterationbased").checked==true)
			{
				if(!isValid(document.getElementById("samplecount").value))
				{
					document.getElementById("samplecount").value = "";
					document.getElementById("samplecount").focus();
					formsubmit = false;
					document.getElementById("norscerr").innerHTML = errHighlight;
				}

				if(formsubmit && checkForIterationCount(document.getElementById("samplecount").value))
				{
					document.getElementById("samplecount").value = "";
					document.getElementById("samplecount").focus();
					formsubmit = false;
					document.getElementById("norscerr").innerHTML = errHighlight;
					return false;
				}
			}
			else 
			{
				var t = document.getElementById("sampleperiod").value;
				var v = document.getElementById("testmodetime").options[document.getElementById("testmodetime").selectedIndex].value;
				if(v=="Minutes")
				{
					t = t * 60;
				}
				else if(v=="Hours")
				{
					t= t * 60 * 60;
				}
				else if(v=="Days")
				{
					t= t * 24 * 60 * 60;
				}
				if(!isValid(t))
				{
					document.getElementById("sampleperiod").value = "";
					document.getElementById("sampleperiod").focus();
					formsubmit = false;
					document.getElementById("norsperr").innerHTML = errHighlight;
				}

				if(formsubmit && checkForTime(t))
				{
					document.getElementById("sampleperiod").value = "";
					document.getElementById("sampleperiod").focus();
					formsubmit = false;
					document.getElementById("norsperr").innerHTML = errHighlight;
					return false;
				}
			}
		}

		if(!isValid(noOfTimes))
		{
			document.getElementById("samplecount").value = "";
			document.getElementById("samplecount").focus();
			formsubmit = false;
			document.getElementById("norscerr").innerHTML = errHighlight;
		}

		//if(!isValid(duration))
		//{
			//document.getElementById("testduration").value = "";
		//	document.getElementById("testduration").focus();
		//	formsubmit = false;
		//	document.getElementById("nordurerr").innerHTML = errHighlight;
		//}

		if(formsubmit)
		{
			minusercount = uc;
			calculateSamplePeriod();
		}
	}
	else if(document.getElementById("rurad").checked)
	{
		ruusers = document.getElementById("users").value;
		userField = document.getElementById("users");
		uerrid = "ruusererr"; 
		incuser = document.getElementById("increment").value;
		incfreq = document.getElementById("time").value;
		rulimit = document.getElementById("limit").value;
		iteration = document.getElementById("ruiteration").value;

		if(!isValid(ruusers))
		{
			document.getElementById("users").value = "";
			document.getElementById("users").focus();
			formsubmit = false;
			document.getElementById("ruusererr").innerHTML = errHighlight;
		}

		if(!isValid(incuser))
		{
			document.getElementById("increment").value = "";
			document.getElementById("increment").focus();
			formsubmit = false;
			document.getElementById("ruincerr").innerHTML = errHighlight;
		}

		if(!isValid(incfreq))
		{
			document.getElementById("time").value = "";
			document.getElementById("time").focus();
			formsubmit = false;
			document.getElementById("rutimeerr").innerHTML = errHighlight;
		}

		if(!isValid(rulimit))
		{
			document.getElementById("limit").value = "";
			document.getElementById("limit").focus();
			formsubmit = false;
			document.getElementById("rulterr").innerHTML = errHighlight;
		}
		else if(checkForAllowedVUCount(rulimit))
		{
			document.getElementById("rulterr").innerHTML = errHighlight;
			document.getElementById("savemode").value = "";
			return false;
		}

		if(formsubmit)
		{
			if(parseInt(ruusers) > parseInt(rulimit))
			{
				showStatusDiv();
				document.getElementById("save_status").innerHTML = "Limit to user cannot be less than number of starting user for ramp up.";
				document.getElementById("ruusererr").innerHTML = errHighlight;
				document.getElementById("rulterr").innerHTML = errHighlight;
				document.getElementById("savemode").value = "";
				return false;
			}
		}

		if(!isValid(iteration))
		{
			document.getElementById("ruiteration").value = "";
			document.getElementById("ruiteration").focus();
			formsubmit = false;
			document.getElementById("runterr").innerHTML = errHighlight;
		}

		if(document.getElementById("rampupmodeItr").checked==true)
		{
				if(!isValid(iteration))
				{
					document.getElementById("ruiteration").value = "";
					document.getElementById("ruiteration").focus();
					formsubmit = false;
					document.getElementById("runterr").innerHTML = errHighlight;
				}

				if(formsubmit && checkForIterationCount(iteration))
				{
					document.getElementById("ruiteration").value = "";
					document.getElementById("ruiteration").focus();
					formsubmit = false;
					document.getElementById("runterr").innerHTML = errHighlight;
					return false;
				}
			}

		if(formsubmit)
		{
			minusercount = ruusers;
		}
		
	}
	else if(document.getElementById("rdrad").checked)
	{
		rdusers = document.getElementById("rampdownusers").value;
		decuser = document.getElementById("decrement").value;
		decfreq = document.getElementById("decrementtime").value;
		rdlimit = document.getElementById("limitTo").value;
		userField = document.getElementById("limitTo");
		uerrid = "rdlterr"; 
		iteration = document.getElementById("rditeration").value;

		if(!isValid(rdusers))
		{
			document.getElementById("rampdownusers").value = "";
			document.getElementById("rampdownusers").focus();
			formsubmit = false;
			document.getElementById("rdusererr").innerHTML = errHighlight;
		}

		if(!isValid(decuser))
		{
			document.getElementById("decrement").value = "";
			document.getElementById("decrement").focus();
			formsubmit = false;
			document.getElementById("rddecerr").innerHTML = errHighlight;
		}

		if(!isValid(decfreq))
		{
			document.getElementById("decrementtime").value = "";
			document.getElementById("decrementtime").focus();
			formsubmit = false;
			document.getElementById("rdtimeerr").innerHTML = errHighlight;
		}

		if(!isValid(rdlimit))
		{
			document.getElementById("limitTo").value = "";
			document.getElementById("limitTo").focus();
			formsubmit = false;
			document.getElementById("rdlterr").innerHTML = errHighlight;
		}
		else if(checkForAllowedVUCount(rdusers))
		{
			document.getElementById("rdlterr").innerHTML = errHighlight;
			document.getElementById("savemode").value = "";
			return false;
		}

		if(formsubmit)
		{
			if(parseInt(rdlimit) > parseInt(rdusers))
			{
				showStatusDiv();
				document.getElementById("save_status").innerHTML = "Limit to user cannot be more than number of starting user for ramp down.";
				document.getElementById("rdusererr").innerHTML = errHighlight;
				document.getElementById("rdlterr").innerHTML = errHighlight;
				document.getElementById("savemode").value = "";
				return false;
			}
		}

		if(!isValid(iteration))
		{
			document.getElementById("rditeration").value = "";
			document.getElementById("rditeration").focus();
			formsubmit = false;
			document.getElementById("rdnterr").innerHTML = errHighlight;
		}

		if(document.getElementById("rampdownmodeItr").checked==true)
		{
				if(!isValid(iteration))
				{
					document.getElementById("rditeration").value = "";
					document.getElementById("rditeration").focus();
					formsubmit = false;
					document.getElementById("rdnterr").innerHTML = errHighlight;
				}

				if(formsubmit && checkForIterationCount(iteration))
				{
					document.getElementById("rditeration").value = "";
					document.getElementById("rditeration").focus();
					formsubmit = false;
					document.getElementById("rdnterr").innerHTML = errHighlight;
					return false;
				}
			}


		if(formsubmit)
		{
			minusercount = rdlimit;
		}
	}
	else if(document.getElementById("burninrad").checked)
	{
		durationInterval = document.getElementById("testdurationexceed").value ;
		biusers = document.getElementById("burninusercount").value;
		userField = document.getElementById("burninusercount");
		uerrid = "biusererr"; 
		iteration = document.getElementById("biiteration").value;
		if(!isValid(biusers))
		{
			document.getElementById("burninusercount").value = "";
			document.getElementById("burninusercount").focus();
			formsubmit = false;
			document.getElementById("biusererr").innerHTML = errHighlight;
		}
		else if(checkForAllowedVUCount(biusers))
		{
			document.getElementById("biusererr").innerHTML = errHighlight;
			document.getElementById("savemode").value = "";
			return false;
		}

		exitCriteriaSelection = false;

		if(document.getElementById("exitservcrash").checked)
		{
			exitCriteriaSelection = true;
		}

		if(document.getElementById("exittestdurexceed").checked)
		{
			exitCriteriaSelection = true;
			exittime = document.getElementById("testdurationexceed").value;
			if(!isValid(exittime))
			{
				document.getElementById("testdurationexceed").value="";
				document.getElementById("testdurationexceed").focus();
				formsubmit = false;
				document.getElementById("exittimeerr").innerHTML = errHighlight;
			}
			if(exittime < 10)
			{
				showStatusDiv();
				document.getElementById("save_status").innerHTML = "Please configure the Exit Criteria Test Duration interval value above 10" ;
				document.getElementById("testdurationexceed").focus();
				document.getElementById("testdurationexceed").select();
				return false;
			}
		}
		
		if(document.getElementById("resptimelessthan").checked)
		{
			exitCriteriaSelection = true;
			rtime = document.getElementById("resptime").value;
			ptime = document.getElementById("percenttime").value;
			rtime1 = document.getElementById("resptime1").value;
			ptime1 = document.getElementById("percenttime1").value;

			if(!isValid(rtime))
			{
				document.getElementById("resptime").value = "";
				document.getElementById("resptime").focus();
				formsubmit = false;
				document.getElementById("rtimeerr").innerHTML = errHighlight;
			}

			if(!isValid(ptime))
			{
				document.getElementById("percenttime").value = "";
				document.getElementById("percenttime").focus();
				formsubmit = false;
				document.getElementById("ptimeerr").innerHTML = errHighlight;
			}

			if(!isValid(rtime1))
			{
				document.getElementById("resptime1").value = "";
				document.getElementById("resptime1").focus();
				formsubmit = false;
				document.getElementById("rtimeerr1").innerHTML = errHighlight;
			}

			if(!isValid(ptime1))
			{
				document.getElementById("percenttime1").value = "";
				document.getElementById("percenttime1").focus();
				formsubmit = false;
				document.getElementById("ptimeerr1").innerHTML = errHighlight;
			}
		}

		noservmon = false;
		if(document.getElementById("exitcpu").checked)
		{
			exitCriteriaSelection = true;
			if(document.getElementById("servercombo").options.length==0)
			{
				document.getElementById("scerr").innerHTML = errHighlight;
				formsubmit = false;
				noservmon = true;
			}

			pcpu = document.getElementById("cpupercent").value;
			if(!isValid(pcpu))
			{
				document.getElementById("cpupercent").value = "";
				document.getElementById("cpupercent").focus();
				formsubmit = false;
				document.getElementById("pcpuerr").innerHTML = errHighlight;
			}
		}

		if(!exitCriteriaSelection)
		{
			showStatusDiv();
			document.getElementById("save_status").innerHTML = "Please configure any of the exit criteria.";
			document.getElementById("savemode").value = "";
			return false;
		}

		if(exitCriteriaSelection && noservmon)
		{
			showStatusDiv();
			document.getElementById("save_status").innerHTML = "No Server Monitors configured.";
			document.getElementById("savemode").value = "";
			return false;
		}

		if(!isValid(iteration))
		{
			document.getElementById("biiteration").value = "";
			document.getElementById("biiteration").focus();
			formsubmit = false;
			document.getElementById("binterr").innerHTML = errHighlight;
		}

		if(document.getElementById("burninmodeItr").checked==true)
		{
				if(!isValid(iteration))
				{
					document.getElementById("biiteration").value = "";
					document.getElementById("biiteration").focus();
					formsubmit = false;
					document.getElementById("binterr").innerHTML = errHighlight;
				}

				if(formsubmit && checkForIterationCount(iteration))
				{
					document.getElementById("biiteration").value = "";
					document.getElementById("biiteration").focus();
					formsubmit = false;
					document.getElementById("binterr").innerHTML = errHighlight;
					return false;
				}
			}

		if(formsubmit)
		{
			minusercount = biusers;
		}
		
	}
	else if(document.getElementById("mlrad").checked)
	{
		alldaytable = document.getElementById("alldaydetailsgecko");
		noOfrows = alldaytable.rows.length;
		document.getElementById("alldayrows").value=noOfrows;
		if(noOfrows == 0)
		{
			showStatusDiv();
			document.getElementById("save_status").innerHTML = "Configure Load values for Mixed Load.";
			document.getElementById("savemode").value = "";
			return false;
		}
		else
		{
			for(l=0;l<noOfrows;l++)
			{
				mlmodecombo = document.getElementById("alldaymode["+l+"]");
				mlmode = mlmodecombo.options[mlmodecombo.selectedIndex].value;
				user = document.getElementById("alldayusercount["+l+"]").value;
				duration = document.getElementById("alldayduration["+l+"]").value;
				if(!isValid(user))
				{
					document.getElementById("alldayusercount["+l+"]").value="";
					document.getElementById("alldayusercount["+l+"]").focus();
					formsubmit = false;
					document.getElementById("aducerr["+l+"]").innerHTML= errHighlight;
				}
				
				if(!isValid(duration))
				{
					document.getElementById("alldayduration["+l+"]").value="";
					document.getElementById("alldayduration["+l+"]").focus();
					formsubmit = false;
					document.getElementById("adadurerr["+l+"]").innerHTML= errHighlight;
				}
				
				if(mlmode == "SteadState")
				{
				}
				else if(mlmode == "Increment" || mlmode == "Decrement")
				{
					step = document.getElementById("alldaysteps["+l+"]").value;
					freq = document.getElementById("foreveryduration["+l+"]").value;

					if(!isValid(step))
					{
						document.getElementById("alldaysteps["+l+"]").value = "";
						document.getElementById("alldaysteps["+l+"]").focus();
						formsubmit = false;
						document.getElementById("adsteperr["+l+"]").innerHTML = errHighlight;
					}

					if(!isValid(freq))
					{
						document.getElementById("foreveryduration["+l+"]").value = "";
						document.getElementById("foreveryduration["+l+"]").focus();
						formsubmit = false;
						document.getElementById("adfdurerr["+l+"]").innerHTML = errHighlight;
					}
				}
				if(formsubmit)
				{
					var temp = document.getElementById("endswithusershid["+l+"]").value;
					if(minusercount == -1)
					{
						minusercount = parseInt(temp);
						userField = document.getElementById("alldayusercount["+l+"]");
						uerrid = "aducerr["+l+"]"; 
					}
					else if(minusercount>parseInt(temp))
					{
						minusercount = parseInt(temp);
						userField = document.getElementById("alldayusercount["+l+"]");
						uerrid = "aducerr["+l+"]"; 
					}

					var temp1 = document.getElementById("alldayusercount["+l+"]");
					var muser = parseInt(temp);
					if(parseInt(temp1) > muser)
					{
						muser = parseInt(temp1);
					}

					if(maxusercount == -1)
					{
						maxusercount = muser;
					}
					else if(parseInt(temp) > maxusercount)
					{
						maxusercount = muser;
					}
				}
			}
			if(checkForAllowedVUCount(maxusercount))
			{
				document.getElementById("savemode").value = "";
				return false;
			}
		}
		iteration = document.getElementById("mliteration").value;
		
		if(!isValid(iteration))
		{
			document.getElementById("mliteration").value = "";
			document.getElementById("mliteration").focus();
			formsubmit = false;
			document.getElementById("mlnterr").innerHTML = errHighlight;
		}
		if(document.getElementById("alldaymodeItr").checked==true)
		{
				if(!isValid(iteration))
				{
					document.getElementById("mliteration").value = "";
					document.getElementById("mliteration").focus();
					formsubmit = false;
					document.getElementById("mlnterr").innerHTML = errHighlight;
				}

				if(formsubmit && checkForIterationCount(iteration))
				{
					document.getElementById("mliteration").value = "";
					document.getElementById("mliteration").focus();
					formsubmit = false;
					document.getElementById("mlnterr").innerHTML = errHighlight;
					return false;
				}
			}
	}
	// End of workload checking 
	

	if(!formsubmit)
	{
		showStatusDiv();
		document.getElementById("save_status").innerHTML = "Please fill in data for fields marked *";
		document.getElementById("savemode").value = "";
		return false;
	}

	

	// check for no of user configured
	if(minusercount<noOfTransaction)
	{
		showStatusDiv();
		document.getElementById("save_status").innerHTML = "Mininmum number of users needs to be configured is "+noOfTransaction+".";
		document.getElementById("savemode").value = "";
		userField.value = "";
		userField.focus();
		document.getElementById(uerrid).innerHTML = errHighlight;
		return false;
	}
	// end of no of user check

	return true;
}

function handleKeyPress(e)
{
	var KeyID = (window.event) ? event.keyCode : e.keyCode;
	if(KeyID == 27)
	{
		hideAllDiv();
	}
	else if(KeyID == 13)
	{
		if(document.getElementById("addtrans").style.display=='block')
		{
			createNewTransaction(e);
		}
		else if(document.getElementById("renamediv").style.display=='block')
		{
			renameTransaction();
		}
	}
}
